#include <math.h>
#include <array>
#include <algorithm>

#include "picosystem.hpp"

using namespace picosystem;

extern const color_t _parrot_image[14400];
buffer_t parrot = {.w = 120, .h = 120, .data = (color_t *)_parrot_image};

// initialise the world
void init() {
}

// process user input and update the world state
void update(uint32_t tick) {
/*  if(pressed(UP)) {
    blend_mode = blend_mode == 0 ? blend_modes.size() - 1 : blend_mode - 1;
  }

  if(pressed(DOWN)) {
    blend_mode = blend_mode == blend_modes.size() - 1 ? 0 : blend_mode + 1;
  }*/
}

// draw the world
void draw(uint32_t tick) {
  blend(COPY);

  pen(5, 6, 7);
  clear();

  blit(SPRITESHEET, 0, 0, 16, 16, 10, 10);
  blit(SPRITESHEET, 0, 0, 16, 16, 35, 10, HFLIP);
  blit(SPRITESHEET, 0, 0, 16, 16, 60, 10, VFLIP);
  blit(SPRITESHEET, 0, 0, 16, 16, 85, 10, VFLIP | HFLIP);

  blit(SPRITESHEET, 0, 0, 16, 16, 10, 40, 20, 20);
  blit(SPRITESHEET, 0, 0, 16, 16, 35, 40, 20, 20, HFLIP);
  blit(SPRITESHEET, 0, 0, 16, 16, 60, 40, 20, 20, VFLIP);
  blit(SPRITESHEET, 0, 0, 16, 16, 85, 40, 20, 20, VFLIP | HFLIP);

  blend(ALPHA);
  pen(15, 0, 0, 8);
  /*rect(10, 10, 16, 16);
  rect(35, 10, 16, 16);
  rect(60, 10, 16, 16);
  rect(85, 10, 16, 16);

  rect(10, 40, 20, 20);
  rect(35, 40, 20, 20);
  rect(60, 40, 20, 20);
  rect(85, 40, 20, 20);*/

}

const color_t _parrot_image[14400] = {
  0x56f9, 0x45f8, 0x45f8, 0x45f8, 0x45f8, 0x45f8, 0x45f8, 0x45f8,
  0x45f8, 0x45f9, 0x45f9, 0x46f9, 0x56f9, 0x56f9, 0x56fa, 0x67fa,
  0x67fa, 0x77fa, 0x78fb, 0x88fb, 0x88fb, 0x89fb, 0x99fb, 0x99fb,
  0x99fb, 0x99fc, 0x99fc, 0xaafc, 0xaafc, 0xaafc, 0xaafc, 0xaafc,
  0xaafc, 0xaafc, 0xaafc, 0xbafc, 0xbbfc, 0xbbfc, 0xbbfd, 0xbbfd,
  0xbbfd, 0xbbfd, 0xbbfc, 0xbbfc, 0xbbfc, 0xbbfc, 0xbbfc, 0xbbfc,
  0xbbfc, 0xbbfc, 0xbcfc, 0xbcfc, 0xbcfc, 0xccfc, 0xccfc, 0xccfc,
  0xccfc, 0xccfc, 0xbcfc, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb,
  0xbcfb, 0xbcfb, 0xbcfa, 0xbcfa, 0xbcfa, 0xacfa, 0xacfa, 0xabfa,
  0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfb,
  0xabfb, 0xabfb, 0xabfb, 0xbbfb, 0xbbfb, 0xbcfb, 0xbcfb, 0xbcfb,
  0xbcfb, 0xbcfb, 0xccfb, 0xccfb, 0xccfb, 0xccfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfc, 0xddfc, 0xddfc, 0xddfc, 0xddfc,
  0xddfc, 0xddfc, 0xddfc, 0xddfc, 0xddfc, 0xddfc, 0xddfc, 0xddfb,
  0xddfc, 0xddfc, 0xcdfc, 0xcdfc, 0xcdfc, 0xcdfc, 0xcdfc, 0xddfc,
  0x34f8, 0x34f8, 0x34f8, 0x34f8, 0x34f8, 0x34f8, 0x34f8, 0x34f8,
  0x34f8, 0x34f8, 0x35f8, 0x45f8, 0x45f9, 0x45f9, 0x55f9, 0x56fa,
  0x66fa, 0x67fa, 0x77fa, 0x78fb, 0x88fb, 0x88fb, 0x88fb, 0x89fb,
  0x99fb, 0x99fb, 0x99fc, 0x99fc, 0x99fc, 0xa9fc, 0xa9fc, 0xaafc,
  0xaafc, 0xaafc, 0xaafc, 0xaafc, 0xaafc, 0xaafc, 0xbafc, 0xbafc,
  0xaafc, 0xaafc, 0xaafc, 0xaafc, 0xaafc, 0xbafc, 0xbbfc, 0xbbfc,
  0xbbfc, 0xbbfc, 0xbbfc, 0xbcfc, 0xbcfc, 0xbcfc, 0xbcfc, 0xbcfc,
  0xbcfc, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb,
  0xbcfa, 0xacfa, 0xacfa, 0xacfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa,
  0xabfa, 0x9afa, 0x9afa, 0x9afa, 0x9afa, 0x9afa, 0x9afa, 0xaafa,
  0xaafa, 0xaafa, 0xabfa, 0xabfa, 0xabfb, 0xbbfb, 0xbcfb, 0xbcfb,
  0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xccfb, 0xccfb, 0xccfb, 0xccfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0x35f8, 0x34f8, 0x34f8, 0x24f8, 0x24f8, 0x24f8, 0x24f8, 0x24f8,
  0x34f8, 0x34f8, 0x34f8, 0x45f8, 0x45f9, 0x45f9, 0x55f9, 0x56fa,
  0x66fa, 0x67fa, 0x77fa, 0x78fb, 0x88fb, 0x88fb, 0x88fb, 0x99fb,
  0x99fb, 0x99fc, 0x99fb, 0x99fb, 0x99fc, 0xa9fc, 0xaafc, 0xaafc,
  0xaafc, 0xaafc, 0xaafc, 0xaafc, 0xaafc, 0xaafc, 0xaafc, 0xaafc,
  0xaafc, 0xaafc, 0xaafc, 0xaafc, 0xaafc, 0xaafc, 0xbbfc, 0xbbfc,
  0xbbfc, 0xbbfc, 0xbbfc, 0xbcfc, 0xbcfc, 0xbcfc, 0xbcfc, 0xbcfc,
  0xbcfc, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb,
  0xbcfa, 0xacfa, 0xacfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa,
  0x9bfa, 0x9afa, 0x9afa, 0x9afa, 0x9afa, 0x9afa, 0x9afa, 0x9afa,
  0xaafa, 0xaafb, 0xabfa, 0xabfa, 0xabfb, 0xbbfb, 0xbbfb, 0xbcfb,
  0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xccfb, 0xccfb, 0xccfb, 0xccfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xddfc,
  0x34f8, 0x24f8, 0x24f8, 0x24f8, 0x24f8, 0x24f8, 0x24f8, 0x24f8,
  0x24f8, 0x34f8, 0x34f8, 0x35f8, 0x45f9, 0x45f9, 0x55f9, 0x56f9,
  0x66fa, 0x67fa, 0x77fa, 0x78fb, 0x88fb, 0x88fb, 0x89fb, 0x99fb,
  0x99fb, 0x99fb, 0x99fb, 0x99fb, 0xa9fb, 0xa9fb, 0xaafc, 0xaafc,
  0xaafc, 0xaafc, 0xaafc, 0xaafc, 0xaafc, 0xaafc, 0xaafc, 0xaafc,
  0xaafc, 0xaafc, 0xaafc, 0xaafc, 0xaafc, 0xaafc, 0xbafc, 0xbbfc,
  0xbbfc, 0xbbfc, 0xbbfc, 0xbbfc, 0xbcfc, 0xbcfc, 0xbcfc, 0xbcfc,
  0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb,
  0xacfa, 0xacfa, 0xacfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xaafa,
  0x9afa, 0x9afa, 0x9afa, 0x9afa, 0x9afa, 0x9afa, 0x9afa, 0x9afa,
  0x9afa, 0xaafb, 0xaafb, 0xabfb, 0xabfb, 0xabfb, 0xbbfb, 0xbcfb,
  0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xccfb, 0xccfb, 0xccfb, 0xccfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xddfc,
  0x24f8, 0x24f8, 0x24f8, 0x24f8, 0x24f8, 0x24f8, 0x24f8, 0x24f8,
  0x24f8, 0x24f8, 0x34f8, 0x34f9, 0x44f9, 0x45f9, 0x55f9, 0x56f9,
  0x66fa, 0x67fa, 0x77fa, 0x78fb, 0x88fb, 0x88fb, 0x89fb, 0x99fb,
  0x99fb, 0x99fb, 0x99fb, 0x99fb, 0xa9fb, 0xaafb, 0xaafc, 0xaafc,
  0xaafc, 0xaafc, 0xaafc, 0xaafb, 0xaafb, 0xaafb, 0xaafc, 0xa9fc,
  0xa9fb, 0xa9fb, 0xa9fc, 0xa9fc, 0xaafc, 0xaafc, 0xbafc, 0xbbfc,
  0xbbfc, 0xbbfc, 0xbbfc, 0xbbfc, 0xbcfc, 0xbcfc, 0xbbfc, 0xbcfb,
  0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfa,
  0xacfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0x9afa,
  0x9afa, 0x9afa, 0x9afa, 0x9afa, 0x9afa, 0x9afa, 0x9afa, 0x9afa,
  0x9afa, 0xaafa, 0xaafa, 0xabfb, 0xabfb, 0xabfb, 0xbbfb, 0xbbfb,
  0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xccfb, 0xccfb, 0xccfb, 0xccfb,
  0xccfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xddfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xddfc,
  0x24f8, 0x14f8, 0x14f8, 0x14f8, 0x14f8, 0x14f8, 0x14f8, 0x24f8,
  0x24f8, 0x24f8, 0x34f8, 0x34f8, 0x45f9, 0x45f9, 0x45f9, 0x56f9,
  0x56fa, 0x67fa, 0x77fa, 0x78fa, 0x88fb, 0x88fb, 0x99fb, 0x99fb,
  0x99fb, 0x99fb, 0x99fb, 0x99fb, 0xa9fb, 0xaafb, 0xaafb, 0xaafb,
  0xaafb, 0xaafb, 0xaafb, 0xaafb, 0xa9fb, 0xa9fb, 0x99fb, 0x99fb,
  0x99fb, 0x99fb, 0x99fb, 0xa9fb, 0xa9fb, 0xaafb, 0xaafc, 0xbafc,
  0xbbfc, 0xbbfc, 0xbbfc, 0xbbfc, 0xbbfc, 0xbbfb, 0xbbfb, 0xbbfb,
  0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfa, 0xbcfa,
  0xacfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xaafa, 0x9afb,
  0x9afa, 0x9afa, 0x9afa, 0x99fa, 0x9afa, 0x9afa, 0x9afa, 0x9afa,
  0x9afa, 0xaafa, 0xaafa, 0xaafb, 0xabfb, 0xabfb, 0xbbfb, 0xbbfb,
  0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xccfb, 0xccfb, 0xccfb,
  0xccfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xddfc,
  0x24f8, 0x14f8, 0x24f8, 0x24f8, 0x14f8, 0x14f8, 0x14f8, 0x24f8,
  0x24f8, 0x24f8, 0x34f8, 0x34f8, 0x45f9, 0x45f9, 0x45f9, 0x56f9,
  0x66fa, 0x66fa, 0x77fa, 0x77fa, 0x88fb, 0x88fb, 0x88fb, 0x99fb,
  0x99fb, 0x99fb, 0x99fb, 0xa9fb, 0xa9fb, 0xaafb, 0xaafb, 0xaafb,
  0xaafb, 0xaafb, 0xaafb, 0xa9fb, 0xa9fb, 0xa9fb, 0x99fb, 0x98fb,
  0x98fb, 0x98fb, 0x98fb, 0x98fb, 0x99fb, 0xa9fb, 0xa9fb, 0xaafb,
  0xaafb, 0xbbfb, 0xbbfb, 0xbbfb, 0xabfb, 0xabfb, 0xbbfb, 0xbbfb,
  0xbbfb, 0xbcfb, 0xbbfb, 0xbbfb, 0xbcfb, 0xbcfa, 0xacfa, 0xacfa,
  0xacfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xaafb, 0x9afb,
  0x9afa, 0x9afa, 0x9afa, 0x99fa, 0x99fa, 0x99fa, 0x99fa, 0x9afa,
  0x9afa, 0xaafa, 0xaafb, 0xaafb, 0xabfa, 0xabfb, 0xabfb, 0xbbfb,
  0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xccfb, 0xccfb, 0xccfb,
  0xccfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xddfc,
  0x24f8, 0x14f8, 0x14f8, 0x24f8, 0x14f8, 0x14f8, 0x14f8, 0x24f8,
  0x24f8, 0x24f8, 0x34f8, 0x34f8, 0x45f9, 0x45f9, 0x55f9, 0x56f9,
  0x56f9, 0x66fa, 0x67fa, 0x77fa, 0x88fa, 0x88fb, 0x88fb, 0x99fb,
  0x99fb, 0x99fb, 0x99fb, 0xa9fb, 0xa9fb, 0xaafb, 0xaafb, 0xaafb,
  0xaafb, 0xaafb, 0xa9fb, 0xa9fb, 0x99fa, 0x99fa, 0x98fa, 0x98fa,
  0x98fa, 0x88fa, 0x88fa, 0x98fa, 0x98fa, 0x99fa, 0x99fa, 0xa9fb,
  0xaafb, 0xaafb, 0xaafb, 0xaafb, 0xabfb, 0xabfb, 0xabfb, 0xabfb,
  0xabfb, 0xabfb, 0xbbfa, 0xbbfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa,
  0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfb, 0xabfb, 0xabfb, 0x9afb,
  0x9afb, 0x9afa, 0x9afa, 0x99fa, 0x99fa, 0x99fa, 0x99fa, 0x9afa,
  0x9afa, 0x9afa, 0xaafb, 0xaafb, 0xabfb, 0xabfb, 0xabfb, 0xbbfb,
  0xbbfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xccfb, 0xccfb, 0xccfb,
  0xccfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xddfc,
  0x24f8, 0x14f8, 0x14f8, 0x14f8, 0x14f8, 0x14f8, 0x14f8, 0x23f8,
  0x24f8, 0x24f8, 0x34f8, 0x34f8, 0x44f9, 0x45f9, 0x55f9, 0x56f9,
  0x56f9, 0x66fa, 0x66fa, 0x77fa, 0x77fa, 0x88fa, 0x88fb, 0x98fb,
  0x99fb, 0x99fb, 0x99fb, 0xa9fb, 0xa9fb, 0xaafb, 0xaafb, 0xaafb,
  0xaafb, 0xa9fb, 0xa9fb, 0x99fa, 0x98fa, 0x98fa, 0x98fa, 0x98fa,
  0x88fa, 0x88fa, 0x88fa, 0x88fa, 0x98fa, 0x98fa, 0x99fa, 0x99fa,
  0x99fa, 0x9afa, 0x9afa, 0xaafa, 0xaafb, 0xaafa, 0xabfb, 0xabfa,
  0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa,
  0xabfa, 0xabfa, 0xabfa, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xaafb,
  0xaafb, 0x9afb, 0x9afb, 0x9afa, 0x99fa, 0x99fa, 0x99fa, 0x9afa,
  0x9afa, 0x9afa, 0xaafa, 0xaafa, 0xabfb, 0xabfb, 0xabfb, 0xbbfb,
  0xbbfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xccfb, 0xccfb, 0xccfb,
  0xccfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xddfc,
  0x24f8, 0x24f8, 0x24f8, 0x14f8, 0x24f8, 0x24f8, 0x24f8, 0x24f8,
  0x24f8, 0x24f8, 0x34f8, 0x34f8, 0x45f9, 0x45f9, 0x55f9, 0x56f9,
  0x56f9, 0x66f9, 0x66f9, 0x77fa, 0x77fa, 0x77fa, 0x88fa, 0x88fa,
  0x98fa, 0x99fb, 0x99fb, 0x99fb, 0xa9fb, 0xa9fb, 0xa9fb, 0xa9fb,
  0xa9fb, 0x99fa, 0x98fa, 0x98fa, 0x98fa, 0x98fa, 0x88fa, 0x88fa,
  0x88fa, 0x87fa, 0x87fa, 0x88fa, 0x98fa, 0x98fa, 0x99fa, 0x99fa,
  0x99fa, 0x99fa, 0xaafa, 0xaafa, 0xaafa, 0xabfa, 0xabfa, 0xabfa,
  0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfb,
  0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xaafb, 0x9afb,
  0x9afb, 0x9afb, 0x9afb, 0x9afa, 0x9afa, 0x9afa, 0x99fa, 0x9afa,
  0x9afa, 0x9afa, 0xaafa, 0xaafb, 0xabfb, 0xabfb, 0xabfb, 0xbbfb,
  0xbbfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xccfb, 0xccfb, 0xccfb,
  0xccfb, 0xccfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xddfc,
  0x24f8, 0x24f8, 0x24f8, 0x24f8, 0x24f8, 0x24f8, 0x24f8, 0x24f8,
  0x24f8, 0x24f8, 0x34f8, 0x34f8, 0x44f9, 0x45f9, 0x55f9, 0x55f9,
  0x56f9, 0x66f9, 0x66f9, 0x66f9, 0x76f9, 0x77fa, 0x77fa, 0x87fa,
  0x88fa, 0x98fa, 0x98fb, 0x98fb, 0x99fa, 0x98fa, 0x98fa, 0x98fa,
  0x98fa, 0x98fa, 0x98fa, 0x98fa, 0x98fa, 0x98fa, 0x88fa, 0x88f9,
  0x87f9, 0x87fa, 0x87fa, 0x87fa, 0x98fa, 0x98fa, 0x99fa, 0x99fa,
  0x99fa, 0xaafa, 0xaafa, 0xaafa, 0xaafa, 0xabfb, 0xabfa, 0xabfa,
  0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfb,
  0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xaafb, 0x9afb,
  0x9afb, 0x9afb, 0x9afb, 0x9afa, 0x9afa, 0x9afa, 0x99fa, 0x9afa,
  0x9afa, 0x9afa, 0xaafa, 0xaafb, 0xabfb, 0xabfb, 0xabfb, 0xbbfb,
  0xbbfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xccfb, 0xccfb,
  0xccfb, 0xccfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xddfc,
  0x24f8, 0x24f8, 0x24f8, 0x24f8, 0x14f8, 0x14f8, 0x14f7, 0x24f8,
  0x24f8, 0x24f8, 0x34f8, 0x34f8, 0x45f9, 0x45f9, 0x55f9, 0x55f9,
  0x66f9, 0x66fa, 0x66fa, 0x76f9, 0x76fa, 0x77fa, 0x77fa, 0x77fa,
  0x87fa, 0x87fa, 0x88fa, 0x88fa, 0x98fa, 0x98fa, 0x98fa, 0x98fa,
  0x98fa, 0x98fa, 0x98fa, 0x98fa, 0x98fa, 0x98fa, 0x88f9, 0x87f9,
  0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x98fa, 0x98fa, 0x99fa, 0x99fa,
  0x99fa, 0xaafa, 0xaafb, 0xaafa, 0xaafb, 0xabfb, 0xabfa, 0xabfa,
  0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfb,
  0xbbfa, 0xabfa, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xaafb, 0xaafb,
  0x9afb, 0x9afb, 0x9afb, 0x9afb, 0x9afa, 0x9afa, 0x99fa, 0x99fa,
  0x9afa, 0x9afb, 0xaafb, 0xaafb, 0xabfb, 0xabfb, 0xabfb, 0xbbfb,
  0xbbfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xccfb, 0xccfb,
  0xccfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xddfc,
  0x24f8, 0x24f8, 0x24f8, 0x24f8, 0x14f8, 0x14f8, 0x14f8, 0x14f8,
  0x24f8, 0x24f8, 0x34f8, 0x34f9, 0x45f9, 0x45f9, 0x55f9, 0x66f9,
  0x66fa, 0x66fa, 0x77fa, 0x77fa, 0x77fa, 0x77fa, 0x77fa, 0x87fa,
  0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x88fa, 0x98fa, 0x98fa,
  0x98fa, 0x98fa, 0x98fa, 0x98fa, 0x98f9, 0x88f9, 0x88f9, 0x87f9,
  0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x98fa, 0x98fa, 0x99fa, 0x99fa,
  0x99fa, 0xaafa, 0xaafb, 0xaafa, 0xaafb, 0xabfb, 0xabfa, 0xabfa,
  0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfb,
  0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xaafb, 0xaafb,
  0x9afb, 0x9afb, 0x9afb, 0x9afb, 0x9afa, 0x9afa, 0x9afa, 0x9afa,
  0x9afa, 0x9afb, 0xaafb, 0xaafb, 0xabfb, 0xabfb, 0xabfb, 0xbbfb,
  0xbbfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xccfb, 0xccfb,
  0xccfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xddfc,
  0x24f8, 0x23f8, 0x24f8, 0x24f8, 0x24f8, 0x14f8, 0x14f8, 0x13f8,
  0x24f8, 0x34f8, 0x34f8, 0x45f9, 0x45f9, 0x55f9, 0x66fa, 0x66fa,
  0x76fa, 0x77fa, 0x77fa, 0x77fa, 0x77fa, 0x87fa, 0x87fa, 0x87fa,
  0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x88fa, 0x98fa,
  0x98fa, 0x98fa, 0x98f9, 0x98f9, 0x98f9, 0x97f9, 0x87f9, 0x87fa,
  0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x98fa, 0x98fa, 0x99fa, 0x99fa,
  0x99fa, 0xaafb, 0xaafa, 0xaafa, 0xaafa, 0xabfa, 0xabfb, 0xabfa,
  0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa,
  0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xaafb, 0xaafb,
  0xaafb, 0x9afb, 0x9afb, 0x9afb, 0x9afb, 0x9afa, 0x9afa, 0x9afb,
  0x9afb, 0x9afb, 0xaafb, 0xaafb, 0xabfb, 0xabfb, 0xabfb, 0xbbfb,
  0xbbfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xccfb, 0xccfb,
  0xccfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfc,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xddfc,
  0x24f8, 0x24f8, 0x24f8, 0x24f8, 0x24f8, 0x13f8, 0x23f8, 0x24f8,
  0x34f8, 0x34f9, 0x44f9, 0x45f9, 0x55f9, 0x66fa, 0x66fa, 0x76fa,
  0x77fa, 0x77fa, 0x77fa, 0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x87fa,
  0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x88fa,
  0x98fa, 0x98f9, 0x98fa, 0x98f9, 0x98f9, 0x98f9, 0x87f9, 0x87fa,
  0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x98fa, 0x98fa, 0x99fa, 0x99fa,
  0x99fa, 0xaafb, 0xaafa, 0xaafa, 0xaafa, 0xabfa, 0xabfa, 0xabfa,
  0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfb,
  0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xaafb, 0xaafb,
  0xaafb, 0x9afb, 0x9afb, 0x9afb, 0x9afb, 0x9afa, 0x9afa, 0x9afb,
  0x9afb, 0x9afb, 0xaafb, 0xaafb, 0xabfb, 0xabfb, 0xabfb, 0xbbfb,
  0xbbfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfa, 0xbcfb, 0xccfb, 0xccfb,
  0xccfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xddfc,
  0x24f8, 0x24f8, 0x24f8, 0x14f8, 0x24f8, 0x23f8, 0x24f8, 0x34f8,
  0x35f8, 0x45f9, 0x45f9, 0x55f9, 0x66fa, 0x66fa, 0x66fa, 0x77fa,
  0x77fa, 0x77fa, 0x77fa, 0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x87fa,
  0x88fa, 0x88fa, 0x88fa, 0x88fa, 0x98fa, 0x87fa, 0x88fa, 0x88f9,
  0x98f9, 0x98f9, 0x98f9, 0x98f9, 0x98f9, 0x98f9, 0x87f9, 0x87fa,
  0x87fa, 0x87fa, 0x87fa, 0x88fa, 0x98fa, 0x98fa, 0x99fa, 0x99fa,
  0x99fa, 0xaafb, 0xaafa, 0xaafb, 0xaafb, 0xabfa, 0xabfa, 0xabfa,
  0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfb,
  0xbbfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xaafb, 0xaafb,
  0x9afb, 0x9afb, 0x9afb, 0x9afb, 0x9afb, 0x9afb, 0x9afb, 0x9afb,
  0x9afb, 0x9afb, 0xaafb, 0xaafb, 0xabfb, 0xabfb, 0xabfb, 0xbbfb,
  0xbbfb, 0xbbfa, 0xbcfb, 0xbcfa, 0xbcfa, 0xbcfb, 0xccfb, 0xccfb,
  0xccfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xddfc,
  0x24f8, 0x24f8, 0x14f8, 0x23f8, 0x23f8, 0x24f8, 0x34f8, 0x35f8,
  0x34f8, 0x45f9, 0x55f9, 0x56fa, 0x66fa, 0x67fa, 0x77fa, 0x77fa,
  0x77fa, 0x77fa, 0x77fa, 0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x87fa,
  0x88fa, 0x88fa, 0x88fa, 0x98fa, 0x98fa, 0x98fa, 0x98fa, 0x88fa,
  0x98fa, 0x98fa, 0x98fa, 0x98fa, 0x98f9, 0x98f9, 0x87fa, 0x87fa,
  0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x98fa, 0x98fa, 0x99fa, 0x99fa,
  0x99fa, 0xaafb, 0xaafa, 0xaafb, 0xaafb, 0xabfa, 0xabfa, 0xabfa,
  0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfb, 0xabfb, 0xabfb,
  0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xaafb, 0xaafb,
  0xaafb, 0x9afb, 0x9afb, 0x9afb, 0x9afb, 0x9afb, 0x9afa, 0x9afb,
  0x9afb, 0x9afb, 0xaafb, 0xaafb, 0xabfb, 0xabfb, 0xabfb, 0xbbfb,
  0xbbfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfb, 0xccfb, 0xccfb,
  0xccfb, 0xccfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xddfc,
  0x24f8, 0x14f8, 0x24f8, 0x23f8, 0x24f8, 0x34f8, 0x35f8, 0x35f8,
  0x45f9, 0x45f9, 0x56fa, 0x66fa, 0x66fa, 0x66fa, 0x77fa, 0x77fa,
  0x77fa, 0x77fa, 0x77fa, 0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x88fa,
  0x88fa, 0x88fa, 0x88fa, 0x98fa, 0x98fa, 0x98fa, 0x98fa, 0x98fa,
  0x98fa, 0x98fa, 0x98fa, 0x98fa, 0x98f9, 0x97f9, 0x87fa, 0x87f9,
  0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x98fa, 0x98fa, 0x99fa, 0x99fa,
  0x99fa, 0x9afa, 0xaafa, 0xaafb, 0xaafb, 0xabfa, 0xabfa, 0xabfa,
  0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfb, 0xabfb, 0xabfb,
  0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xaafb, 0xaafb,
  0xaafb, 0x9afb, 0x9afb, 0x9afb, 0x9afb, 0x9afa, 0x9afa, 0x9afb,
  0x9afb, 0x9afb, 0xaafb, 0xabfb, 0xabfb, 0xabfa, 0xabfa, 0xbbfb,
  0xbbfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfb, 0xccfb,
  0xccfb, 0xccfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0x24f8, 0x14f7, 0x23f8, 0x24f8, 0x34f8, 0x35f8, 0x35f8, 0x35f8,
  0x45f9, 0x55f9, 0x56fa, 0x66fa, 0x66fa, 0x66fa, 0x77fa, 0x77fa,
  0x77fa, 0x77fa, 0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x88fa, 0x88fa,
  0x88fa, 0x88fa, 0x98fa, 0x98fa, 0x98fa, 0x98fa, 0x98fa, 0x87fa,
  0x87fa, 0x97fa, 0x97fa, 0x97fa, 0x97fa, 0x87fa, 0x87f9, 0x87f9,
  0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x98fa, 0x98fa, 0x99fa, 0x99fa,
  0x99fa, 0xaafa, 0xaafa, 0xaafb, 0xabfb, 0xabfb, 0xabfa, 0xabfa,
  0xabfa, 0xabfa, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb,
  0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xaafb, 0xaafb,
  0x9afb, 0x9afb, 0x9afb, 0x9afb, 0x9afb, 0x9afa, 0x9afa, 0x9afa,
  0x9afb, 0x9afb, 0xaafb, 0xaafb, 0xabfa, 0xabfa, 0xabfa, 0xabfa,
  0xbbfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfb, 0xccfb,
  0xccfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0x24f8, 0x23f8, 0x24f8, 0x34f8, 0x34f8, 0x35f8, 0x35f8, 0x45f9,
  0x45f9, 0x56fa, 0x56fa, 0x66fa, 0x66fa, 0x66fa, 0x76fa, 0x77fa,
  0x77fa, 0x77fa, 0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x88fa, 0x88fa,
  0x88fa, 0x88fa, 0x98fa, 0x98fa, 0x98fa, 0x98fa, 0x98fa, 0x98fa,
  0x87fa, 0x87fa, 0x87fa, 0x97f9, 0x87fa, 0x87f9, 0x87f9, 0x87f9,
  0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x98fa, 0x98fa, 0x99fa, 0x99fa,
  0x99fa, 0xaafa, 0xaafb, 0xaafb, 0xabfb, 0xabfb, 0xabfb, 0xabfb,
  0xabfb, 0xabfb, 0xabfb, 0xbbfb, 0xbbfb, 0xabfb, 0xabfb, 0xabfb,
  0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xaafb, 0xaafb,
  0x9afb, 0x9afb, 0x9afb, 0x9afb, 0x9afa, 0x9afa, 0x9afa, 0x9afa,
  0x9afa, 0x9afb, 0xaafb, 0xaafb, 0xabfa, 0xabfa, 0xabfa, 0xabfa,
  0xbbfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xccfb,
  0xccfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0x24f8, 0x23f8, 0x24f8, 0x34f8, 0x35f8, 0x45f8, 0x45f8, 0x45f9,
  0x55f9, 0x56fa, 0x66fa, 0x66fa, 0x66fa, 0x66fa, 0x76fa, 0x77fa,
  0x77fa, 0x77fa, 0x87fa, 0x87fa, 0x87fa, 0x88fa, 0x88fa, 0x88fa,
  0x88fa, 0x88fa, 0x88fa, 0x98fa, 0x98fa, 0x98fa, 0x98fa, 0x98fa,
  0x87fa, 0x87f9, 0x87f9, 0x87f9, 0x87f9, 0x87f9, 0x87f9, 0x87f9,
  0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x98fa, 0x98fa, 0x99fa, 0x99fa,
  0xa9fa, 0xaafa, 0xaafa, 0xaafb, 0xaafb, 0xabfa, 0xabfb, 0xabfb,
  0xabfb, 0xabfb, 0xabfb, 0xbbfb, 0xbbfb, 0xbbfb, 0xabfb, 0xabfb,
  0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xaafb, 0xaafb,
  0xaafb, 0x9afb, 0x9afb, 0x9afb, 0x9afa, 0x9afb, 0x9afa, 0x9afa,
  0x9afa, 0x9afb, 0xaafb, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xbbfa,
  0xbbfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa,
  0xccfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0x24f8, 0x24f8, 0x34f8, 0x35f8, 0x35f8, 0x45f8, 0x45f8, 0x45f9,
  0x56f9, 0x56f9, 0x66f9, 0x66fa, 0x66f9, 0x66fa, 0x76fa, 0x77fa,
  0x77fa, 0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x88fa, 0x88fa, 0x88fa,
  0x88fa, 0x88fa, 0x88fa, 0x98fa, 0x98fa, 0x98fa, 0x98fa, 0x97fa,
  0x87fa, 0x87f9, 0x87f9, 0x87f9, 0x87f9, 0x87f9, 0x87f9, 0x87f9,
  0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x88fa, 0x98fa, 0x99fa, 0x99fa,
  0x99fa, 0xaafa, 0xaafa, 0xaafa, 0xaafa, 0xabfa, 0xabfb, 0xabfb,
  0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xbbfb, 0xbbfb,
  0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xaafb, 0xaafb,
  0xaafb, 0x9afb, 0x9afb, 0x9afb, 0x9afb, 0x9afb, 0x9afa, 0x9afa,
  0x9afa, 0x9afa, 0xaafa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa,
  0xbbfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa,
  0xccfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0x34f8, 0x24f8, 0x34f8, 0x35f8, 0x45f8, 0x45f8, 0x45f9, 0x55f9,
  0x66f9, 0x66f9, 0x66f9, 0x66f9, 0x66f9, 0x67fa, 0x77fa, 0x77fa,
  0x77fa, 0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x88fa, 0x87fa, 0x88fa,
  0x88fa, 0x88fa, 0x98fa, 0x98fa, 0x98fa, 0x98fa, 0x98fa, 0x97fa,
  0x97fa, 0x87f9, 0x87f9, 0x87f9, 0x87f9, 0x87f9, 0x87f9, 0x87f9,
  0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x98fa, 0x99fa, 0x99fa,
  0x99fa, 0x9afa, 0x9afa, 0xaafa, 0xaafa, 0xaafa, 0xabfb, 0xabfb,
  0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xbbfb,
  0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xaafb, 0xaafb,
  0x9afb, 0x9afb, 0x9afb, 0x9afb, 0x9afb, 0x9afb, 0x9afa, 0x9afa,
  0x9afa, 0xaafa, 0xaafa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa,
  0xbbfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa,
  0xccfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0x34f8, 0x34f8, 0x34f8, 0x35f8, 0x45f8, 0x45f8, 0x45f8, 0x56f9,
  0x66f9, 0x66f9, 0x66f9, 0x66f9, 0x67f9, 0x77fa, 0x77fa, 0x77fa,
  0x77fa, 0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x88fa, 0x88fa, 0x88fa,
  0x98fa, 0x98fa, 0x98fa, 0x98fa, 0x98fa, 0x98fa, 0x98fa, 0x97fa,
  0x87fa, 0x87f9, 0x87f9, 0x87f9, 0x87f9, 0x87f9, 0x87f9, 0x87f9,
  0x87f9, 0x87fa, 0x87f9, 0x87fa, 0x88fa, 0x88fa, 0x87f9, 0x88f9,
  0x98f9, 0x99fa, 0x9afa, 0x9afa, 0xaafa, 0xaafb, 0xaafb, 0xabfb,
  0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xbbfb,
  0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xaafb, 0xaafb,
  0x9afb, 0x9afb, 0x9afb, 0x9afb, 0x9afb, 0x9afb, 0x9afa, 0x9afa,
  0x9afa, 0xaafa, 0xaafa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa,
  0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa,
  0xccfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0x34f8, 0x34f8, 0x34f8, 0x35f8, 0x45f8, 0x45f8, 0x45f9, 0x56f9,
  0x66f9, 0x66f9, 0x66f9, 0x67f9, 0x77f9, 0x77f9, 0x77fa, 0x77fa,
  0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x88fa, 0x88fa, 0x98fa,
  0x98fa, 0x98fa, 0x98fa, 0x98fa, 0x98fa, 0x98fa, 0x97fa, 0x97fa,
  0x87fa, 0x86f9, 0x86f9, 0x87f9, 0x87f9, 0x87f9, 0x87f9, 0x87f9,
  0x87f9, 0x77f9, 0x76f9, 0x76f9, 0x76fa, 0xa8fb, 0xcbfd, 0xeefe,
  0xddfd, 0x99fa, 0x88f9, 0x99f9, 0x99fa, 0x99fa, 0x9afa, 0x9afa,
  0x9afa, 0x9afb, 0xaafb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb,
  0xabfb, 0xbbfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0x9afb,
  0x9afb, 0x9afb, 0x9afb, 0x9afb, 0x9afa, 0x9afa, 0x9afa, 0x9afa,
  0x9afa, 0x9afa, 0xaafa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa,
  0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa,
  0xccfb, 0xccfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0x34f8, 0x34f8, 0x34f8, 0x45f8, 0x45f8, 0x45f8, 0x55f9, 0x66f9,
  0x66f9, 0x66f9, 0x66f9, 0x77f9, 0x77f9, 0x77f9, 0x77fa, 0x77fa,
  0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x88fa, 0x98fa, 0x98fa,
  0x98fa, 0x98fa, 0x98fa, 0x98fa, 0x98fa, 0x87fa, 0x87fa, 0x97fa,
  0x87fa, 0x86f9, 0x86f9, 0x86f9, 0x87f9, 0x87f9, 0x77f9, 0x67f9,
  0x75f9, 0x85fa, 0x97fb, 0xb9fc, 0xecfe, 0xfeff, 0xffff, 0xffff,
  0xffff, 0xdcfd, 0xccfd, 0xeefe, 0xddfd, 0xbbfc, 0xbbfc, 0xbbfb,
  0xbbfb, 0xabfb, 0xabfb, 0xabfb, 0xaafb, 0xabfb, 0xabfb, 0xabfb,
  0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xabfb, 0xaafb, 0x9afb,
  0x9afb, 0x9afb, 0x9afa, 0x9afa, 0x9afa, 0x9afa, 0x9afa, 0x9afa,
  0x9afa, 0x9afa, 0xaafa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabf9,
  0xabf9, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa,
  0xbcfa, 0xccfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0x34f8, 0x34f8, 0x34f8, 0x45f8, 0x45f8, 0x55f8, 0x55f8, 0x66f9,
  0x66f9, 0x77f9, 0x77f9, 0x77f9, 0x77f9, 0x77f9, 0x77fa, 0x87f9,
  0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x88fa, 0x98fa, 0x98fa, 0x98fa,
  0x98fa, 0x98fa, 0x98fa, 0x98fa, 0x98fa, 0x88fa, 0x87fa, 0x87fa,
  0x87fa, 0x76f9, 0x66f8, 0x76f8, 0x77f9, 0x67f9, 0x77fa, 0xa6fb,
  0xe8fe, 0xfbff, 0xffff, 0xffff, 0xfdff, 0xfbff, 0xf9ff, 0xfeff,
  0xffff, 0xffff, 0xffff, 0xfdff, 0xffff, 0xffff, 0xffff, 0xffff,
  0xffff, 0xffff, 0xfffe, 0xfffe, 0xdefd, 0xbbfc, 0xabfb, 0xabfb,
  0xaafb, 0xaafb, 0xabfb, 0xabfb, 0xabfb, 0xaafb, 0xaafb, 0x9afb,
  0x9afa, 0x9afa, 0x9afa, 0x9afa, 0x9afa, 0x9afa, 0x9afa, 0x9afa,
  0x9afa, 0x9afa, 0x9bfa, 0xabf9, 0xabf9, 0xabfa, 0xabf9, 0xabf9,
  0xabf9, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa,
  0xbcfa, 0xccfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0x34f8, 0x34f8, 0x45f8, 0x45f8, 0x55f8, 0x55f8, 0x55f8, 0x66f9,
  0x77f9, 0x77f9, 0x77f9, 0x77f9, 0x77f9, 0x77f9, 0x87f9, 0x87f9,
  0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x87fa, 0x88fa, 0x98fa, 0x98fa,
  0x98fa, 0x98fa, 0x98fa, 0x98fa, 0x98fa, 0x88fa, 0x87fa, 0x87f9,
  0x77f9, 0x87fa, 0xb8fd, 0xbafc, 0x86fa, 0xb5fd, 0xf4ff, 0xf5ff,
  0xf9ff, 0xfaff, 0xfaff, 0xf8ff, 0xe4ff, 0xd6fe, 0xd9fe, 0xfeff,
  0xffff, 0xffff, 0xfeff, 0xf9ff, 0xf7ff, 0xf7ff, 0xfcff, 0xffff,
  0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffd, 0xeefd, 0xeefd,
  0xddfd, 0xccfc, 0xabfb, 0xabfb, 0x9afb, 0x9afa, 0x9afa, 0x9afb,
  0x9afa, 0x9afa, 0x9afa, 0x9afa, 0x9afa, 0x9afa, 0x9afa, 0x9afa,
  0x9afa, 0x9af9, 0x9bf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9,
  0xabf9, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa,
  0xbcfa, 0xccfb, 0xccfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0x34f8, 0x34f8, 0x45f8, 0x55f8, 0x55f8, 0x55f8, 0x66f8, 0x76f9,
  0x77f9, 0x77f9, 0x77f9, 0x87f9, 0x87f9, 0x87f9, 0x87f9, 0x87f9,
  0x87f9, 0x87fa, 0x87fa, 0x88fa, 0x88fa, 0x98fa, 0x98fa, 0x98fa,
  0x98fa, 0x98fa, 0x98fa, 0x98fa, 0x88fa, 0x88f9, 0x89f9, 0x89fa,
  0xc7fe, 0xf5ff, 0xf5ff, 0xf6ff, 0xf4ff, 0xf1ff, 0xf0ff, 0xe2ff,
  0xd4ff, 0xe2ff, 0xe2ff, 0xe6ff, 0xe7ff, 0xfbff, 0xeefe, 0xb6fb,
  0xc6fd, 0xd9ff, 0xd9fd, 0xb7fb, 0xb5fb, 0xc7fd, 0xecfd, 0xeefe,
  0xeefe, 0xddfc, 0xdcfc, 0xfffe, 0xffff, 0xfffe, 0xfffd, 0xfffe,
  0xfffd, 0xfffe, 0xfffe, 0xeffd, 0xddfc, 0xaafb, 0x99fa, 0x99fa,
  0x9afa, 0x9afa, 0x9afa, 0x9afa, 0x9afa, 0x9afa, 0x9afa, 0x9afa,
  0x9af9, 0x9af9, 0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9,
  0xabf9, 0xabf9, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa,
  0xbcfa, 0xbcfa, 0xccfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0x44f8, 0x44f8, 0x45f8, 0x55f8, 0x55f8, 0x66f8, 0x66f8, 0x76f9,
  0x87f9, 0x87f9, 0x87f9, 0x87f9, 0x87f9, 0x87f9, 0x87f9, 0x87f9,
  0x87f9, 0x88f9, 0x88fa, 0x88fa, 0x98fa, 0x98fa, 0x98fa, 0x98fa,
  0x98fa, 0x98fa, 0x98fa, 0x88f9, 0x78f9, 0xa7fd, 0xc8fe, 0xf5ff,
  0xf1ff, 0xf0ff, 0xe1ff, 0xd3ff, 0xe2ff, 0xe1ff, 0xe1ff, 0xe1ff,
  0xf2ff, 0xf0ff, 0xf3ff, 0xfbff, 0xfaff, 0xfdff, 0xfbff, 0xc7fd,
  0xd9fd, 0xdbfc, 0xbbf9, 0xbbfa, 0xdbfc, 0xccfa, 0xabf6, 0xbbf7,
  0xbbf8, 0xb9f8, 0x98f7, 0xaaf8, 0xddfb, 0xeefc, 0xffff, 0xffff,
  0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xcdfc, 0xabfb,
  0x99fa, 0x89fa, 0x89fa, 0x9afa, 0x9afa, 0x9afa, 0x9afa, 0x9af9,
  0x9af9, 0x9af9, 0x9bf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9,
  0xabf9, 0xabf9, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa,
  0xbcfa, 0xbcfa, 0xccfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0x45f8, 0x45f8, 0x55f8, 0x55f8, 0x66f8, 0x66f8, 0x76f8, 0x77f9,
  0x87f9, 0x88f9, 0x88f9, 0x88f9, 0x88f9, 0x88f9, 0x88f9, 0x88f9,
  0x98f9, 0x98f9, 0x98f9, 0x98fa, 0x98fa, 0x98fa, 0x98fa, 0x98fa,
  0x98fa, 0x98fa, 0x88f9, 0x88f9, 0xb4fe, 0xf1ff, 0xf1ff, 0xe1ff,
  0xd1ff, 0xe1ff, 0xd3ff, 0xc4ff, 0xc4ff, 0xe2ff, 0xc2ff, 0xc3fe,
  0xc4fd, 0xc2fc, 0xb4fd, 0xb7fe, 0xc8fe, 0xc7fe, 0xe6ff, 0xfdff,
  0xfdff, 0xebfe, 0xfbff, 0xfaff, 0xe8ff, 0xd8fc, 0xbbf8, 0x99f4,
  0x87f3, 0x98f4, 0x99f3, 0x76f4, 0xa8f8, 0xccfa, 0xfffd, 0xffff,
  0xffff, 0xfffd, 0xeffd, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe,
  0xeefc, 0xcdfb, 0xabfa, 0x89fa, 0x99fa, 0x9afa, 0x9af9, 0x9af9,
  0x9af9, 0x9af9, 0x9af9, 0x9af9, 0xabf9, 0xabf9, 0xabf9, 0xabf9,
  0xabf9, 0xabf9, 0xabf9, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa,
  0xbcfa, 0xbcfa, 0xbcfa, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0x45f8, 0x55f8, 0x55f8, 0x66f8, 0x66f8, 0x76f8, 0x77f8, 0x87f9,
  0x87f9, 0x98f9, 0x98f9, 0x98f9, 0x98f9, 0x98f9, 0x98f9, 0x98f9,
  0x98f9, 0x98f9, 0x98f9, 0x98f9, 0x98f9, 0x98fa, 0x98fa, 0x98fa,
  0x88f9, 0x88f9, 0x97fb, 0xd5ff, 0xf2ff, 0xd2ff, 0xb1fc, 0xa2fd,
  0x93fb, 0xa2fc, 0xd5ff, 0xa4fb, 0xa2fc, 0x92fa, 0x61f6, 0x62f5,
  0x62f4, 0x51f3, 0x51f4, 0x50f5, 0x61f6, 0x61f6, 0x73f7, 0xb7fb,
  0xdbfe, 0xc8fd, 0xb4fe, 0xc2ff, 0xc3fd, 0xd7fe, 0xe8fd, 0xb5f9,
  0x85f6, 0x77f1, 0x88f2, 0x66f2, 0x77f2, 0xaaf7, 0xabf6, 0xbdf7,
  0xdef9, 0xdefa, 0xdefa, 0xdefa, 0xeffc, 0xffff, 0xffff, 0xffff,
  0xffff, 0xfffd, 0xfffe, 0xcdfc, 0x88f9, 0x89f9, 0x9af9, 0x9af9,
  0x9af9, 0x9af8, 0x9af8, 0x9af8, 0x9bf8, 0x9bf8, 0xabf9, 0xabf9,
  0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa,
  0xbcfa, 0xbcfa, 0xbcfa, 0xccfb, 0xccfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0x55f8, 0x55f8, 0x65f8, 0x66f8, 0x76f8, 0x77f8, 0x87f8, 0x87f8,
  0x87f9, 0x98f9, 0x98f9, 0x98f9, 0x98f9, 0x98f9, 0x98f9, 0x98f9,
  0x98f9, 0x98f9, 0x98f9, 0x98f9, 0x98f9, 0x98f9, 0x98fa, 0x98f9,
  0x99fa, 0xb5fe, 0xe4ff, 0xd6fe, 0x94fb, 0x92fb, 0x82f9, 0x92fb,
  0x81f8, 0xa2fa, 0xa4fb, 0x71f6, 0x71f6, 0x61f5, 0x60f3, 0x61f4,
  0x71f5, 0x61f5, 0x61f4, 0x61f4, 0x61f4, 0x52f4, 0x51f3, 0x73f6,
  0xa9f8, 0x85f6, 0x72f6, 0x83f7, 0x93f8, 0x94f8, 0xa3fa, 0x92f8,
  0x73f4, 0x76f1, 0x67f1, 0x77f1, 0x78f1, 0x88f2, 0x88f3, 0x87f3,
  0x89f2, 0x9bf3, 0xbdf5, 0xbdf6, 0xadf4, 0xbdf5, 0xdefa, 0xfffc,
  0xfffd, 0xfffd, 0xfffd, 0xfffe, 0xdefc, 0x9afa, 0x89f8, 0x89f8,
  0x9af8, 0x9af8, 0x9af8, 0x9af8, 0x9bf8, 0x9bf8, 0x9bf8, 0xabf9,
  0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xbbf9, 0xbcfa, 0xbcfa, 0xbcfa,
  0xbcfa, 0xbcfa, 0xbcfa, 0xccfb, 0xccfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0x55f8, 0x55f8, 0x66f8, 0x76f8, 0x77f8, 0x87f8, 0x87f8, 0x87f8,
  0x97f8, 0x98f9, 0x98f9, 0xa9f9, 0x99f9, 0x99f9, 0xa9f9, 0xa8f9,
  0xa8f9, 0xa8f9, 0x98f9, 0x98f9, 0x98f9, 0x98fa, 0x98fa, 0x99f9,
  0xa6fd, 0xc1ff, 0xa5fb, 0x54f5, 0x61f6, 0x71f7, 0xa3fb, 0xb3fc,
  0x93fa, 0x83f8, 0x51f4, 0x50f4, 0x61f6, 0x72f7, 0x61f5, 0x61f5,
  0x72f5, 0x61f5, 0x61f4, 0x71f5, 0x72f5, 0x52f3, 0x62f4, 0x50f3,
  0x40f2, 0x50f2, 0x52f3, 0x51f3, 0x61f3, 0x62f2, 0x62f2, 0x71f4,
  0x83f4, 0x75f2, 0x66f1, 0x65f2, 0x75f2, 0x75f3, 0x84f5, 0x94f7,
  0x86f4, 0x78f0, 0x8bf1, 0x9cf1, 0xbdf5, 0x9cf2, 0x8bf0, 0x9cf3,
  0xcef7, 0xdffa, 0xdffa, 0xfffd, 0xfffe, 0xfffe, 0xeefd, 0x9af9,
  0x79f7, 0x8af8, 0x9af8, 0x9af8, 0x9af8, 0x9bf8, 0x9bf8, 0x9bf8,
  0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xbbf9, 0xbcfa, 0xbcfa,
  0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfb, 0xccfb, 0xccfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0x66f8, 0x66f8, 0x66f8, 0x77f8, 0x87f8, 0x87f8, 0x87f8, 0x98f8,
  0x98f8, 0x98f8, 0xa8f9, 0xa9f9, 0xa9f9, 0xa9f9, 0xa9f9, 0xa9f9,
  0xa9f9, 0xa9f9, 0xa8f9, 0xa8f9, 0xa8f9, 0x98f9, 0x98f9, 0x99fa,
  0xa3fc, 0xb4fc, 0x56f5, 0x54f6, 0x71f6, 0x71f7, 0xa2fc, 0x92fa,
  0x84f9, 0x73f7, 0x60f5, 0x61f6, 0x51f5, 0x61f5, 0x71f6, 0x61f5,
  0x51f4, 0x51f4, 0x51f4, 0x50f4, 0x51f4, 0x52f3, 0x52f3, 0x51f3,
  0x61f4, 0x51f4, 0x61f5, 0x70f5, 0x61f4, 0x61f4, 0x71f4, 0x71f4,
  0x72f3, 0x73f3, 0x74f3, 0x75f2, 0x75f2, 0x74f3, 0x62f2, 0x64f1,
  0x86f1, 0x88f0, 0x89f1, 0x8af1, 0xacf4, 0xcef7, 0xadf3, 0x7bf0,
  0x9cf1, 0xbdf6, 0xdff9, 0xdff9, 0xdff9, 0xfffb, 0xfffd, 0xfffd,
  0xabfa, 0x79f6, 0x79f6, 0x8af7, 0x9af8, 0x9af8, 0x9af8, 0x9bf8,
  0x9bf8, 0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xbcfa, 0xbcfa,
  0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xccfa, 0xccfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0x66f8, 0x66f8, 0x76f8, 0x77f8, 0x87f8, 0x87f8, 0x88f8, 0x98f8,
  0x98f8, 0x98f8, 0xa8f8, 0xa9f9, 0xa9f9, 0xa9f9, 0xa9f9, 0xa9f9,
  0xa9f9, 0xa9f9, 0xa9f9, 0xa9f9, 0xa8f9, 0xa8f9, 0x99f8, 0xa7fb,
  0x91fb, 0xb6fc, 0x86f9, 0x85f9, 0x62f6, 0x61f6, 0x61f6, 0x51f6,
  0x72f7, 0x71f6, 0x51f5, 0x51f5, 0x52f4, 0x51f5, 0x60f5, 0x50f4,
  0x40f3, 0x51f4, 0x52f5, 0x64f5, 0x41f3, 0x40f2, 0x40f2, 0x50f3,
  0x50f4, 0x51f4, 0x52f3, 0x51f3, 0x70f4, 0x61f5, 0x71f5, 0x71f5,
  0x70f5, 0x71f5, 0x61f4, 0x62f4, 0x53f2, 0x53f2, 0x62f4, 0x74f2,
  0x76f1, 0x76f1, 0x77f1, 0x77f2, 0x77f1, 0x8af1, 0x9cf3, 0x9cf2,
  0x8bf0, 0x9cf1, 0xbdf6, 0xcef6, 0xcef6, 0xdff9, 0xdff9, 0xeff9,
  0xeffb, 0xdefc, 0xbcfa, 0x79f6, 0x8af7, 0x9af8, 0x9af8, 0x9bf8,
  0x9bf8, 0x9bf8, 0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xbcfa,
  0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xccfa, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0x77f8, 0x77f8, 0x77f8, 0x87f8, 0x87f8, 0x88f8, 0x98f8, 0x98f8,
  0x98f8, 0xa8f8, 0xa9f8, 0xa9f9, 0xa9f9, 0xa9f9, 0xb9f9, 0xbaf9,
  0xa9f9, 0xa9f9, 0xa9f9, 0xa9f9, 0xa9f9, 0x98f8, 0xa9fa, 0xb8fc,
  0x62f7, 0x71fa, 0x71f9, 0x52f5, 0x51f4, 0x41f4, 0x30f2, 0x40f4,
  0x60f5, 0x61f6, 0x51f5, 0x42f3, 0x31f3, 0x52f5, 0x42f3, 0x41f3,
  0x75f7, 0x30f3, 0x88f8, 0x67f7, 0x77f8, 0xa9f9, 0x85f7, 0x75f7,
  0x75f7, 0x74f6, 0x43f2, 0x31f1, 0x50f3, 0x50f3, 0x50f3, 0x61f5,
  0x61f4, 0x61f5, 0x70f5, 0x61f5, 0x61f4, 0x52f3, 0x52f4, 0x63f4,
  0x63f4, 0x63f3, 0x64f3, 0x65f3, 0x65f2, 0x66f2, 0x79f0, 0x8bf0,
  0x8bf1, 0x8bf1, 0x9cf1, 0xadf2, 0xbdf4, 0xbef6, 0xcef7, 0xdffa,
  0xeffb, 0xfffc, 0xfffe, 0xcdfb, 0x89f7, 0x79f7, 0x9af8, 0x9af8,
  0x9af8, 0x9af8, 0xabf8, 0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9,
  0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xccfa, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0x77f8, 0x77f8, 0x87f8, 0x87f8, 0x87f8, 0x98f8, 0x98f8, 0x98f8,
  0xa9f8, 0xa9f8, 0xa9f8, 0xa9f8, 0xa9f8, 0xa9f9, 0xbaf9, 0xbaf9,
  0xbaf9, 0xb9f9, 0xb9f9, 0xa9f9, 0xa8f8, 0xa8f9, 0xb8fb, 0xc5fe,
  0x85f9, 0x41f4, 0x30f3, 0x30f3, 0x30f3, 0x31f3, 0x31f3, 0x41f4,
  0x51f5, 0x30f3, 0x31f3, 0x20f2, 0x53f5, 0xaafa, 0x67f6, 0x9afa,
  0x67f6, 0x77f7, 0x89f8, 0x77f7, 0xffff, 0xffff, 0xcdfc, 0xcdfd,
  0xcdfd, 0xdefd, 0xcdfc, 0xaafa, 0x97f9, 0x97f9, 0x75f6, 0x31f2,
  0x40f2, 0x61f4, 0x71f5, 0x61f4, 0x61f4, 0x72f4, 0x52f3, 0x65f3,
  0x64f4, 0x64f4, 0x74f3, 0x65f2, 0x66f2, 0x66f1, 0x78f1, 0x7af1,
  0x8af1, 0x8bf1, 0x9bf2, 0x9cf1, 0x9cf0, 0x9cf2, 0xadf2, 0xbdf5,
  0xdefa, 0xdffb, 0xfffd, 0xffff, 0xeefc, 0x89f6, 0x79f6, 0x8af8,
  0x9af8, 0x9af8, 0x9af8, 0xabf8, 0xabf9, 0xabf9, 0xabf9, 0xabf9,
  0xbcf9, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xccfa,
  0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xccfb, 0xccfb, 0xccfb, 0xccfb, 0xccfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0x87f8, 0x87f8, 0x87f8, 0x87f8, 0x97f8, 0x98f8, 0x98f8, 0x98f8,
  0xa8f8, 0xa9f8, 0xa9f7, 0xa9f8, 0xa9f8, 0xb9f8, 0xb9f9, 0xbaf9,
  0xb9f9, 0xb9f9, 0xb9f9, 0xb9f9, 0xbaf9, 0xa9f9, 0x96fa, 0x94fb,
  0x74f7, 0x55f5, 0x44f4, 0x43f5, 0x21f2, 0x31f4, 0x41f4, 0x21f3,
  0x30f3, 0x63f6, 0x43f4, 0x43f4, 0xeefe, 0xacfa, 0x99fa, 0xdefd,
  0x78f7, 0xccfb, 0x67f6, 0xeeff, 0xffff, 0x9af9, 0x78f8, 0xffff,
  0xeffe, 0xcdfb, 0xbdfb, 0xeffd, 0xffff, 0xffff, 0xdffe, 0xabfa,
  0x55f5, 0x20f1, 0x40f3, 0x51f4, 0x61f4, 0x62f4, 0x62f3, 0x73f3,
  0x65f3, 0x55f3, 0x66f2, 0x66f1, 0x77f1, 0x78f1, 0x79f1, 0x79f1,
  0x8af1, 0x8af1, 0x7af1, 0x8bf1, 0x9cf1, 0x9cf0, 0xbdf3, 0xcef3,
  0x9df1, 0xadf4, 0xdef9, 0xfffe, 0xffff, 0xfffd, 0xbcf9, 0x79f6,
  0x89f7, 0x9af8, 0x9af8, 0x9af8, 0xabf9, 0xabf9, 0xabf9, 0xabf9,
  0xabf9, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa,
  0xccfa, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0xcdfb, 0xccfb, 0xccfa, 0xccfa, 0xccfb, 0xcdfb, 0xcdfb, 0xcdfb,
  0x88f8, 0x87f8, 0x87f8, 0x87f8, 0x98f8, 0x98f7, 0x98f7, 0xa8f7,
  0xa9f7, 0xa9f7, 0xa9f7, 0xa9f7, 0xa9f8, 0xb9f8, 0xb9f8, 0xb9f8,
  0xb9f8, 0xb9f8, 0xa9f8, 0xa9f8, 0xbafa, 0xa9fa, 0xdcfd, 0xccfc,
  0x99fa, 0xaafa, 0xabf9, 0x9af9, 0x66f5, 0x42f4, 0x52f5, 0x54f6,
  0x31f4, 0x86f8, 0x45f3, 0x87f7, 0xeffe, 0x88f7, 0x77f7, 0xccfc,
  0xccfc, 0x67f6, 0x99f9, 0xdefd, 0x67f6, 0x33f3, 0xa9fa, 0xcefc,
  0x78f7, 0x55f6, 0x55f7, 0x77f8, 0x89f8, 0xbbfb, 0xeeff, 0xffff,
  0xeffe, 0x68f7, 0x32f2, 0x30f2, 0x41f3, 0x62f4, 0x62f4, 0x72f4,
  0x74f3, 0x55f2, 0x45f2, 0x67f2, 0x78f1, 0x78f1, 0x68f2, 0x78f2,
  0x89f2, 0x8af1, 0x8af1, 0x8bf1, 0x9bf1, 0x9cf1, 0x9cf0, 0xbef3,
  0xcef5, 0x9df2, 0x7bf0, 0xadf4, 0xeffb, 0xffff, 0xffff, 0xdefb,
  0x9af8, 0x89f7, 0x9af8, 0x9af8, 0xabf9, 0xabf9, 0xabf9, 0xabf9,
  0xabf9, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa,
  0xccfa, 0xccfb, 0xccfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xcdfb, 0xccfa,
  0xccfa, 0xccfa, 0xccfa, 0xccfa, 0xccfa, 0xccfa, 0xccfa, 0xcdfb,
  0x88f8, 0x87f8, 0x88f8, 0x98f7, 0x98f7, 0x98f7, 0x98f7, 0xa8f7,
  0xa9f7, 0xa9f7, 0xa9f7, 0xa9f7, 0xa9f7, 0xb9f8, 0xb9f8, 0xb9f8,
  0xb9f8, 0xb9f8, 0xb9f8, 0xa8f7, 0xa7f8, 0xecff, 0xffff, 0xdefd,
  0xbcfc, 0xa9fb, 0xaafa, 0xbbfa, 0x9af9, 0x76f7, 0x53f5, 0x65f6,
  0x43f4, 0x76f8, 0x68f7, 0x77f7, 0xdefc, 0x56f4, 0x56f5, 0xabfa,
  0x67f6, 0x77f7, 0x9af9, 0x56f4, 0x22f1, 0x55f5, 0xcdfc, 0x55f5,
  0x54f7, 0x98fa, 0xa9fb, 0xa9fc, 0x98fa, 0x44f5, 0xbbfb, 0xeeff,
  0xeeff, 0xffff, 0xcdfd, 0x88f9, 0x53f5, 0x50f3, 0x62f5, 0x72f5,
  0x83f4, 0x75f3, 0x55f2, 0x55f2, 0x68f1, 0x89f1, 0x78f1, 0x78f1,
  0x89f1, 0x79f1, 0x79f1, 0x8af1, 0x8af1, 0x89f1, 0x89f1, 0x9cf2,
  0xadf3, 0xbdf5, 0xacf6, 0x8cf1, 0x8bf0, 0xcef6, 0xfffd, 0xffff,
  0xfffd, 0xbcf9, 0x8af8, 0x9af8, 0x9af8, 0xabf9, 0xabf9, 0xabf9,
  0xabf9, 0xbcf9, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa,
  0xccfa, 0xbcfa, 0xccfa, 0xccfa, 0xccfa, 0xccfa, 0xccfa, 0xccfa,
  0xccfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xccfa, 0xccfa, 0xccfa, 0xcdfb,
  0x88f8, 0x88f8, 0x98f8, 0x98f7, 0x98f7, 0x98f7, 0x98f7, 0xa8f7,
  0xa9f7, 0xa9f7, 0xa9f7, 0xa9f7, 0xa9f7, 0xb9f7, 0xb9f8, 0xb9f8,
  0xb9f8, 0xb9f8, 0xb9f8, 0xa8f7, 0xb9f9, 0xfeff, 0xeefe, 0xccfd,
  0xbcfb, 0x78f8, 0x66f7, 0xbafb, 0xbcfc, 0x88f8, 0x65f7, 0x88f8,
  0x32f3, 0x88f9, 0xcdfc, 0xabfa, 0xeffe, 0x56f5, 0x55f5, 0xbcfa,
  0x55f5, 0xeefe, 0x56f5, 0x23f2, 0x77f6, 0x77f7, 0x88f8, 0x55f7,
  0xbafd, 0x56f5, 0x35f3, 0x78f7, 0xdcfe, 0x99fa, 0x88f9, 0xeeff,
  0xdefe, 0xdefe, 0xffff, 0xffff, 0xddfe, 0x75f6, 0x50f3, 0x60f5,
  0x72f4, 0x83f4, 0x74f4, 0x54f3, 0x56f1, 0x68f1, 0x78f1, 0x88f1,
  0x88f1, 0x88f1, 0x89f1, 0x8af1, 0x8af1, 0x78f1, 0x77f1, 0x79f1,
  0x8bf0, 0x8bf1, 0xbdf7, 0xdef9, 0xadf4, 0xadf2, 0xcef5, 0xeffb,
  0xfffe, 0xfffd, 0x9af8, 0x89f7, 0x9af8, 0xabf9, 0xabf9, 0xabf9,
  0xabf9, 0xbcf9, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa,
  0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xccfa, 0xccfa,
  0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xccfa, 0xccfa, 0xbcfa, 0xccfb,
  0x98f8, 0x98f8, 0x98f8, 0x98f7, 0x98f7, 0xa8f7, 0xa8f7, 0xa8f7,
  0xa8f7, 0xa9f7, 0xa9f7, 0xa9f7, 0xb9f7, 0xb9f7, 0xb9f7, 0xbaf8,
  0xb9f8, 0xb9f8, 0xb9f8, 0xa9f7, 0xb9f8, 0xdcfd, 0xccfc, 0xaafb,
  0xabfb, 0x89f8, 0x11f2, 0x65f7, 0xeefe, 0x9afa, 0x88f9, 0x9afa,
  0x77f7, 0xddfd, 0xabfa, 0xaafa, 0xffff, 0x67f6, 0x76f6, 0xbcfb,
  0x89f9, 0xbbfb, 0x11f2, 0x99fa, 0x99f9, 0x55f5, 0x77f8, 0x65f7,
  0x77f8, 0x23f1, 0x02f0, 0x34f3, 0xbafc, 0xa9fb, 0x77f9, 0xeefe,
  0xddfd, 0xddfe, 0xeeff, 0xeeff, 0xffff, 0xeefe, 0x98f9, 0x61f4,
  0x60f4, 0x71f5, 0x73f4, 0x73f4, 0x63f4, 0x64f2, 0x65f2, 0x77f2,
  0x77f1, 0x77f1, 0x89f1, 0x8af1, 0x89f1, 0x89f1, 0x8af1, 0x8af1,
  0x9bf0, 0x8bf0, 0x8bf0, 0xacf4, 0xbdf7, 0xbdf5, 0x9cf1, 0xbdf4,
  0xdffa, 0xeffb, 0xeefc, 0xacf9, 0x8af8, 0x9af8, 0xabf9, 0xabf9,
  0xabf9, 0xabf9, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa,
  0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa,
  0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xccfb,
  0x98f8, 0x98f8, 0x98f8, 0x98f7, 0xa8f7, 0xa8f7, 0xa8f7, 0xa9f7,
  0xa9f6, 0xa9f6, 0xa9f7, 0xa9f7, 0xb9f7, 0xb9f7, 0xb9f7, 0xb9f7,
  0xbaf8, 0xbaf8, 0xb9f8, 0xa9f7, 0xb8f7, 0xccfb, 0xbcfc, 0xaafa,
  0xaafa, 0xbcfa, 0x34f3, 0x10f2, 0xbafc, 0xccfc, 0x99fa, 0x99fb,
  0xbbfc, 0xeefe, 0xbbfa, 0xaafa, 0xeefe, 0xabfa, 0xbbfb, 0xdefe,
  0xbbfb, 0x23f3, 0x66f7, 0xffff, 0x56f4, 0x55f5, 0x78f8, 0x65f7,
  0x66f7, 0x12f1, 0x01f0, 0x55f6, 0xbafc, 0x98fb, 0x77f8, 0xeefe,
  0xccfc, 0xddfe, 0xeefe, 0xeefe, 0xddfe, 0xeeff, 0xffff, 0xbbfc,
  0x62f5, 0x50f3, 0x72f5, 0x72f4, 0x62f4, 0x63f4, 0x75f2, 0x76f2,
  0x75f2, 0x76f1, 0x78f0, 0x89f1, 0x79f1, 0x79f1, 0x89f1, 0x8af1,
  0x9bf1, 0x9cf0, 0x8bf0, 0x9bf2, 0x8af2, 0x9cf3, 0xbdf4, 0x9df2,
  0xadf2, 0xdff8, 0xfffe, 0xffff, 0xcdfb, 0x89f7, 0x9af8, 0xabf9,
  0xabf9, 0xabf9, 0xbcf9, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa,
  0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa,
  0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xccfb,
  0x99f8, 0x98f8, 0x99f8, 0xa9f8, 0xa9f8, 0xa9f7, 0xa9f7, 0xa9f7,
  0xa9f7, 0xa9f6, 0xa9f6, 0xa9f6, 0xb9f6, 0xb9f7, 0xb9f7, 0xb9f7,
  0xbaf7, 0xbaf7, 0xb9f7, 0xb8f7, 0xecfc, 0xbcfa, 0x89f8, 0xbbfb,
  0x9afa, 0xabfb, 0x8af8, 0x12f1, 0x76f8, 0xddfe, 0xaafa, 0xbbfb,
  0xcdfc, 0xccfb, 0xdefd, 0xbbfb, 0xdefd, 0xaaf9, 0x88f9, 0xffff,
  0x67f7, 0x32f4, 0xfeff, 0x9af9, 0x22f3, 0xccfd, 0x78f8, 0x44f6,
  0x98fa, 0x66f6, 0x56f5, 0x99fa, 0xcafe, 0x65f8, 0x88f9, 0xddfd,
  0xddfd, 0xeeff, 0xeeff, 0xeeff, 0xeefe, 0xdefe, 0xeefe, 0xffff,
  0xccfc, 0x63f6, 0x61f6, 0x82f6, 0x72f4, 0x63f3, 0x74f3, 0x75f3,
  0x76f2, 0x86f1, 0x88f1, 0x89f1, 0x78f1, 0x67f1, 0x67f1, 0x78f1,
  0x89f0, 0x8bf1, 0x8bf1, 0x8af1, 0x7af0, 0x8bf0, 0xbdf4, 0xbdf5,
  0xadf4, 0xcef7, 0xdff9, 0xeffa, 0xeffb, 0xdefc, 0xabf9, 0x9af8,
  0xabf9, 0xabf9, 0xabf9, 0xbcf9, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa,
  0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa,
  0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa,
  0x99f8, 0x99f8, 0xa9f8, 0xa9f8, 0xa9f8, 0xa9f7, 0xa9f7, 0xa9f7,
  0xa9f7, 0xa9f7, 0xa9f6, 0xb9f6, 0xb9f6, 0xb9f7, 0xb9f7, 0xb9f7,
  0xbaf7, 0xbaf7, 0xb8f7, 0xecfc, 0xdefc, 0x67f5, 0x66f5, 0x78f8,
  0xbbfb, 0xaafb, 0xbbfb, 0x78f8, 0x89fa, 0xccfd, 0xbbfb, 0x9af8,
  0x66f6, 0x88f8, 0xccfc, 0xabfa, 0x89f8, 0x11f1, 0x98fa, 0xdefd,
  0x23f3, 0xa9fb, 0xffff, 0x56f6, 0x98fa, 0xffff, 0xaafa, 0x23f3,
  0x65f8, 0x98fb, 0xaafc, 0xbafd, 0x76f9, 0x34f4, 0xabfa, 0xeffe,
  0xeeff, 0x99fa, 0x88f8, 0x9afa, 0xbbfb, 0xccfd, 0xeefe, 0xeefe,
  0xffff, 0xddfd, 0x97fa, 0x97fb, 0x83f7, 0x61f3, 0x62f4, 0x73f4,
  0x75f3, 0x86f2, 0x87f1, 0x79f0, 0x89f0, 0x76f1, 0x66f1, 0x68f1,
  0x79f1, 0x8af1, 0x8bf1, 0x8af0, 0x8bf1, 0x8bf1, 0x8bf0, 0x8cf0,
  0x9cf2, 0xadf2, 0xbef5, 0xcef5, 0xcff5, 0xeffa, 0xcdfb, 0x99f8,
  0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xbbf9, 0xbcf9, 0xbcfa,
  0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa,
  0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa,
  0xa9f9, 0xa9f8, 0xa9f8, 0xa9f8, 0xa9f8, 0xa9f8, 0xa9f7, 0xa9f7,
  0xb9f7, 0xa9f7, 0xa9f6, 0xb9f6, 0xb9f6, 0xb9f6, 0xb9f7, 0xb9f7,
  0xbaf7, 0xb9f7, 0xcaf9, 0xeefd, 0x67f5, 0x44f3, 0x78f6, 0x67f5,
  0x78f7, 0xbafb, 0xaafb, 0xaafb, 0xbbfc, 0xbbfd, 0xabfb, 0x89f8,
  0x66f6, 0x77f8, 0x99f9, 0x89f8, 0x44f5, 0x98fa, 0xffff, 0x89f9,
  0x98fa, 0xffff, 0xddfd, 0xccfd, 0xeefe, 0xddfe, 0xeeff, 0x9af9,
  0x34f3, 0x44f5, 0x65f8, 0x55f7, 0x33f4, 0x89f9, 0xeefe, 0xbbfb,
  0x44f4, 0x43f4, 0x55f6, 0x23f3, 0x22f1, 0x33f3, 0x77f7, 0xccfc,
  0xffff, 0xffff, 0xeeff, 0xdcfd, 0xb9fb, 0x73f7, 0x60f5, 0x71f4,
  0x73f5, 0x85f4, 0x86f3, 0x87f2, 0x77f1, 0x87f1, 0x76f1, 0x66f1,
  0x78f1, 0x8af1, 0x8af0, 0x8af1, 0x8bf1, 0x8bf1, 0x7af1, 0x8af1,
  0x8bf0, 0x8cf0, 0x9df1, 0xbef4, 0xcff7, 0xcff7, 0xeffb, 0xbcfa,
  0x99f8, 0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xbcf9,
  0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa,
  0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa,
  0xaaf9, 0xa9f8, 0xa9f8, 0xa9f8, 0xa9f8, 0xa9f8, 0xa9f8, 0xa9f7,
  0xb9f7, 0xb9f7, 0xb9f7, 0xb9f6, 0xb9f6, 0xb9f7, 0xb9f7, 0xb9f7,
  0xbaf7, 0xb9f7, 0xedfc, 0x9af9, 0x55f4, 0x45f3, 0x78f6, 0x89f6,
  0x45f3, 0x88f8, 0xbcfb, 0xbcfb, 0xaafb, 0xaafc, 0x9afa, 0x99f9,
  0xccfc, 0x77f7, 0x66f7, 0xa9fb, 0xedfe, 0xccfc, 0x44f5, 0x55f6,
  0xccfd, 0xccfc, 0xccfc, 0xffff, 0xeefe, 0xeefe, 0xddfe, 0x78f7,
  0x55f5, 0x78f8, 0x78f8, 0x67f7, 0x9afa, 0x88f8, 0x55f5, 0x44f5,
  0x87f9, 0xcbfd, 0xdcfe, 0xbbfc, 0xaafb, 0x55f5, 0x00f0, 0x44f4,
  0xcbfc, 0xeefe, 0xeefe, 0xeefe, 0xdefe, 0xbdfc, 0x85f9, 0x70f7,
  0x71f5, 0x73f5, 0x86f5, 0x85f7, 0x72f5, 0x75f2, 0x86f1, 0x75f2,
  0x75f2, 0x66f1, 0x89f1, 0x8af1, 0x8bf1, 0x8cf1, 0x8af1, 0x7af1,
  0x8bf1, 0x8bf1, 0x8bf0, 0x9bf1, 0xacf4, 0xadf4, 0xdff8, 0xfffc,
  0xcdfa, 0x9af9, 0x9af8, 0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9,
  0xabf9, 0xbcf9, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa,
  0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa,
  0xaaf9, 0xa9f8, 0xa9f8, 0xa9f8, 0xa9f8, 0xa9f8, 0xb9f8, 0xb9f8,
  0xb9f7, 0xb9f7, 0xb9f7, 0xb9f7, 0xb9f7, 0xb9f7, 0xb9f7, 0xbaf7,
  0xb9f7, 0xdcfa, 0xbcfa, 0x55f4, 0x56f4, 0x45f3, 0x44f3, 0x77f6,
  0x78f6, 0x45f4, 0x88f8, 0xbbfa, 0xbcfc, 0xccfc, 0xbbfc, 0x88f9,
  0x99f9, 0x77f8, 0x98fa, 0x77f8, 0xbafb, 0xccfc, 0x55f5, 0x44f4,
  0x22f1, 0x22f2, 0x66f7, 0xccfc, 0xddfd, 0x9af9, 0x55f5, 0x98fa,
  0x99fa, 0x66f6, 0x66f6, 0x55f5, 0x65f6, 0x65f7, 0x76f9, 0xdcfe,
  0xffff, 0xffff, 0xfeff, 0xfeff, 0xffff, 0xddfe, 0x89f8, 0x34f3,
  0x23f2, 0x34f2, 0x44f3, 0x77f6, 0xb9fb, 0xb6fd, 0x93ff, 0x80ff,
  0x70fc, 0x71f9, 0x73fa, 0x71fb, 0x71f9, 0x72f4, 0x74f2, 0x75f3,
  0x64f3, 0x64f3, 0x76f1, 0x79f0, 0x8af0, 0x7af0, 0x8bf0, 0x9bf1,
  0x8bf1, 0x8af1, 0x7af1, 0x8bf1, 0x9cf3, 0x8bf0, 0xbdf4, 0xfffc,
  0xfffd, 0xeefc, 0xbbfa, 0x9af9, 0xabf9, 0xabf9, 0xabf9, 0xabf9,
  0xabf9, 0xabf9, 0xbcf9, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa,
  0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa,
  0xaaf9, 0xa9f8, 0xa9f8, 0xa9f8, 0xa9f8, 0xa9f8, 0xb9f8, 0xb9f8,
  0xb9f7, 0xb9f7, 0xb9f7, 0xb9f7, 0xb9f7, 0xbaf7, 0xbaf7, 0xb9f7,
  0xcaf8, 0xcdfa, 0x67f6, 0x45f3, 0x45f4, 0x45f3, 0x34f3, 0x45f3,
  0x66f5, 0x66f5, 0x66f5, 0x66f6, 0x77f8, 0xccfd, 0xeefe, 0xddfe,
  0xaafb, 0x77f8, 0x88f9, 0x55f5, 0x32f3, 0x98fa, 0xffff, 0xefff,
  0xbbfb, 0x88f8, 0x88f9, 0x78f8, 0x34f4, 0x55f6, 0x77f8, 0x45f5,
  0x66f7, 0x88f9, 0x98fa, 0x88fa, 0xbafc, 0xdcff, 0xffff, 0xffff,
  0xcdfd, 0xccfc, 0xddfd, 0xeefe, 0xffff, 0xffff, 0xffff, 0xeefe,
  0xabfa, 0x77f8, 0x76f8, 0x99f9, 0x96fc, 0x90ff, 0x80ff, 0x81ff,
  0x81ff, 0x80ff, 0x80ff, 0x80ff, 0x80ff, 0x70fe, 0x61fa, 0x72f5,
  0x73f4, 0x62f5, 0x74f4, 0x75f3, 0x75f3, 0x75f2, 0x78f1, 0x8bf1,
  0x8bf1, 0x8af1, 0x8af1, 0x8bf1, 0x9bf2, 0x9cf2, 0xadf4, 0xcef8,
  0xfffc, 0xffff, 0xffff, 0xbbfa, 0x9af8, 0xabf9, 0xabf9, 0xabf9,
  0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xbcf9, 0xbcf9, 0xbcf9,
  0xbcf9, 0xbcf9, 0xbcf9, 0xbcf9, 0xbcf9, 0xbcfa, 0xbcfa, 0xbcfa,
  0xaaf9, 0xa9f8, 0xa9f8, 0xa9f8, 0xa9f8, 0xa9f8, 0xb9f8, 0xb9f8,
  0xb9f8, 0xb9f7, 0xb9f7, 0xb9f8, 0xbaf8, 0xbaf8, 0xbaf8, 0xb9f7,
  0xdcfa, 0x9bf9, 0x45f3, 0x34f2, 0x34f3, 0x55f4, 0x56f4, 0x44f3,
  0x33f2, 0x56f4, 0x56f4, 0x45f4, 0x34f3, 0x44f5, 0xbafc, 0xffff,
  0xdefe, 0x66f7, 0x77f8, 0x98fa, 0x76f7, 0x33f3, 0x54f6, 0xa9fb,
  0xaafa, 0xccfb, 0xffff, 0xffff, 0xaafa, 0x66f6, 0xa9fb, 0x78f8,
  0x33f3, 0x98fa, 0xfeff, 0xffff, 0xffff, 0xeefe, 0xabfa, 0x56f5,
  0x33f2, 0x22f2, 0x22f2, 0x54f4, 0x99f9, 0xeffe, 0xffff, 0xffff,
  0xddfd, 0x95fb, 0x96fb, 0xa7fc, 0x93fd, 0x80ff, 0x71fe, 0x81ff,
  0x81ff, 0x81ff, 0x81ff, 0x80ff, 0x81ff, 0x71ff, 0x60ff, 0x70fc,
  0x82f7, 0x72f7, 0x72f8, 0x61f7, 0x61f5, 0x72f4, 0x75f3, 0x79f1,
  0x8bf1, 0x7af1, 0x7af2, 0x8af1, 0x8af1, 0x9bf2, 0xacf4, 0xadf4,
  0xbef6, 0xfffb, 0xfffe, 0xeffc, 0x9af9, 0x9af8, 0xabf9, 0xabf9,
  0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9,
  0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xacf9, 0xbcf9, 0xbcf9, 0xbcfa,
  0xaaf9, 0xa9f8, 0xa9f8, 0xa9f8, 0xa9f8, 0xa9f8, 0xa9f8, 0xa9f8,
  0xb9f8, 0xb9f7, 0xb9f8, 0xbaf8, 0xbaf8, 0xbaf8, 0xbaf8, 0xcaf8,
  0xccfa, 0x67f6, 0x45f3, 0x44f3, 0x34f2, 0x56f5, 0x56f5, 0x45f3,
  0x45f3, 0x34f3, 0x34f3, 0x34f2, 0x45f4, 0x34f3, 0x34f4, 0xbafc,
  0xffff, 0xccfc, 0x55f7, 0x66f6, 0x88f9, 0xaafa, 0x77f8, 0x67f7,
  0x23f2, 0x00f0, 0x66f6, 0xbbfb, 0xccfc, 0xddfd, 0xccfc, 0xfeff,
  0xddfe, 0xaafb, 0xccfd, 0xddfd, 0xbcfb, 0x9af9, 0x45f4, 0x33f4,
  0x88f9, 0x88f9, 0x76f7, 0x21f1, 0x11f0, 0x67f6, 0x67f5, 0x89f7,
  0x95fb, 0x70fb, 0x61f9, 0x61f9, 0x60f9, 0x61fb, 0x71fe, 0x71ff,
  0x71ff, 0x71ff, 0x71ff, 0x71ff, 0x71ff, 0x71ff, 0x71ff, 0x70ff,
  0x71fd, 0x71fa, 0x70fa, 0x70fa, 0x61f8, 0x61f6, 0x73f3, 0x88f1,
  0x8bf1, 0x7af1, 0x8af1, 0x8af1, 0x9bf1, 0x9bf1, 0xacf3, 0xadf4,
  0x8bf2, 0xacf3, 0xdff9, 0xfffd, 0xdffa, 0xabf9, 0x9af8, 0xabf9,
  0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9,
  0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xacf9, 0xbcfa,
  0xaaf9, 0xa9f8, 0xa9f8, 0xa9f8, 0xa9f8, 0xa9f8, 0xa9f8, 0xb9f8,
  0xb9f8, 0xb9f8, 0xb9f8, 0xbaf8, 0xbaf8, 0xbaf8, 0xbaf7, 0xcbf9,
  0x99f7, 0x45f3, 0x34f3, 0x45f3, 0x44f2, 0x55f4, 0x45f4, 0x45f3,
  0x44f3, 0x34f3, 0x34f3, 0x34f3, 0x34f3, 0x44f3, 0x45f3, 0x22f2,
  0xa9fa, 0xffff, 0xddfe, 0x55f4, 0x00f0, 0x87f8, 0xddfe, 0xbafc,
  0xbbfc, 0x99fa, 0x87f9, 0x88f9, 0x66f6, 0x44f4, 0x66f5, 0x55f5,
  0x45f5, 0x55f6, 0x44f4, 0x32f2, 0x11f1, 0x22f2, 0x44f4, 0x77f8,
  0xddfe, 0xffff, 0xffff, 0xbcfb, 0x56f5, 0x22f2, 0x21f1, 0x11f0,
  0x32f1, 0x62f9, 0x81ff, 0x80ff, 0x71fe, 0x60fd, 0x60fe, 0x71ff,
  0x71ff, 0x70ff, 0x60ff, 0x70ff, 0x71ff, 0x71ff, 0x71ff, 0x81ff,
  0x70ff, 0x70fe, 0x71fb, 0x71fb, 0x71fa, 0x71f9, 0x73f5, 0x78f1,
  0x7af0, 0x8af1, 0x8af1, 0x8bf1, 0x9bf1, 0x8bf1, 0x9cf1, 0xadf1,
  0x8cf0, 0x6af0, 0x8bf1, 0xdefa, 0xfffc, 0xcdfa, 0x99f8, 0x9af8,
  0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9,
  0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xbcf9,
  0xa9f9, 0xa9f8, 0xa9f8, 0xa9f8, 0xa9f8, 0xa9f8, 0xa9f8, 0xa9f8,
  0xb9f8, 0xbaf8, 0xbaf8, 0xbaf8, 0xbaf8, 0xbaf8, 0xbaf8, 0xccf9,
  0x67f5, 0x34f3, 0x45f3, 0x45f2, 0x45f2, 0x45f4, 0x44f3, 0x34f3,
  0x34f3, 0x34f3, 0x34f2, 0x44f3, 0x44f3, 0x34f2, 0x45f3, 0x34f2,
  0x23f2, 0xddfe, 0xffff, 0xdefd, 0x55f5, 0x54f6, 0xbbfb, 0x88f8,
  0xccfd, 0xccfd, 0xddfe, 0xeeff, 0xeeff, 0xbbfb, 0x88f8, 0x66f6,
  0x55f5, 0x55f5, 0x55f5, 0x65f6, 0x87f9, 0xbafc, 0xccfd, 0xddfd,
  0xeeff, 0xeefe, 0xeefe, 0xffff, 0xffff, 0xbbfc, 0xaafa, 0x88f8,
  0x43f4, 0x32f4, 0x61fa, 0x70fe, 0x71ff, 0x70ff, 0x71ff, 0x70ff,
  0x70ff, 0x82ff, 0x82ff, 0x81ff, 0x70ff, 0x71ff, 0x71ff, 0x71ff,
  0x71ff, 0x71ff, 0x71fe, 0x71fc, 0x71fb, 0x71fa, 0x63f7, 0x76f3,
  0x79f0, 0x8af0, 0x8af1, 0x8bf1, 0x8bf1, 0x8bf1, 0x8bf1, 0x8cf0,
  0x9df1, 0xadf1, 0x8bf0, 0xbdf5, 0xfffd, 0xdefc, 0x9af8, 0x9af8,
  0x9af8, 0x9bf8, 0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9,
  0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9, 0xabf9,
  0x99f9, 0x99f8, 0xa9f8, 0xa9f8, 0xa9f8, 0xa9f8, 0xa9f8, 0xa9f8,
  0xb9f8, 0xb9f8, 0xb9f8, 0xbaf8, 0xbaf8, 0xbaf8, 0xcbf9, 0xabf9,
  0x45f3, 0x45f3, 0x45f3, 0x45f3, 0x34f2, 0x45f3, 0x55f4, 0x34f2,
  0x33f2, 0x44f3, 0x34f3, 0x44f3, 0x34f3, 0x44f3, 0x44f4, 0x45f4,
  0x34f2, 0x44f4, 0xeefe, 0xffff, 0xefff, 0x88f9, 0xaafb, 0x99fa,
  0xa9fa, 0xbcfb, 0xabfb, 0xbbfb, 0xbbfc, 0xffff, 0xffff, 0xffff,
  0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff,
  0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xdefe,
  0x92fe, 0x70ff, 0x71fd, 0x61fb, 0x61fa, 0x61fc, 0x71fe, 0x60fe,
  0x83fe, 0x83ff, 0x73fe, 0x83ff, 0x82ff, 0x70ff, 0x81ff, 0x81ff,
  0x71ff, 0x81ff, 0x71ff, 0x71fd, 0x71fd, 0x70fd, 0x61fb, 0x73f8,
  0x75f4, 0x67f0, 0x8af1, 0x9bf1, 0x9bf1, 0x8bf1, 0x8bf1, 0x7af1,
  0x8af1, 0xadf2, 0xbef5, 0xacf3, 0xcef7, 0xfffd, 0xcdfb, 0x89f7,
  0x9af8, 0x9af8, 0x9af8, 0x9bf8, 0xabf8, 0xabf8, 0xabf8, 0xabf8,
  0xabf8, 0xabf8, 0xabf8, 0xabf8, 0xabf8, 0xabf8, 0xabf9, 0xabf9,
  0x99f9, 0x99f8, 0xa9f8, 0xa9f8, 0xa9f8, 0xa9f9, 0xa9f8, 0xa9f8,
  0xa9f8, 0xb9f8, 0xb9f8, 0xbaf8, 0xbaf8, 0xaaf7, 0xccf9, 0x89f7,
  0x45f4, 0x45f4, 0x34f3, 0x44f3, 0x34f2, 0x34f3, 0x56f5, 0x88f8,
  0x67f6, 0x34f3, 0x44f3, 0x34f2, 0x34f3, 0x75f8, 0x54f5, 0x44f4,
  0x55f4, 0x13f0, 0x87f8, 0xffff, 0xeeff, 0xedfe, 0xccfd, 0xa9fc,
  0x53f8, 0xbbfc, 0xeffe, 0xacfa, 0x45f4, 0x76f7, 0x66f7, 0xbafa,
  0xddfd, 0xccfd, 0xccfd, 0xddfe, 0xeefe, 0xeefd, 0xdefe, 0xeefe,
  0xddfd, 0xeefe, 0xdefd, 0xccfb, 0xdefd, 0xeefe, 0xeffe, 0xeffd,
  0xbbfd, 0x93ff, 0x80ff, 0x70ff, 0x61fc, 0x71fd, 0x60ff, 0x72ff,
  0x83ff, 0x82ff, 0x83ff, 0x72fe, 0x83ff, 0x72ff, 0x60ff, 0x71ff,
  0x81ff, 0x81ff, 0x71ff, 0x81fe, 0x71fd, 0x71fc, 0x70fd, 0x71fc,
  0x72f9, 0x75f4, 0x78f0, 0x8af0, 0x8bf1, 0x7af1, 0x8af1, 0x8af1,
  0x79f1, 0x8af2, 0xacf4, 0x9cf2, 0x9cf2, 0xeffa, 0xfffd, 0xcdfa,
  0x9bf8, 0x89f8, 0x9af8, 0x9af8, 0x9af8, 0x9af8, 0x9af8, 0x9af8,
  0x9af8, 0x9af8, 0x9af8, 0x9bf8, 0xabf8, 0xabf8, 0xabf8, 0xabf9,
  0x99f9, 0x99f9, 0x99f9, 0x99f9, 0xa9f9, 0xa9f9, 0xa9f8, 0xa9f8,
  0xa9f8, 0xa9f8, 0xb9f8, 0xbaf8, 0xaaf8, 0xbaf8, 0xbbf9, 0x67f5,
  0x44f3, 0x45f3, 0x34f3, 0x34f3, 0x45f3, 0x45f3, 0x55f5, 0x76f7,
  0x77f6, 0x45f4, 0x34f3, 0x34f2, 0x34f2, 0x55f4, 0x44f4, 0x34f2,
  0x44f4, 0x44f5, 0x54f6, 0xccfd, 0xfeff, 0xecff, 0xcbfe, 0xcbfe,
  0xa8fc, 0x98fa, 0xddfd, 0xffff, 0x9af8, 0x00f0, 0x11f1, 0x22f1,
  0x22f1, 0x33f3, 0x44f3, 0x54f4, 0x54f4, 0x54f4, 0x54f4, 0x55f6,
  0x34f3, 0x44f3, 0x44f3, 0x44f3, 0x77f6, 0x67f6, 0x66f6, 0x97fa,
  0xa8fe, 0xa7fe, 0x94fe, 0x70ff, 0x71ff, 0x61ff, 0x60ff, 0x83ff,
  0x83ff, 0x82fe, 0x72ff, 0x83ff, 0x93ff, 0x82ff, 0x70ff, 0x71ff,
  0x81ff, 0x71ff, 0x71ff, 0x81ff, 0x71fe, 0x71fd, 0x71fd, 0x70fc,
  0x71fb, 0x74f5, 0x67f1, 0x78f1, 0x79f1, 0x8af1, 0x79f1, 0x68f1,
  0x79f1, 0x7af2, 0x8af1, 0x9cf0, 0x9cf1, 0xbdf5, 0xeffb, 0xdffa,
  0xcdfa, 0xabf9, 0x8af8, 0x9af8, 0x9af8, 0x9af8, 0x9af8, 0x9af8,
  0x9af8, 0x9af8, 0x9af8, 0x9af8, 0x9af8, 0x9bf8, 0x9bf8, 0xabf9,
  0x99f9, 0x99f9, 0x99f9, 0x99f9, 0x98f9, 0xa9f9, 0xa9f9, 0xa9f8,
  0xa9f8, 0xa9f8, 0xa9f8, 0xa9f8, 0xa9f8, 0xcbf9, 0x9af8, 0x45f3,
  0x44f3, 0x44f3, 0x55f4, 0x56f5, 0x34f2, 0x45f2, 0x45f4, 0x33f3,
  0x55f6, 0x66f6, 0x34f2, 0x34f2, 0x34f2, 0x35f2, 0x56f4, 0x44f3,
  0x44f4, 0x43f5, 0x41f7, 0x96fc, 0xedff, 0xb9ff, 0xa6fd, 0xcafe,
  0xcbfd, 0xddfe, 0xccfd, 0xedfe, 0xffff, 0x9af8, 0x23f2, 0x66f5,
  0x78f6, 0x34f2, 0x12f0, 0x01f0, 0x11f0, 0x21f1, 0x33f2, 0x44f3,
  0x66f6, 0x66f5, 0x12f1, 0x00f0, 0x11f0, 0x11f0, 0x11f0, 0x22f2,
  0x50f9, 0x91ff, 0x96fe, 0x72fd, 0x60fe, 0x61fe, 0x60ff, 0x72ff,
  0x84ff, 0x72ff, 0x72ff, 0x83ff, 0x93ff, 0x82ff, 0x70ff, 0x71ff,
  0x81ff, 0x81ff, 0x81ff, 0x81ff, 0x71ff, 0x71fe, 0x71fd, 0x81fc,
  0x71fc, 0x63f8, 0x66f1, 0x77f1, 0x78f2, 0x8af1, 0x89f1, 0x79f0,
  0x8af1, 0x8af1, 0x8af1, 0x9bf1, 0x9cf2, 0x9cf1, 0xdef8, 0xeffc,
  0xdef9, 0xdefa, 0x9af8, 0x9af8, 0x9af8, 0x9af8, 0x9af8, 0x9af8,
  0x9af8, 0x9af8, 0x9af8, 0x9af8, 0x9af8, 0x9af8, 0x9bf8, 0xabf9,
  0x99f9, 0x99f9, 0x99f9, 0x98f9, 0x98f9, 0x98f9, 0x98f9, 0xa9f9,
  0xa9f9, 0xa9f8, 0xa9f8, 0xa9f8, 0xaaf8, 0xbbf9, 0x79f6, 0x34f3,
  0x44f3, 0x34f2, 0x45f4, 0x56f5, 0x34f2, 0x55f4, 0x44f3, 0x44f3,
  0x45f4, 0x44f4, 0x44f3, 0x44f3, 0x34f2, 0x56f4, 0x67f6, 0x45f4,
  0x34f3, 0x33f3, 0x43f5, 0x74fa, 0x65f8, 0x53f7, 0xa8fd, 0xcafe,
  0xcafe, 0xedff, 0xeefe, 0xddfd, 0xeefe, 0xffff, 0xbcfb, 0xaafa,
  0xeefe, 0xdefc, 0xbcfb, 0x9af9, 0xaaf9, 0xbbfa, 0xddfd, 0xdefd,
  0xeffe, 0xffff, 0xccfc, 0x77f7, 0x55f5, 0x44f4, 0x22f1, 0x12f0,
  0x32f2, 0x50f8, 0x72fb, 0x86fb, 0x72fd, 0x60ff, 0x70ff, 0x70ff,
  0x83ff, 0x83ff, 0x82ff, 0x82ff, 0x82ff, 0x71ff, 0x70ff, 0x60ff,
  0x71ff, 0x71ff, 0x70ff, 0x71ff, 0x71ff, 0x81ff, 0x71fe, 0x71fd,
  0x70fc, 0x71fa, 0x84f7, 0x77f1, 0x68f0, 0x68f1, 0x89f1, 0x9bf1,
  0x9bf0, 0x8af0, 0x8bf1, 0x9bf2, 0x9cf3, 0x9cf1, 0xadf2, 0xeffb,
  0xdffc, 0xcdf9, 0xbcf9, 0x89f7, 0x9af8, 0x9af7, 0x9af7, 0x8af7,
  0x9af7, 0x9af8, 0x9af8, 0x9af8, 0x9af8, 0x9af8, 0x9af8, 0xabf8,
  0x99fa, 0x99f9, 0x99f9, 0x98f9, 0x98f9, 0x98f9, 0x98f9, 0x98f9,
  0xa9f9, 0xa9f8, 0xa9f8, 0xa9f8, 0xaaf8, 0xbbf9, 0x67f5, 0x34f3,
  0x45f4, 0x34f3, 0x34f3, 0x45f4, 0x34f3, 0x44f4, 0x55f5, 0x44f3,
  0x34f2, 0x34f2, 0x33f3, 0x65f6, 0x45f4, 0x45f4, 0x66f5, 0x45f4,
  0x44f4, 0x55f5, 0x56f5, 0x44f5, 0x00f0, 0x10f2, 0xa8fc, 0xcbfd,
  0xcbfe, 0xb9fd, 0xcbfe, 0xddfe, 0xddfe, 0xeefe, 0xffff, 0xeefe,
  0xddfd, 0xeefe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xeffe,
  0xeefe, 0xeefe, 0xffff, 0xffff, 0xeeff, 0xddfe, 0xbbfc, 0x56f6,
  0x23f1, 0x33f3, 0x51f8, 0x84fc, 0x73fc, 0x61fe, 0x71ff, 0x71ff,
  0x70ff, 0x82ff, 0x82ff, 0x71ff, 0x70ff, 0x70ff, 0x81ff, 0x81ff,
  0x71ff, 0x71ff, 0x81ff, 0x71ff, 0x61fe, 0x61fd, 0x71ff, 0x71fd,
  0x71fc, 0x81fb, 0x71fa, 0x74f8, 0x77f5, 0x78f2, 0x79f1, 0x8af2,
  0x9cf1, 0x9bf1, 0x9bf1, 0x9cf1, 0x9cf2, 0x9bf2, 0x8bf0, 0xbdf3,
  0xeffb, 0xbdfa, 0xabf8, 0x89f8, 0x89f7, 0x89f7, 0x89f7, 0x89f7,
  0x89f7, 0x89f7, 0x89f7, 0x8af7, 0x9af7, 0x9af8, 0x9af8, 0x9bf8,
  0x99fa, 0x99fa, 0x98f9, 0x98f9, 0x98f9, 0x98f9, 0x98f9, 0x98f9,
  0x99f8, 0xa9f8, 0xa9f8, 0xaaf8, 0xaaf8, 0xbbf9, 0x56f4, 0x23f2,
  0x44f3, 0x34f2, 0x34f3, 0x34f3, 0x45f3, 0x55f4, 0x55f5, 0x34f2,
  0x34f3, 0x34f3, 0x44f4, 0x55f5, 0x56f5, 0x45f4, 0x55f4, 0x44f4,
  0x44f4, 0x66f6, 0x56f6, 0x44f5, 0x00f0, 0x11f2, 0x65f8, 0xbafc,
  0xccfc, 0xbafc, 0x97fc, 0xcbfd, 0xeefe, 0xeefe, 0xdefd, 0xddfd,
  0xeefe, 0xddfd, 0xddfd, 0xdefd, 0xddfd, 0xddfd, 0xeefe, 0xeefe,
  0xddfd, 0xeefe, 0xeefe, 0xeefd, 0xeefe, 0xeefe, 0xeeff, 0xddfe,
  0x67f7, 0x23f2, 0x42f5, 0x62fa, 0x61fb, 0x72fc, 0x72fe, 0x83fe,
  0x71ff, 0x81ff, 0x82ff, 0x81ff, 0x80ff, 0x82ff, 0x92ff, 0x82ff,
  0x92ff, 0x92ff, 0x92ff, 0x82ff, 0x81ff, 0x71fe, 0x71fe, 0x82fe,
  0x82fd, 0x82fd, 0x83fb, 0x74f9, 0x76f8, 0x78f4, 0x79f1, 0x68f2,
  0x8bf2, 0xacf1, 0x9bf1, 0x9cf0, 0x9cf1, 0x9bf1, 0x8bf1, 0x9cf0,
  0xcef5, 0xdffa, 0x9af8, 0x89f7, 0x89f7, 0x89f7, 0x89f7, 0x89f7,
  0x89f7, 0x89f7, 0x89f7, 0x89f7, 0x8af7, 0x9af7, 0x9af7, 0x9bf8,
  0xaafb, 0x99fa, 0x98f9, 0x88f9, 0x88f9, 0x88f9, 0x98f9, 0x98f9,
  0x99f9, 0x99f8, 0xa9f8, 0xa9f8, 0xaaf8, 0xabf8, 0x45f3, 0x33f3,
  0x34f3, 0x34f2, 0x34f3, 0x34f2, 0x45f4, 0x66f6, 0x44f4, 0x34f2,
  0x33f2, 0x34f3, 0x45f4, 0x45f4, 0x55f5, 0x56f5, 0x55f5, 0x44f4,
  0x44f5, 0x44f5, 0x44f5, 0x22f2, 0x11f1, 0x11f1, 0x66f6, 0xddfd,
  0xdcfd, 0xddfc, 0xa9fb, 0x98fb, 0xdefd, 0xdefd, 0xdefd, 0xdefd,
  0xddfd, 0xedfe, 0xdefd, 0xdefd, 0xddfd, 0xddfd, 0xdefd, 0xdefd,
  0xeefe, 0xddfd, 0xddfd, 0xeefe, 0xeefe, 0xdefd, 0xddfd, 0xddfe,
  0xddfe, 0x77f7, 0x23f2, 0x43f5, 0x62f9, 0x72fb, 0x72fd, 0x71fe,
  0x71ff, 0x82ff, 0x82ff, 0x81ff, 0x81ff, 0x92ff, 0x82ff, 0x82ff,
  0x81ff, 0x92ff, 0x92ff, 0x92ff, 0x92ff, 0x80ff, 0x81ff, 0x82fd,
  0x82fd, 0x82fc, 0x71fc, 0x84fa, 0x66f4, 0x78f3, 0x8af1, 0x7af1,
  0x7af1, 0x9bf1, 0x9cf1, 0x9cf1, 0x9cf1, 0x9cf1, 0x8bf1, 0x8bf1,
  0x9cf2, 0xdff6, 0xdffa, 0x89f7, 0x78f7, 0x89f7, 0x89f7, 0x89f7,
  0x89f7, 0x89f7, 0x89f7, 0x89f7, 0x8af7, 0x8af7, 0x9af7, 0x9bf8,
  0xaafb, 0x99fa, 0x98fa, 0x88f9, 0x88f9, 0x88f9, 0x88f9, 0x88f9,
  0x98f9, 0x99f8, 0x99f8, 0xa9f8, 0xaaf8, 0x9af7, 0x34f3, 0x34f3,
  0x34f3, 0x44f3, 0x34f3, 0x34f3, 0x34f3, 0x55f5, 0x44f3, 0x34f2,
  0x34f3, 0x44f3, 0x45f4, 0x44f3, 0x33f3, 0x55f4, 0x56f5, 0x55f6,
  0x43f4, 0x44f5, 0x33f3, 0x00f0, 0x11f1, 0x33f3, 0x77f8, 0xdcfd,
  0xddfd, 0xddfd, 0xccfc, 0xbcfb, 0xcdfb, 0xddfd, 0xddfd, 0xddfd,
  0xddfd, 0xddfd, 0xeefe, 0xddfd, 0xddfd, 0xeefe, 0xdefd, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xdefd, 0xdefe, 0xddfd, 0xddfd, 0xddfd,
  0xdefe, 0xddfd, 0x67f6, 0x44f4, 0x52f7, 0x41f8, 0x71fc, 0x81fe,
  0x70ff, 0x82ff, 0x82ff, 0x81ff, 0x81ff, 0x93ff, 0x81ff, 0x81ff,
  0x92ff, 0x92ff, 0x92ff, 0x82ff, 0x81ff, 0x81ff, 0x92ff, 0x82fe,
  0x83fb, 0x72fa, 0x82fb, 0x72fa, 0x76f6, 0x89f3, 0x8af0, 0x8bf1,
  0x8bf1, 0x8af1, 0x8bf1, 0x9cf1, 0x8bf1, 0x9cf1, 0x9cf1, 0x7af1,
  0x8bf1, 0xbdf4, 0xfffa, 0xcdfa, 0x78f6, 0x89f7, 0x89f7, 0x89f7,
  0x89f7, 0x89f7, 0x89f7, 0x89f7, 0x8af7, 0x8af7, 0x9af7, 0x9bf8,
  0xaafb, 0x99fa, 0x98fa, 0x88f9, 0x88f9, 0x88f9, 0x88f9, 0x88f9,
  0x88f9, 0x99f9, 0x99f8, 0x9af8, 0xaaf9, 0x99f7, 0x44f3, 0x34f3,
  0x34f3, 0x34f3, 0x34f3, 0x34f3, 0x34f3, 0x44f3, 0x45f4, 0x34f3,
  0x34f3, 0x45f4, 0x55f4, 0x45f3, 0x23f2, 0x44f4, 0x55f6, 0x44f5,
  0x44f5, 0x44f5, 0x11f1, 0x00f0, 0x11f1, 0x55f5, 0x66f6, 0x77f7,
  0x9af9, 0xccfb, 0xddfd, 0xccfc, 0xccfc, 0xddfc, 0xddfc, 0xddfd,
  0xdcfd, 0xddfd, 0xdefd, 0xddfd, 0xddfd, 0xddfd, 0xeefe, 0xdefd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xddfd, 0xeefd, 0xbcfa, 0x55f5, 0x42f5, 0x20f4, 0x62fa, 0x83fe,
  0x81ff, 0x82ff, 0x82ff, 0x91ff, 0x81ff, 0x92ff, 0x81ff, 0x81ff,
  0x82ff, 0x82ff, 0x81ff, 0x92ff, 0x81ff, 0x81ff, 0x92ff, 0x92ff,
  0x82fd, 0x82fb, 0x81fb, 0x71f9, 0x74f7, 0x77f4, 0x89f1, 0x8bf0,
  0x8bf1, 0x8bf1, 0x8af1, 0x8bf1, 0x8af1, 0x8bf1, 0x9cf1, 0x8bf1,
  0x7bf0, 0x9cf1, 0xdff8, 0xeffb, 0x89f7, 0x78f6, 0x89f7, 0x89f7,
  0x89f7, 0x89f7, 0x89f7, 0x89f7, 0x8af7, 0x8af7, 0x9af7, 0x9bf8,
  0xaafb, 0x9afb, 0x99fa, 0x88fa, 0x88f9, 0x88f9, 0x88f9, 0x88f9,
  0x88f9, 0x89f9, 0x99f9, 0x9af8, 0xabf9, 0x89f7, 0x45f3, 0x44f3,
  0x44f3, 0x34f3, 0x33f2, 0x34f3, 0x34f3, 0x44f3, 0x44f3, 0x34f3,
  0x34f3, 0x45f4, 0x45f4, 0x45f4, 0x55f4, 0x55f5, 0x44f5, 0x33f4,
  0x33f4, 0x22f2, 0x12f1, 0x00f0, 0x22f2, 0x56f4, 0x45f3, 0x55f4,
  0x45f4, 0x88f8, 0xccfc, 0xddfd, 0xccfc, 0xcdfc, 0xddfc, 0xcdfc,
  0xccfc, 0xccfd, 0xddfd, 0xcdfc, 0xdefd, 0xddfd, 0xdcfd, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xccfc, 0xddfd, 0xcdfd, 0xcdfc, 0xddfc,
  0xdefd, 0xdefd, 0x9af9, 0x34f4, 0x32f3, 0x43f4, 0x52f9, 0x71fd,
  0x71ff, 0x72fe, 0x82fe, 0x81ff, 0x81ff, 0x82fe, 0x81ff, 0x81ff,
  0x82ff, 0x81ff, 0x81ff, 0x92ff, 0x81ff, 0x80ff, 0x82ff, 0x92ff,
  0x92ff, 0x92ff, 0x81fe, 0x82fc, 0x85f7, 0x77f3, 0x65f4, 0x77f4,
  0x8af2, 0x8bf0, 0x8af1, 0x68f0, 0x79f1, 0x7af1, 0x8bf1, 0x9cf1,
  0x8cf1, 0x8cf0, 0xbef5, 0xeffa, 0xabf9, 0x67f6, 0x89f7, 0x89f7,
  0x89f7, 0x89f7, 0x89f7, 0x89f7, 0x89f7, 0x8af7, 0x8af7, 0x9bf8,
  0xaafb, 0xaafb, 0x99fa, 0x88fa, 0x88f9, 0x88f9, 0x88f9, 0x88f9,
  0x89f9, 0x89f9, 0x99f9, 0x9af8, 0xabf9, 0x79f6, 0x34f3, 0x45f4,
  0x45f4, 0x45f4, 0x34f3, 0x34f3, 0x34f3, 0x34f3, 0x34f3, 0x33f3,
  0x34f3, 0x45f4, 0x44f4, 0x44f4, 0x55f5, 0x55f5, 0x44f5, 0x22f3,
  0x22f2, 0x33f3, 0x11f1, 0x12f1, 0x44f4, 0x44f4, 0x33f3, 0x34f3,
  0x44f4, 0x45f4, 0x88f8, 0xdcfd, 0xddfd, 0xcdfc, 0xddfc, 0xcdfc,
  0xcdfc, 0xccfc, 0xccfc, 0xccfc, 0xddfd, 0xddfd, 0xccfc, 0xccfd,
  0xddfd, 0xddfd, 0xddfd, 0xccfc, 0xccfc, 0xddfd, 0xcdfc, 0xcdfc,
  0xddfc, 0xddfc, 0x77f7, 0x22f2, 0x23f3, 0x33f4, 0x53f7, 0x61fb,
  0x70fe, 0x82fe, 0x83fd, 0x61fe, 0x81ff, 0x83fe, 0x71ff, 0x81ff,
  0x93ff, 0x92ff, 0x71ff, 0x83ff, 0x82ff, 0x81ff, 0x81ff, 0x82ff,
  0x82ff, 0x92fe, 0x93fe, 0x81fe, 0x84fa, 0x89f4, 0x77f4, 0x76f6,
  0x78f3, 0x7af1, 0x8bf1, 0x79f1, 0x69f1, 0x8af1, 0x8bf1, 0x9cf1,
  0x9cf1, 0x8bf0, 0xadf2, 0xdff9, 0xeffb, 0x9af8, 0x67f6, 0x78f6,
  0x79f6, 0x88f7, 0x89f7, 0x89f7, 0x89f7, 0x8af7, 0x8af7, 0x9af8,
  0xaafb, 0xaafb, 0x99fa, 0x88fa, 0x88f9, 0x88f9, 0x88f9, 0x89f9,
  0x89f9, 0x89f8, 0x89f8, 0x9af8, 0xabf9, 0x79f6, 0x34f3, 0x45f4,
  0x45f5, 0x55f5, 0x45f4, 0x44f4, 0x34f3, 0x34f3, 0x34f3, 0x34f3,
  0x33f3, 0x44f4, 0x34f3, 0x34f3, 0x44f5, 0x55f6, 0x54f7, 0x33f4,
  0x11f1, 0x22f1, 0x11f1, 0x44f4, 0x34f3, 0x23f2, 0x34f3, 0x33f3,
  0x33f3, 0x65f6, 0x66f6, 0x77f7, 0xddfd, 0xddfc, 0xccfc, 0xddfc,
  0xdefd, 0xcdfc, 0xccfc, 0xccfc, 0xccfd, 0xddfd, 0xddfd, 0xccfc,
  0xccfd, 0xccfd, 0xddfd, 0xddfd, 0xccfc, 0xcdfc, 0xcdfc, 0xcdfc,
  0xcdfc, 0xcdfc, 0x56f4, 0x22f2, 0x32f3, 0x32f3, 0x42f5, 0x41f8,
  0x61fc, 0x71fe, 0x72fd, 0x61fd, 0x61fe, 0x72ff, 0x71ff, 0x71ff,
  0x82ff, 0x81ff, 0x71ff, 0x72ff, 0x71ff, 0x71ff, 0x80ff, 0x81ff,
  0x71fe, 0x81fe, 0x81fd, 0x70fb, 0x73f9, 0x86f6, 0x87f4, 0x88f5,
  0x79f2, 0x79f1, 0x8af1, 0x9cf1, 0x8bf1, 0x7af1, 0x8bf1, 0x9cf1,
  0x9cf1, 0x9cf0, 0x8bf1, 0xcef7, 0xdff9, 0xdff7, 0xabf8, 0x67f6,
  0x78f6, 0x78f6, 0x78f6, 0x89f6, 0x89f7, 0x8af7, 0x8af7, 0x9af8,
  0xaafc, 0xa9fb, 0x99fb, 0x99fa, 0x88f9, 0x88f9, 0x89f9, 0x89f9,
  0x89f9, 0x89f8, 0x89f8, 0x8af8, 0x9bf9, 0x8af7, 0x55f4, 0x45f4,
  0x45f4, 0x45f4, 0x44f4, 0x45f4, 0x45f4, 0x34f3, 0x34f3, 0x44f3,
  0x33f3, 0x34f3, 0x34f3, 0x33f3, 0x34f4, 0x44f6, 0x54f6, 0x33f3,
  0x22f1, 0x12f0, 0x23f2, 0x44f4, 0x33f3, 0x23f3, 0x33f3, 0x33f3,
  0x22f2, 0x54f6, 0x75f8, 0x45f5, 0x89f9, 0xeefd, 0xcdfc, 0xccfc,
  0xddfd, 0xddfc, 0xddfc, 0xddfc, 0xccfc, 0xccfc, 0xddfd, 0xcdfd,
  0xccfc, 0xccfc, 0xcdfc, 0xddfd, 0xddfd, 0xcdfc, 0xcdfc, 0xcdfc,
  0xddfc, 0xbcfa, 0x78f6, 0x33f3, 0x10f1, 0x30f3, 0x41f5, 0x51f8,
  0x61fa, 0x60fc, 0x60fd, 0x71fc, 0x71fe, 0x60ff, 0x71ff, 0x71ff,
  0x70ff, 0x70ff, 0x71ff, 0x70ff, 0x70ff, 0x71ff, 0x81ff, 0x80ff,
  0x80ff, 0x80ff, 0x80fe, 0x80fd, 0x71f9, 0x66f4, 0x77f3, 0x88f3,
  0x7af1, 0x7af1, 0x7af1, 0x8bf1, 0x9cf1, 0x8bf1, 0x8bf0, 0x8cf1,
  0x9cf1, 0x9df1, 0x9cf0, 0xadf3, 0xfffc, 0xdff8, 0xdff8, 0xabf8,
  0x67f6, 0x78f6, 0x78f6, 0x79f6, 0x89f7, 0x89f7, 0x8af7, 0x9af7,
  0xbafc, 0xaafb, 0xa9fb, 0x99fa, 0x88fa, 0x88f9, 0x89f9, 0x89f9,
  0x89f9, 0x89f8, 0x89f8, 0x8af8, 0x9bf8, 0x8af7, 0x56f4, 0x55f4,
  0x44f3, 0x44f4, 0x45f5, 0x34f3, 0x45f4, 0x44f4, 0x44f4, 0x44f4,
  0x34f4, 0x33f3, 0x33f3, 0x34f4, 0x44f5, 0x65f7, 0x45f5, 0x23f2,
  0x34f1, 0x23f1, 0x44f4, 0x55f5, 0x33f3, 0x33f3, 0x33f3, 0x34f3,
  0x33f3, 0x23f3, 0x54f5, 0x55f6, 0x44f4, 0xbbfb, 0xeefd, 0xcdfc,
  0xbbfc, 0xccfc, 0xddfd, 0xcdfc, 0xcdfc, 0xccfc, 0xddfd, 0xddfd,
  0xddfd, 0xccfc, 0xccfc, 0xddfc, 0xcdfc, 0xcdfc, 0xcdfc, 0xcdfc,
  0xcdfc, 0xdefc, 0x78f7, 0x12f1, 0x21f2, 0x41f5, 0x51f8, 0x61f9,
  0x61fa, 0x61fb, 0x61fa, 0x61fb, 0x61fc, 0x71ff, 0x71ff, 0x81ff,
  0x71ff, 0x71ff, 0x71ff, 0x81ff, 0x71ff, 0x71ff, 0x81ff, 0x81ff,
  0x81ff, 0x81ff, 0x81fe, 0x81fd, 0x90fd, 0x84f8, 0x79f2, 0x79f0,
  0x7af1, 0x8bf1, 0x8af1, 0x7af1, 0x8af1, 0x8bf1, 0x8bf1, 0x9cf1,
  0x9cf1, 0x8bf1, 0x9cf0, 0xadf2, 0xdff9, 0xeffd, 0xcdf8, 0xeffa,
  0xacf8, 0x67f5, 0x78f6, 0x78f6, 0x89f6, 0x89f7, 0x8af7, 0x9af7,
  0xbafc, 0xaafb, 0xaafb, 0x99fa, 0x89fa, 0x88f9, 0x89f9, 0x89f9,
  0x89f8, 0x89f8, 0x89f8, 0x8af8, 0x8bf8, 0x8af7, 0x56f5, 0x55f4,
  0x45f3, 0x44f3, 0x45f4, 0x34f3, 0x44f4, 0x44f4, 0x44f3, 0x44f4,
  0x44f4, 0x33f3, 0x45f5, 0x55f5, 0x55f7, 0x76f8, 0x45f4, 0x34f3,
  0x23f1, 0x34f3, 0x77f8, 0x44f4, 0x34f3, 0x33f3, 0x33f3, 0x33f3,
  0x33f3, 0x33f3, 0x33f3, 0x55f5, 0x55f6, 0x87f8, 0xddfd, 0xdefd,
  0xcdfc, 0xccfc, 0xccfc, 0xccfc, 0xddfc, 0xccfc, 0xcdfd, 0xddfd,
  0xddfd, 0xcdfd, 0xccfc, 0xddfc, 0xcdfc, 0xccfc, 0xcdfc, 0xcdfc,
  0xcdfc, 0xddfc, 0x56f5, 0x12f1, 0x12f1, 0x21f3, 0x51f7, 0x61fa,
  0x51f9, 0x51f8, 0x51f8, 0x61fa, 0x61fc, 0x71fd, 0x71fe, 0x71ff,
  0x81ff, 0x81ff, 0x71fe, 0x71ff, 0x81ff, 0x81ff, 0x81ff, 0x81ff,
  0x71fe, 0x71fe, 0x81fe, 0x81fd, 0x71fb, 0x81fb, 0x97f6, 0x8af0,
  0x8af1, 0x9bf1, 0x8bf1, 0x7af1, 0x79f1, 0x7af0, 0x8bf1, 0x8bf1,
  0x9cf1, 0x9cf1, 0x9cf1, 0xbdf4, 0xdff8, 0xdff8, 0xbdf6, 0xbdf6,
  0xeffb, 0x9af7, 0x67f6, 0x78f6, 0x89f6, 0x89f7, 0x8af7, 0x9af7,
  0xbbfc, 0xaafc, 0xaafb, 0x99fb, 0x99fa, 0x89f9, 0x89f9, 0x89f9,
  0x89f9, 0x8af8, 0x8af8, 0x8af8, 0x8af7, 0x8af7, 0x56f5, 0x55f5,
  0x45f4, 0x34f3, 0x44f4, 0x44f4, 0x44f4, 0x44f4, 0x34f3, 0x44f4,
  0x44f4, 0x33f3, 0x66f6, 0x87f9, 0x77f9, 0x66f7, 0x45f5, 0x33f3,
  0x12f1, 0x54f5, 0x55f6, 0x33f2, 0x44f4, 0x33f3, 0x33f3, 0x33f3,
  0x33f3, 0x33f3, 0x33f3, 0x33f3, 0x55f5, 0x43f4, 0x99fa, 0xddfd,
  0xdefc, 0xcdfc, 0xccfc, 0xccfd, 0xddfd, 0xccfc, 0xccfc, 0xddfd,
  0xddfd, 0xcdfd, 0xccfc, 0xddfd, 0xcdfc, 0xccfc, 0xcdfc, 0xcdfc,
  0xbcfb, 0x77f6, 0x23f1, 0x12f1, 0x12f1, 0x22f1, 0x32f3, 0x32f4,
  0x31f5, 0x42f5, 0x51f6, 0x61fa, 0x71fd, 0x71fd, 0x71fd, 0x71fe,
  0x81ff, 0x81ff, 0x81ff, 0x81ff, 0x81ff, 0x81ff, 0x71ff, 0x71ff,
  0x71fe, 0x71fd, 0x71fd, 0x81fd, 0x81fb, 0x72f8, 0x85f9, 0x98f4,
  0x8af1, 0x8bf1, 0x8bf1, 0x7af1, 0x7af1, 0x7bf1, 0x8cf0, 0x9cf1,
  0x9cf0, 0x9cf0, 0x9cf1, 0x8cf1, 0xacf6, 0xdff7, 0xdff8, 0xbdf8,
  0xdefa, 0xbcf9, 0x67f5, 0x78f6, 0x79f6, 0x89f7, 0x8af7, 0x9af7,
  0xbbfc, 0xaafc, 0xaafb, 0x9afb, 0x99fa, 0x89fa, 0x89f9, 0x8af9,
  0x8af9, 0x8af8, 0x8af8, 0x8af8, 0x8af7, 0x8bf7, 0x57f5, 0x44f4,
  0x44f3, 0x34f3, 0x44f4, 0x45f4, 0x44f4, 0x44f4, 0x34f4, 0x33f3,
  0x55f5, 0x44f5, 0x56f6, 0x66f7, 0x55f6, 0x65f6, 0x55f6, 0x22f2,
  0x33f3, 0x55f6, 0x23f2, 0x33f3, 0x34f4, 0x34f3, 0x33f3, 0x34f3,
  0x34f3, 0x33f3, 0x34f3, 0x23f2, 0x33f3, 0x33f3, 0x55f6, 0xccfc,
  0xcdfc, 0xddfc, 0xccfc, 0xccfc, 0xccfd, 0xccfd, 0xcdfd, 0xcdfd,
  0xcdfd, 0xccfc, 0xccfc, 0xcdfc, 0xcdfc, 0xccfc, 0xccfc, 0xccfc,
  0x88f7, 0x23f1, 0x22f1, 0x12f1, 0x12f1, 0x22f1, 0x33f2, 0x22f1,
  0x22f1, 0x43f3, 0x52f5, 0x61f9, 0x71fc, 0x71fc, 0x71fc, 0x81fe,
  0x81ff, 0x81ff, 0x81ff, 0x81ff, 0x81ff, 0x81ff, 0x81ff, 0x81ff,
  0x81ff, 0x71fd, 0x71fb, 0x81fc, 0x90fd, 0x72fa, 0x76f6, 0x88f4,
  0x8af1, 0x8af1, 0x8bf1, 0x7af1, 0x7af0, 0x7af1, 0x8bf1, 0x9cf0,
  0x9cf1, 0x9cf1, 0x9df0, 0xadf0, 0x48f0, 0x79f3, 0xfffb, 0xfffc,
  0xdefc, 0xccfb, 0x78f6, 0x78f6, 0x89f6, 0x89f7, 0x8af7, 0x9af7,
  0xbbfc, 0xaafb, 0xaafb, 0x9afa, 0x99fa, 0x99fa, 0x8af9, 0x8af9,
  0x8af9, 0x8af8, 0x8af8, 0x8af8, 0x8af7, 0x9bf7, 0x68f5, 0x45f4,
  0x45f4, 0x45f3, 0x44f3, 0x55f5, 0x45f5, 0x44f4, 0x44f4, 0x33f3,
  0x44f4, 0x66f6, 0x67f7, 0x55f5, 0x44f5, 0x65f7, 0x55f6, 0x22f2,
  0x44f4, 0x44f4, 0x33f2, 0x34f3, 0x34f3, 0x34f4, 0x33f3, 0x34f4,
  0x45f4, 0x33f3, 0x33f3, 0x33f3, 0x23f3, 0x44f4, 0x34f4, 0x88f9,
  0xccfc, 0xccfc, 0xcdfc, 0xccfc, 0xccfc, 0xbcfc, 0xccfc, 0xddfd,
  0xcdfd, 0xccfd, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xcdfc, 0xabfa,
  0x34f2, 0x23f1, 0x33f2, 0x12f1, 0x22f1, 0x23f1, 0x22f1, 0x22f1,
  0x33f2, 0x43f4, 0x61f8, 0x71fb, 0x71fc, 0x71fc, 0x71fc, 0x81fe,
  0x81ff, 0x81ff, 0x81ff, 0x81ff, 0x81ff, 0x81ff, 0x81ff, 0x81ff,
  0x81ff, 0x70fe, 0x71fd, 0x81fb, 0x80fc, 0x93fb, 0x87f6, 0x79f1,
  0x8af0, 0x8af1, 0x68f1, 0x68f1, 0x7af1, 0x7af1, 0x7af1, 0x7af1,
  0x9cf1, 0x9df1, 0x8cf1, 0x9cf1, 0x9cf1, 0x47f0, 0x8af4, 0xfff9,
  0xeffc, 0xddfc, 0x89f8, 0x78f5, 0x89f6, 0x89f6, 0x8af7, 0x9af7,
  0xbbfc, 0xaafb, 0xaafb, 0x9afa, 0x9afa, 0x9afa, 0x9afa, 0x9af9,
  0x9af9, 0x9af9, 0x9bf8, 0x9bf8, 0x8bf8, 0x9cf8, 0x79f6, 0x45f4,
  0x66f6, 0x56f6, 0x45f3, 0x44f4, 0x44f4, 0x44f4, 0x45f5, 0x44f4,
  0x44f4, 0x44f4, 0x44f5, 0x65f7, 0x65f7, 0x54f6, 0x55f6, 0x33f3,
  0x55f5, 0x34f4, 0x34f3, 0x34f3, 0x34f3, 0x34f3, 0x33f3, 0x33f4,
  0x34f4, 0x33f3, 0x33f3, 0x33f3, 0x23f3, 0x23f3, 0x34f3, 0x22f3,
  0x98fa, 0xddfd, 0xccfc, 0xccfc, 0xccfc, 0xbcfc, 0xbcfc, 0xcbfc,
  0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xbbfb, 0xbcfb, 0xccfb, 0x67f5,
  0x12f1, 0x34f3, 0x33f2, 0x11f0, 0x22f1, 0x23f2, 0x22f2, 0x22f2,
  0x33f2, 0x43f4, 0x61f8, 0x71fc, 0x71fd, 0x71fc, 0x71fd, 0x81ff,
  0x81ff, 0x80ff, 0x81ff, 0x81ff, 0x71ff, 0x81ff, 0x81ff, 0x81ff,
  0x81ff, 0x71fd, 0x81fd, 0x81fc, 0x73f7, 0x85f8, 0x97f6, 0x7af0,
  0x7af0, 0x7af1, 0x68f1, 0x57f1, 0x68f1, 0x8bf1, 0x7af1, 0x7af1,
  0x8bf1, 0x9cf1, 0x9df1, 0x8bf1, 0x8bf1, 0x8bf0, 0x69f0, 0x9cf2,
  0xeff8, 0xcdfa, 0x77f6, 0x79f6, 0x89f6, 0x89f6, 0x8af7, 0x9af7,
  0xbbfc, 0xaafb, 0xaafb, 0xaafb, 0xaafb, 0x9afa, 0x9afa, 0x9bfa,
  0x9bf9, 0x9bf9, 0x9bf9, 0x9bf8, 0x9bf8, 0xacf8, 0x8af7, 0x45f3,
  0x66f6, 0x66f6, 0x55f4, 0x45f4, 0x34f3, 0x44f4, 0x55f5, 0x55f5,
  0x55f5, 0x44f5, 0x65f7, 0x89f7, 0x8af7, 0x77f8, 0x77f8, 0x88f6,
  0x79f7, 0x33f4, 0x33f3, 0x34f4, 0x33f3, 0x33f3, 0x34f3, 0x33f3,
  0x33f3, 0x33f3, 0x33f3, 0x23f3, 0x33f3, 0x23f3, 0x33f3, 0x33f3,
  0x43f5, 0xbbfc, 0xccfc, 0xccfd, 0xccfc, 0xbcfc, 0xbbfc, 0xccfc,
  0xccfc, 0xbbfc, 0xccfc, 0xbcfb, 0xbcfb, 0xcdfc, 0xabf9, 0x34f2,
  0x23f1, 0x33f2, 0x23f2, 0x12f1, 0x23f1, 0x23f1, 0x33f2, 0x32f3,
  0x32f3, 0x43f4, 0x52f7, 0x61fb, 0x61fb, 0x61fb, 0x71fc, 0x81fe,
  0x81ff, 0x81ff, 0x81ff, 0x81ff, 0x71ff, 0x71ff, 0x81ff, 0x81ff,
  0x71ff, 0x81fd, 0x81fc, 0x81fc, 0x75f7, 0x78f4, 0x79f2, 0x7af0,
  0x8bf1, 0x8bf1, 0x7af1, 0x68f1, 0x47f1, 0x68f1, 0x8af1, 0x7af1,
  0x69f1, 0x8bf1, 0xadf1, 0xadf1, 0x8bf1, 0x8bf0, 0x8bf0, 0x7bf0,
  0xadf3, 0xdff9, 0x9af7, 0x78f6, 0x89f6, 0x89f6, 0x8af7, 0x9af7,
  0xbbfc, 0xbbfc, 0xbbfb, 0xaafb, 0xabfb, 0xabfb, 0xabfa, 0xabfa,
  0xabfa, 0xabf9, 0x9bf9, 0x9bf9, 0x9bf9, 0xacf8, 0xacf8, 0x56f4,
  0x44f4, 0x77f7, 0x77f7, 0x45f4, 0x44f4, 0x44f4, 0x55f5, 0x55f5,
  0x86f8, 0x99f8, 0xacf7, 0x9cf6, 0x9cf6, 0x9cf7, 0x9bf7, 0xadf7,
  0x8af6, 0x44f4, 0x33f3, 0x33f3, 0x33f3, 0x34f4, 0x34f4, 0x33f3,
  0x33f3, 0x33f3, 0x33f3, 0x33f3, 0x33f3, 0x33f3, 0x23f3, 0x34f4,
  0x22f2, 0x87f8, 0xcdfc, 0xbbfb, 0xbcfc, 0xbbfc, 0xbbfb, 0xccfc,
  0xbcfc, 0xabfb, 0xbbfb, 0xabfa, 0xabfa, 0xabfa, 0x56f5, 0x22f1,
  0x23f2, 0x23f2, 0x23f2, 0x23f2, 0x23f2, 0x33f2, 0x33f2, 0x22f2,
  0x30f4, 0x41f6, 0x52f7, 0x51f8, 0x51f9, 0x61fa, 0x61fc, 0x71fd,
  0x71fe, 0x81ff, 0x81ff, 0x81ff, 0x70ff, 0x81ff, 0x81ff, 0x81ff,
  0x71fe, 0x71fe, 0x81fc, 0x72f9, 0x85f7, 0x89f3, 0x7af0, 0x8af0,
  0x8bf1, 0x8bf1, 0x8bf1, 0x7af1, 0x7af1, 0x69f1, 0x69f1, 0x8bf1,
  0x7af1, 0x7af1, 0x8bf1, 0x9cf1, 0x9df1, 0x9cf1, 0x8bf1, 0x8bf0,
  0x9cf0, 0xdff8, 0xdefa, 0x89f7, 0x89f6, 0x89f6, 0x8af7, 0x9af7,
  0xccfc, 0xbbfc, 0xbbfb, 0xbbfb, 0xbbfb, 0xbbfb, 0xbbfb, 0xabfb,
  0xabfa, 0xabfa, 0xacfa, 0xacf9, 0xacf9, 0xacf9, 0xbdf9, 0x79f6,
  0x34f3, 0x77f7, 0x78f8, 0x56f6, 0x45f4, 0x55f5, 0x34f3, 0x54f6,
  0x88f9, 0x9df6, 0x9df6, 0x9cf6, 0x9bf6, 0x8bf5, 0x8bf5, 0x9cf6,
  0x8af7, 0x55f6, 0x44f4, 0x33f3, 0x44f4, 0x44f4, 0x33f3, 0x33f3,
  0x33f3, 0x23f3, 0x33f3, 0x33f3, 0x33f3, 0x33f3, 0x33f3, 0x33f3,
  0x23f3, 0x33f4, 0x88f9, 0xbcfb, 0xccfc, 0xbbfb, 0xbbfb, 0xbbfc,
  0xbbfc, 0xabfb, 0xbbfb, 0xabfa, 0x89f8, 0x67f6, 0x23f2, 0x23f1,
  0x23f2, 0x22f2, 0x23f2, 0x23f2, 0x33f2, 0x33f2, 0x32f2, 0x32f3,
  0x41f6, 0x50f9, 0x41f7, 0x51f7, 0x51f9, 0x61f9, 0x71fc, 0x71fd,
  0x70fe, 0x81ff, 0x81ff, 0x71ff, 0x70ff, 0x71ff, 0x81ff, 0x70ff,
  0x71fe, 0x71fd, 0x80fd, 0x83fa, 0x79f2, 0x7af0, 0x8af1, 0x8af1,
  0x8bf0, 0x8bf1, 0x8bf1, 0x8bf1, 0x8cf1, 0x9df1, 0x8bf1, 0x7af1,
  0x8bf1, 0x8bf1, 0x8bf0, 0x8bf0, 0xadf1, 0x9df1, 0x9cf1, 0x8cf0,
  0x8bf0, 0xcff5, 0xeffc, 0x89f7, 0x78f6, 0x8af6, 0x8af7, 0x9af7,
  0xccfc, 0xbbfc, 0xbbfc, 0xbbfb, 0xbbfb, 0xbbfb, 0xbbfb, 0xbbfb,
  0xbbfb, 0xacfa, 0xacfa, 0xacfa, 0xacf9, 0xacf9, 0xbdfa, 0x9bf8,
  0x44f4, 0x44f4, 0x55f5, 0x66f6, 0x66f6, 0x56f5, 0x34f3, 0x54f6,
  0x9af8, 0xadf7, 0x9cf7, 0x9cf7, 0x9bf6, 0x9bf6, 0x9bf6, 0x9cf6,
  0x89f7, 0x55f7, 0x55f6, 0x34f3, 0x44f4, 0x44f4, 0x34f4, 0x33f4,
  0x33f3, 0x23f3, 0x33f3, 0x33f3, 0x22f3, 0x33f3, 0x33f4, 0x22f3,
  0x33f3, 0x22f3, 0x44f5, 0xbbfb, 0xbcfc, 0xbcfc, 0xabfb, 0xbbfc,
  0xbbfb, 0xbcfb, 0xbcfb, 0x67f6, 0x34f3, 0x34f3, 0x22f1, 0x23f2,
  0x23f2, 0x22f2, 0x22f2, 0x23f2, 0x33f2, 0x32f2, 0x31f3, 0x41f4,
  0x51f7, 0x61fa, 0x51fa, 0x52f6, 0x52f6, 0x61f9, 0x61fa, 0x61fc,
  0x81ff, 0x81ff, 0x81ff, 0x81ff, 0x81ff, 0x71ff, 0x71ff, 0x81ff,
  0x81ff, 0x81fe, 0x71fc, 0x81fb, 0x88f3, 0x8bf0, 0x8bf1, 0x7af1,
  0x8af1, 0x9bf1, 0x8af1, 0x7af1, 0x8bf1, 0x9cf1, 0x9df1, 0x8cf1,
  0x7bf1, 0x8cf1, 0x8cf1, 0x8cf1, 0x9cf1, 0x9df1, 0x8cf1, 0x9df1,
  0x9cf0, 0x9df1, 0xeff9, 0xbdf9, 0x78f5, 0x89f6, 0x8af7, 0x9af7,
  0xccfc, 0xcbfc, 0xcbfc, 0xbbfc, 0xbcfc, 0xbcfb, 0xbcfb, 0xbcfb,
  0xbcfb, 0xbcfb, 0xbcfa, 0xacfa, 0xbcfa, 0xbcfa, 0xbcf9, 0xbdfa,
  0x67f5, 0x23f3, 0x44f4, 0x45f4, 0x55f5, 0x55f5, 0x45f5, 0x66f7,
  0x9af8, 0xadf8, 0x9cf7, 0x9cf7, 0x9bf7, 0x9bf6, 0x9cf6, 0xadf8,
  0x77f7, 0x44f5, 0x56f6, 0x34f4, 0x33f3, 0x33f3, 0x34f4, 0x33f4,
  0x33f3, 0x33f3, 0x33f3, 0x33f3, 0x33f3, 0x23f3, 0x33f3, 0x33f3,
  0x22f3, 0x33f3, 0x33f4, 0x88f9, 0xabfa, 0xbbfb, 0xaafb, 0xaafb,
  0xaafa, 0xaafa, 0x67f6, 0x12f1, 0x12f1, 0x23f1, 0x23f1, 0x23f2,
  0x33f2, 0x22f1, 0x22f1, 0x22f2, 0x22f1, 0x22f2, 0x42f5, 0x41f4,
  0x31f4, 0x51f8, 0x61f9, 0x52f6, 0x52f5, 0x51f7, 0x61fa, 0x61fc,
  0x71fe, 0x81ff, 0x81ff, 0x81ff, 0x91ff, 0x91ff, 0x71fe, 0x71fe,
  0x81ff, 0x81ff, 0x71fd, 0x70fc, 0x81fa, 0x77f3, 0x7af0, 0x8bf0,
  0x79f1, 0x89f2, 0x9bf1, 0x8bf0, 0x7af1, 0x8bf1, 0x9cf1, 0x9cf1,
  0x7af1, 0x7af1, 0x9cf1, 0x8cf1, 0x8bf1, 0x8bf1, 0x9cf1, 0x9df0,
  0xadf0, 0x8cf0, 0xcef6, 0xfffe, 0xbcf8, 0x78f6, 0x89f6, 0x9af7,
  0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xbcfb, 0xbcfb,
  0xbcfb, 0xbcfb, 0xbcfb, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xcefb,
  0x79f6, 0x22f2, 0x44f4, 0x45f4, 0x66f5, 0x55f5, 0x45f5, 0x65f7,
  0x89f7, 0xadf8, 0xacf8, 0xadf8, 0xacf7, 0xacf7, 0x9bf7, 0x77f6,
  0x33f4, 0x55f6, 0x45f5, 0x33f3, 0x33f4, 0x33f3, 0x33f3, 0x33f3,
  0x33f3, 0x33f3, 0x33f3, 0x33f3, 0x33f3, 0x33f3, 0x33f3, 0x33f3,
  0x33f4, 0x33f4, 0x44f5, 0x87f9, 0x9af9, 0xaafa, 0xaafb, 0x99fa,
  0x88f9, 0x56f6, 0x22f2, 0x22f1, 0x33f2, 0x23f2, 0x22f2, 0x22f2,
  0x23f2, 0x22f1, 0x22f1, 0x22f1, 0x22f1, 0x22f1, 0x21f3, 0x31f3,
  0x22f3, 0x32f4, 0x52f6, 0x41f5, 0x51f8, 0x61f9, 0x61fa, 0x71fc,
  0x71fe, 0x70ff, 0x81ff, 0x80ff, 0x81ff, 0x81ff, 0x81ff, 0x61fe,
  0x71fe, 0x81fe, 0x81fe, 0x81fc, 0x70fb, 0x72f7, 0x78f1, 0x89f1,
  0x89f1, 0x89f1, 0x8bf1, 0x9cf0, 0x8bf1, 0x8bf1, 0x8bf1, 0x8cf1,
  0x7af1, 0x46f1, 0x68f1, 0x8cf1, 0x8cf1, 0x7af1, 0x7af1, 0x9df1,
  0x9df1, 0x9df0, 0xbef3, 0xfffe, 0xfffc, 0xabf8, 0x8af7, 0x9af7,
  0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc,
  0xccfc, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfa, 0xbcfa, 0xbdfa,
  0xbdf9, 0x45f3, 0x33f3, 0x44f4, 0x55f5, 0x45f4, 0x34f3, 0x44f5,
  0x88f8, 0xbdf9, 0x8af7, 0x56f4, 0x67f5, 0x88f7, 0x88f8, 0x66f6,
  0x66f6, 0x66f7, 0x66f7, 0x34f4, 0x33f3, 0x33f3, 0x44f4, 0x33f4,
  0x33f3, 0x33f3, 0x33f3, 0x33f3, 0x23f3, 0x33f3, 0x33f3, 0x32f3,
  0x22f3, 0x33f4, 0x44f5, 0x66f7, 0x99f9, 0x99f9, 0x99fa, 0x99fa,
  0x67f7, 0x22f2, 0x12f1, 0x23f2, 0x33f2, 0x22f1, 0x22f1, 0x22f1,
  0x22f1, 0x22f1, 0x22f1, 0x22f1, 0x33f2, 0x32f2, 0x11f1, 0x32f4,
  0x42f4, 0x42f3, 0x42f5, 0x51f7, 0x61f9, 0x71fb, 0x61fa, 0x61fb,
  0x71fe, 0x71ff, 0x81ff, 0x81ff, 0x80ff, 0x71ff, 0x81ff, 0x81fe,
  0x71fe, 0x71fe, 0x81fd, 0x71fc, 0x81fb, 0x81fa, 0x86f5, 0x78f3,
  0x88f2, 0x7af1, 0x7af0, 0x8bf1, 0x9cf1, 0x8cf1, 0x7af1, 0x8af1,
  0x7af1, 0x68f1, 0x46f0, 0x58f1, 0x9cf1, 0x8cf1, 0x7bf1, 0x8bf1,
  0x9cf1, 0xadf0, 0x9ef0, 0xdff8, 0xfffe, 0xdffa, 0xbcfa, 0x99f8,
  0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc,
  0xccfc, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfa, 0xbcfa,
  0xdefb, 0x79f7, 0x22f2, 0x44f4, 0x44f4, 0x55f5, 0x44f4, 0x44f5,
  0x77f7, 0xcdf9, 0x78f7, 0x32f5, 0x33f4, 0x33f3, 0x45f5, 0x67f6,
  0x78f7, 0x77f7, 0x77f8, 0x45f5, 0x44f4, 0x44f4, 0x33f4, 0x44f4,
  0x44f4, 0x33f4, 0x33f3, 0x33f3, 0x33f3, 0x33f3, 0x33f4, 0x33f3,
  0x22f3, 0x33f4, 0x43f5, 0x66f7, 0x99f9, 0x88f8, 0x77f8, 0x66f7,
  0x33f3, 0x12f1, 0x23f2, 0x23f2, 0x22f2, 0x22f1, 0x22f1, 0x22f1,
  0x22f2, 0x22f1, 0x22f1, 0x33f2, 0x22f1, 0x22f2, 0x11f1, 0x21f3,
  0x41f6, 0x41f5, 0x41f6, 0x61f9, 0x51f9, 0x61fa, 0x61fb, 0x61fb,
  0x61fd, 0x71ff, 0x71ff, 0x71ff, 0x81ff, 0x81ff, 0x71fe, 0x71fe,
  0x71fd, 0x71fd, 0x81fd, 0x81fc, 0x71fa, 0x81f9, 0x83f8, 0x76f6,
  0x77f4, 0x79f1, 0x7af0, 0x7af1, 0x7af1, 0x8bf1, 0x8bf1, 0x7af1,
  0x8bf1, 0x8bf1, 0x7af1, 0x58f1, 0x79f1, 0x9cf1, 0x9df1, 0x9cf1,
  0x8cf1, 0x9df1, 0x9df0, 0xbef3, 0xfffc, 0xdef9, 0xbcf9, 0xabfb,
  0xdcfd, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc,
  0xccfc, 0xccfc, 0xccfb, 0xbcfb, 0xbcfb, 0xbdfb, 0xbcfb, 0xbcfb,
  0xcdfb, 0xcefb, 0x56f4, 0x22f2, 0x44f4, 0x66f6, 0x66f6, 0x56f5,
  0x76f7, 0xbbf9, 0xbcfa, 0x87fa, 0x65f8, 0x65f7, 0x44f5, 0x44f4,
  0x55f5, 0x66f6, 0x66f6, 0x66f7, 0x56f5, 0x45f4, 0x45f4, 0x44f4,
  0x44f4, 0x44f4, 0x34f4, 0x33f4, 0x44f4, 0x44f4, 0x34f4, 0x33f4,
  0x44f5, 0x55f6, 0x33f4, 0x66f7, 0x99f9, 0x77f7, 0x45f4, 0x23f2,
  0x22f2, 0x22f2, 0x23f2, 0x23f2, 0x22f2, 0x12f1, 0x22f1, 0x22f1,
  0x22f1, 0x22f1, 0x23f1, 0x33f2, 0x22f2, 0x11f1, 0x22f2, 0x21f1,
  0x32f4, 0x52f7, 0x51f7, 0x61f8, 0x61f9, 0x61f9, 0x61fa, 0x61fc,
  0x61fd, 0x71fe, 0x71ff, 0x71ff, 0x71ff, 0x81ff, 0x81fe, 0x71fd,
  0x71fc, 0x71fc, 0x71fc, 0x81fb, 0x71f8, 0x71f7, 0x74f7, 0x76f5,
  0x78f3, 0x7af1, 0x7af1, 0x79f1, 0x69f1, 0x68f1, 0x8bf1, 0x8cf1,
  0x8bf1, 0x8cf1, 0x8cf1, 0x7bf1, 0x7af1, 0x7af1, 0x8bf1, 0x8cf1,
  0x9df1, 0x9cf1, 0x8cf0, 0xaef2, 0xdff9, 0xdff9, 0xbdf7, 0xcdfd,
  0xdcfd, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc,
  0xccfc, 0xccfc, 0xccfc, 0xcdfb, 0xcdfb, 0xccfb, 0xccfb, 0xcdfb,
  0xccfb, 0xdefc, 0x9bf9, 0x12f2, 0x33f3, 0x55f5, 0x87f8, 0x77f7,
  0x55f6, 0xaaf9, 0xbdfa, 0xbcfa, 0x99fa, 0x98fa, 0x87fa, 0x76f8,
  0x66f8, 0x55f6, 0x44f5, 0x65f7, 0x45f5, 0x34f4, 0x44f4, 0x44f4,
  0x34f4, 0x33f3, 0x33f3, 0x33f3, 0x33f4, 0x44f5, 0x33f4, 0x23f3,
  0x44f4, 0x44f5, 0x34f4, 0x66f7, 0x78f8, 0x66f6, 0x22f3, 0x22f2,
  0x22f2, 0x22f2, 0x23f2, 0x23f2, 0x12f1, 0x12f1, 0x23f1, 0x23f1,
  0x22f1, 0x23f2, 0x22f1, 0x22f2, 0x22f1, 0x12f1, 0x22f2, 0x22f2,
  0x23f1, 0x44f4, 0x54f7, 0x52f6, 0x50f7, 0x61f9, 0x61fc, 0x61fc,
  0x71fe, 0x70fe, 0x81ff, 0x81ff, 0x71fe, 0x71fe, 0x81fe, 0x71fc,
  0x61fb, 0x71fb, 0x71fb, 0x70fa, 0x71f7, 0x72f6, 0x85f6, 0x88f3,
  0x8bf1, 0x8bf0, 0x7bf1, 0x7af0, 0x7af1, 0x7af1, 0x7af0, 0x9cf1,
  0x8cf1, 0x8bf1, 0x9df1, 0x9df0, 0x8cf1, 0x7bf1, 0x8bf1, 0x8bf1,
  0x8cf1, 0x9df1, 0x7bf1, 0x8bf2, 0xdff7, 0xfffd, 0xdff9, 0xbcf9,
  0xddfd, 0xdcfd, 0xdcfd, 0xdcfd, 0xdcfc, 0xdcfc, 0xddfc, 0xccfc,
  0xcdfc, 0xccfc, 0xccfc, 0xcdfc, 0xcdfc, 0xcdfc, 0xcdfb, 0xcdfb,
  0xcdfb, 0xcdfb, 0xdefc, 0x67f5, 0x22f2, 0x44f4, 0x44f4, 0x66f6,
  0x66f6, 0x99f9, 0xcdfb, 0xbcf9, 0xbcfa, 0xbcfa, 0xaafa, 0xa9fa,
  0x98fa, 0x87f9, 0x65f8, 0x75f9, 0x54f6, 0x33f4, 0x33f4, 0x33f4,
  0x33f4, 0x33f4, 0x33f4, 0x33f4, 0x44f5, 0x44f5, 0x44f5, 0x54f6,
  0x54f5, 0x32f3, 0x22f3, 0x33f5, 0x55f6, 0x33f3, 0x22f2, 0x23f2,
  0x22f2, 0x22f2, 0x33f2, 0x22f2, 0x12f1, 0x23f1, 0x23f1, 0x23f1,
  0x23f1, 0x22f1, 0x22f2, 0x22f1, 0x22f1, 0x22f1, 0x32f2, 0x32f3,
  0x33f2, 0x35f2, 0x55f4, 0x53f6, 0x41f7, 0x61fb, 0x71fd, 0x70fd,
  0x71fe, 0x71fe, 0x81ff, 0x81ff, 0x81fe, 0x81fe, 0x51fa, 0x61fb,
  0x71fa, 0x71fa, 0x70fb, 0x70f9, 0x71f8, 0x84f6, 0x87f4, 0x8af1,
  0x7bf0, 0x7af0, 0x8af1, 0x8af1, 0x8af0, 0x8bf0, 0x8bf1, 0x8cf0,
  0x9df1, 0x7af1, 0x45f1, 0x57f1, 0x7af1, 0x8cf1, 0x9cf1, 0x8cf1,
  0x8cf1, 0x8cf1, 0x9df1, 0x7af0, 0x9bf2, 0xeffa, 0xfffd, 0xcef8,
  0xddfd, 0xddfd, 0xdcfd, 0xdcfd, 0xddfc, 0xddfc, 0xddfc, 0xccfc,
  0xccfc, 0xccfc, 0xccfc, 0xcdfc, 0xcdfc, 0xcdfc, 0xcdfc, 0xcdfc,
  0xcdfc, 0xcdfb, 0xdefd, 0xcdfb, 0x45f4, 0x33f3, 0x44f4, 0x45f5,
  0x55f6, 0x98f9, 0xcdfb, 0xbcfa, 0xbcfa, 0xacf9, 0xbcf9, 0xbcf9,
  0xbcfa, 0xabfa, 0xaafb, 0xa9fb, 0x98fb, 0x66f8, 0x65f7, 0x64f7,
  0x65f7, 0x65f8, 0x75f8, 0x75f8, 0x75f9, 0x63f8, 0x63f8, 0x64f8,
  0x64f8, 0x64f7, 0x65f6, 0xa8fa, 0x65f7, 0x11f1, 0x23f2, 0x23f2,
  0x22f2, 0x23f2, 0x22f2, 0x11f1, 0x12f1, 0x33f2, 0x33f2, 0x33f2,
  0x22f1, 0x12f1, 0x11f1, 0x22f1, 0x22f1, 0x23f2, 0x43f3, 0x43f3,
  0x34f2, 0x45f2, 0x55f2, 0x64f6, 0x51fa, 0x50fb, 0x70fd, 0x71fe,
  0x70fe, 0x71fe, 0x81fe, 0x81fe, 0x71fe, 0x71fe, 0x61fa, 0x51f7,
  0x71fa, 0x61f8, 0x61f9, 0x71fa, 0x72f7, 0x75f5, 0x89f1, 0x8bf0,
  0x7af1, 0x79f1, 0x7af1, 0x8bf1, 0x9cf1, 0x8cf1, 0x8cf1, 0x8cf1,
  0x9df0, 0x8bf1, 0x12f1, 0x00f2, 0x34f2, 0x57f1, 0x7af1, 0x8bf1,
  0x8cf1, 0x8cf1, 0x8cf1, 0x9df1, 0x7bf0, 0x8cf1, 0xdff8, 0xeffa,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfc, 0xddfc, 0xddfc,
  0xccfc, 0xcdfc, 0xcdfc, 0xcdfc, 0xcdfc, 0xcdfc, 0xcdfc, 0xcdfc,
  0xcdfc, 0xcdfc, 0xcdfc, 0xeefd, 0xabfa, 0x33f3, 0x43f4, 0x44f4,
  0x44f4, 0x88f8, 0xccfb, 0xbcfa, 0xbcfa, 0xbbfa, 0xbbfa, 0xabfa,
  0xabf9, 0xacf9, 0xacf9, 0xacfa, 0xbcfa, 0xabfa, 0xaafa, 0xa9fa,
  0x99fa, 0x99fa, 0x98fa, 0x98fa, 0x87f9, 0x87f9, 0x87f9, 0x88f9,
  0xaafa, 0xcbfc, 0xebfe, 0xc9fd, 0x33f5, 0x12f1, 0x33f2, 0x23f2,
  0x22f2, 0x22f2, 0x12f1, 0x22f1, 0x22f1, 0x23f2, 0x33f2, 0x33f2,
  0x22f1, 0x12f1, 0x11f1, 0x22f1, 0x22f1, 0x32f1, 0x43f3, 0x42f3,
  0x43f3, 0x54f3, 0x55f3, 0x63f6, 0x61fa, 0x60fc, 0x71fe, 0x71fe,
  0x70fe, 0x71fe, 0x71fe, 0x71fd, 0x71fd, 0x70fb, 0x70fb, 0x53f6,
  0x54f5, 0x64f7, 0x66f4, 0x75f6, 0x75f6, 0x56f2, 0x68f1, 0x79f1,
  0x79f0, 0x7af1, 0x8bf1, 0x8bf0, 0x9bf1, 0x9cf1, 0x9cf1, 0x8cf1,
  0x8cf1, 0x9cf1, 0x57f1, 0x22f1, 0x33f2, 0x45f1, 0x56f1, 0x67f1,
  0x7af1, 0x7bf1, 0x8bf1, 0x8bf1, 0x9cf0, 0x9df0, 0xcef5, 0xeffc,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfc,
  0xddfc, 0xcdfc, 0xcdfc, 0xddfc, 0xddfc, 0xddfc, 0xddfc, 0xddfc,
  0xddfc, 0xddfc, 0xddfc, 0xddfc, 0xeefd, 0xaaf9, 0x33f3, 0x44f4,
  0x44f4, 0x65f6, 0xccfc, 0xcdfb, 0xbcfb, 0xbbfa, 0xbbfa, 0xbbfa,
  0xabfa, 0xabfa, 0xabf9, 0xabf9, 0xabf9, 0xacf9, 0xacf9, 0xbcfa,
  0xbcfa, 0xacfa, 0xacfa, 0xacfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa,
  0xcdfd, 0xcbff, 0xa5ff, 0x43fb, 0x12f2, 0x23f1, 0x33f2, 0x23f1,
  0x23f2, 0x23f2, 0x12f1, 0x22f2, 0x22f2, 0x23f2, 0x33f2, 0x33f2,
  0x22f1, 0x11f1, 0x22f1, 0x22f1, 0x33f1, 0x33f2, 0x42f3, 0x53f3,
  0x44f3, 0x54f3, 0x54f4, 0x63f7, 0x70fb, 0x70fe, 0x71fe, 0x71fe,
  0x71fe, 0x70fe, 0x71fd, 0x71fc, 0x61fa, 0x52f7, 0x54f5, 0x66f4,
  0x68f1, 0x68f2, 0x79f0, 0x7af0, 0x79f2, 0x69f1, 0x69f1, 0x69f1,
  0x79f1, 0x7af0, 0x8bf1, 0x8bf1, 0x7af1, 0x8bf1, 0x9df1, 0x8cf1,
  0x9cf1, 0x9cf1, 0x69f1, 0x68f1, 0x56f1, 0x46f1, 0x57f1, 0x67f1,
  0x79f1, 0x8bf1, 0x8bf0, 0x8bf0, 0x9cf0, 0x9cf0, 0xbef3, 0xfffd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xddfc, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfc, 0xddfc,
  0xddfc, 0xddfc, 0xddfc, 0xddfc, 0xddfc, 0xeefe, 0x9af9, 0x33f4,
  0x33f3, 0x44f4, 0xa9fb, 0xdefc, 0xbbfb, 0xbbfb, 0xbbfb, 0xbbfa,
  0xbbfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabf9, 0xabf9, 0xabf9,
  0xabf9, 0xabfa, 0xacfa, 0xbcfa, 0xbbfa, 0xbcfa, 0xbbfa, 0xbcfc,
  0xbaff, 0x97ff, 0x65ff, 0x33fb, 0x23f0, 0x23f1, 0x33f1, 0x23f1,
  0x34f2, 0x33f1, 0x22f1, 0x22f2, 0x22f2, 0x23f2, 0x22f2, 0x22f2,
  0x22f1, 0x11f1, 0x22f1, 0x23f1, 0x33f1, 0x43f3, 0x42f3, 0x42f3,
  0x54f3, 0x54f4, 0x53f5, 0x62f8, 0x70fc, 0x71fe, 0x70fe, 0x71ff,
  0x71fe, 0x71fd, 0x71fd, 0x71fd, 0x51f8, 0x54f4, 0x67f3, 0x68f1,
  0x79f1, 0x7af0, 0x7af0, 0x7af0, 0x7af0, 0x7af0, 0x7af1, 0x7bf1,
  0x8bf1, 0x7bf1, 0x8bf1, 0x9cf1, 0x8cf1, 0x7bf1, 0x9cf1, 0x9cf1,
  0x9cf1, 0x9cf1, 0x69f1, 0x58f1, 0x79f1, 0x69f1, 0x69f1, 0x58f1,
  0x58f1, 0x69f1, 0x7af1, 0x8cf1, 0xadf0, 0xaef1, 0xbef3, 0xcef5,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfc, 0xddfd, 0xeefe, 0x9af9,
  0x33f3, 0x23f3, 0x65f6, 0xdcfd, 0xcdfc, 0xbbfb, 0xbcfb, 0xbcfb,
  0xbbfb, 0xbbfa, 0xbbfa, 0xbbfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa,
  0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xabfa, 0xbcfa, 0xbcfb, 0xbbff,
  0xa8ff, 0x97ff, 0x44ff, 0x23f3, 0x23f1, 0x33f2, 0x33f2, 0x33f2,
  0x44f2, 0x34f2, 0x33f2, 0x23f2, 0x22f2, 0x22f2, 0x22f1, 0x22f1,
  0x22f1, 0x22f1, 0x22f1, 0x33f1, 0x43f2, 0x53f3, 0x42f3, 0x33f2,
  0x53f3, 0x53f5, 0x52f6, 0x61f8, 0x61fc, 0x71fe, 0x71fe, 0x71fe,
  0x71fe, 0x71fe, 0x71fc, 0x60fa, 0x61f8, 0x64f5, 0x67f3, 0x79f1,
  0x79f1, 0x7af1, 0x79f1, 0x79f1, 0x68f1, 0x57f1, 0x67f1, 0x69f1,
  0x7af1, 0x8bf1, 0x7bf1, 0x8cf0, 0x9df1, 0x9df1, 0x9df1, 0x9cf1,
  0x7bf1, 0x8bf1, 0x8bf0, 0x58f1, 0x68f1, 0x7af0, 0x8cf1, 0x8cf1,
  0x7af1, 0x69f0, 0x69f1, 0x69f1, 0x69f0, 0x9bf1, 0xeff9, 0xeffa,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfc, 0xddfd, 0xeefe,
  0xaafa, 0x33f4, 0x11f2, 0x86f8, 0xeefd, 0xccfb, 0xbbfb, 0xbcfb,
  0xbbfb, 0xbbfb, 0xbbfb, 0xbbfa, 0xbbfa, 0xbbfa, 0xbbfa, 0xbbfa,
  0xbbfa, 0xbbfa, 0xbbfa, 0xbcfa, 0xbbfa, 0xbcfa, 0xcdfe, 0xb9ff,
  0xa5ff, 0x65ff, 0x23fb, 0x23f1, 0x23f2, 0x33f2, 0x33f2, 0x33f2,
  0x44f2, 0x43f2, 0x22f2, 0x22f2, 0x22f2, 0x22f2, 0x23f2, 0x22f1,
  0x22f1, 0x32f2, 0x32f1, 0x32f1, 0x53f3, 0x53f3, 0x43f3, 0x23f1,
  0x43f2, 0x62f6, 0x52f7, 0x61f8, 0x61fb, 0x61fe, 0x71fe, 0x71fe,
  0x71fe, 0x71fe, 0x61fc, 0x61f9, 0x61f9, 0x63f7, 0x77f4, 0x89f1,
  0x79f1, 0x79f1, 0x7af1, 0x69f1, 0x57f1, 0x34f1, 0x45f1, 0x56f1,
  0x57f1, 0x57f1, 0x68f1, 0x68f1, 0x69f1, 0x8af1, 0x8bf1, 0x8cf1,
  0x7bf1, 0x7af1, 0x7af0, 0x7bf1, 0x6af1, 0x68f1, 0x69f1, 0x8cf1,
  0xaef1, 0x9df1, 0x8cf1, 0x7bf1, 0x6af1, 0x69f0, 0x8af2, 0xbdf7,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfc, 0xddfd,
  0xeefe, 0xbbfb, 0x44f4, 0x11f3, 0xa8fa, 0xeffd, 0xccfc, 0xbcfb,
  0xbcfb, 0xbbfb, 0xbbfb, 0xbcfb, 0xbcfb, 0xbbfa, 0xbbfa, 0xbbfa,
  0xbcfa, 0xbcfa, 0xbbfa, 0xbcfa, 0xbcfa, 0xbcfb, 0xccff, 0xa7ff,
  0x64ff, 0x33ff, 0x22f6, 0x23f1, 0x23f2, 0x33f2, 0x33f2, 0x33f2,
  0x44f2, 0x33f2, 0x12f1, 0x22f2, 0x22f1, 0x22f1, 0x23f1, 0x23f1,
  0x33f1, 0x33f2, 0x32f1, 0x32f1, 0x52f3, 0x53f3, 0x34f2, 0x34f1,
  0x44f2, 0x62f6, 0x61f8, 0x61f9, 0x51f9, 0x61fc, 0x71fe, 0x71ff,
  0x71fe, 0x71fe, 0x71fd, 0x71fb, 0x70fa, 0x71f9, 0x74f7, 0x89f4,
  0x7af1, 0x68f2, 0x78f4, 0x67f4, 0x55f2, 0x56f1, 0x56f0, 0x56f0,
  0x57f1, 0x58f1, 0x68f1, 0x57f1, 0x46f1, 0x45f1, 0x34f1, 0x57f1,
  0x8cf1, 0x8cf1, 0x8bf0, 0x7bf1, 0x8cf0, 0x8cf0, 0x69f1, 0x57f1,
  0x7af1, 0xadf1, 0xaef1, 0x9df1, 0x9cf1, 0x8cf1, 0x8bf0, 0x8bf1,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xdcfc, 0xeefe, 0xddfd, 0x77f7, 0x21f4, 0x97fa, 0xeefd, 0xcdfc,
  0xccfb, 0xccfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfa, 0xbcfa,
  0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfa, 0xbcfe, 0xbaff, 0x95ff,
  0x44ff, 0x12fd, 0x33f1, 0x33f2, 0x22f2, 0x33f2, 0x33f2, 0x33f2,
  0x43f3, 0x33f2, 0x22f2, 0x11f1, 0x22f1, 0x22f1, 0x33f1, 0x33f1,
  0x33f1, 0x43f2, 0x32f2, 0x42f2, 0x52f3, 0x43f2, 0x45f1, 0x55f2,
  0x54f2, 0x62f6, 0x61f9, 0x61fa, 0x51fb, 0x61fd, 0x71fe, 0x81fe,
  0x71ff, 0x71fe, 0x71fd, 0x71fe, 0x71fc, 0x70fc, 0x70fc, 0x75f9,
  0x78f6, 0x64f7, 0x52f7, 0x63f7, 0x64f5, 0x66f3, 0x68f1, 0x68f0,
  0x68f0, 0x79f1, 0x79f1, 0x7bf1, 0x8bf1, 0x7af1, 0x57f1, 0x45f1,
  0x57f1, 0x8cf1, 0xaef1, 0x9df1, 0x8cf1, 0x8cf1, 0x9df1, 0x7bf1,
  0x57f1, 0x57f1, 0x8bf1, 0xaef1, 0x9ef1, 0x9df1, 0x9df1, 0xadf1,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xedfd, 0xedfd, 0xedfd, 0xedfd,
  0xedfd, 0xedfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xddfc, 0xdcfc, 0xedfd, 0xeefe, 0x89f9, 0x32f5, 0x87f9, 0xddfd,
  0xcdfc, 0xccfb, 0xccfb, 0xccfb, 0xbcfb, 0xbcfb, 0xbcfb, 0xbcfb,
  0xbcfb, 0xbcfb, 0xbcfb, 0xbcfa, 0xbcfb, 0xbbff, 0xbaff, 0x96ff,
  0x44ff, 0x12fb, 0x33f4, 0x33f4, 0x33f2, 0x34f3, 0x23f2, 0x33f2,
  0x33f3, 0x32f2, 0x22f1, 0x11f1, 0x22f1, 0x32f1, 0x33f1, 0x33f1,
  0x43f2, 0x42f3, 0x32f2, 0x43f3, 0x52f4, 0x42f3, 0x44f1, 0x55f2,
  0x53f3, 0x61f8, 0x70fb, 0x61fd, 0x50fd, 0x71fd, 0x71fe, 0x70fe,
  0x71fe, 0x81fe, 0x61fd, 0x61fd, 0x70fe, 0x71fd, 0x70fc, 0x60fc,
  0x61fb, 0x60fa, 0x60fa, 0x60f9, 0x73f8, 0x74f7, 0x65f5, 0x67f3,
  0x79f1, 0x8af0, 0x7af1, 0x7af1, 0x7af1, 0x8cf1, 0x8cf1, 0x7af0,
  0x46f1, 0x56f1, 0x8cf1, 0xaef1, 0x9df1, 0x8cf1, 0x9df1, 0x9df0,
  0x8cf1, 0x58f1, 0x45f1, 0x79f1, 0xaef1, 0xaff0, 0x9df0, 0xadf1,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xddfd, 0xedfd, 0xedfd, 0xedfe, 0xedfe, 0xeefe, 0xeefe, 0xeefe,
  0xeefe, 0xedfd, 0xedfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xddfd, 0xddfd, 0xddfc, 0xddfd, 0xeefe, 0xccfb, 0x88f9, 0x86fa,
  0xcafc, 0xcdfc, 0xccfc, 0xccfc, 0xccfb, 0xccfb, 0xccfb, 0xbcfb,
  0xbcfb, 0xbcfb, 0xbcfb, 0xbcfa, 0xbcfc, 0xcbff, 0xcaff, 0x76ff,
  0x12ff, 0x12fc, 0x23f9, 0x23f8, 0x33f4, 0x33f2, 0x34f3, 0x43f3,
  0x33f3, 0x32f2, 0x32f1, 0x22f1, 0x22f1, 0x22f1, 0x32f1, 0x33f2,
  0x43f3, 0x42f2, 0x22f1, 0x32f2, 0x52f4, 0x52f5, 0x54f3, 0x65f3,
  0x62f6, 0x60fa, 0x70fd, 0x61fe, 0x61fe, 0x70fe, 0x71fe, 0x71ff,
  0x70fe, 0x81fe, 0x71fd, 0x61fd, 0x71ff, 0x71ff, 0x71fe, 0x70fd,
  0x60fb, 0x60fa, 0x60fa, 0x60fa, 0x71fa, 0x71fa, 0x72f9, 0x63f6,
  0x55f3, 0x68f0, 0x79f1, 0x7af1, 0x69f0, 0x68f1, 0x69f1, 0x8bf1,
  0x8bf1, 0x68f1, 0x57f1, 0x7af1, 0xaef1, 0x9df0, 0x9df1, 0x9df0,
  0x9df1, 0x8cf1, 0x7bf1, 0x57f1, 0x46f1, 0x8af1, 0xcff1, 0xaef1,
  0xddfd, 0xddfd, 0xddfd, 0xedfd, 0xedfe, 0xedfe, 0xedfe, 0xedfe,
  0xedfe, 0xeefe, 0xeefe, 0xedfe, 0xedfe, 0xeefe, 0xeefe, 0xeefe,
  0xeefe, 0xeefe, 0xedfe, 0xedfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfc, 0xedfd, 0xeefd, 0xbbfb,
  0xb9fc, 0xddfd, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfb, 0xccfb,
  0xbcfb, 0xbcfb, 0xbcfb, 0xbcfa, 0xccfd, 0xccff, 0xcaff, 0x34ff,
  0x01ff, 0x02fb, 0x02fb, 0x12f9, 0x33f2, 0x56f5, 0x66f7, 0x32f4,
  0x31f2, 0x32f2, 0x43f2, 0x33f1, 0x22f1, 0x22f1, 0x32f2, 0x32f2,
  0x53f3, 0x54f2, 0x22f1, 0x32f2, 0x54f3, 0x64f3, 0x64f3, 0x63f5,
  0x61f8, 0x60fa, 0x70fd, 0x71ff, 0x71ff, 0x71fe, 0x81fe, 0x81ff,
  0x81fe, 0x71fe, 0x71fe, 0x71fd, 0x71fe, 0x81ff, 0x80ff, 0x81fe,
  0x71fc, 0x61fa, 0x60f9, 0x70fa, 0x70f9, 0x70f9, 0x71fa, 0x62f7,
  0x44f3, 0x44f1, 0x46f1, 0x57f1, 0x68f1, 0x57f1, 0x46f1, 0x68f1,
  0x7bf1, 0x7af1, 0x68f1, 0x46f1, 0x68f1, 0x9df1, 0x9df0, 0x9df1,
  0x9df1, 0x9df1, 0x9df0, 0x8cf1, 0x46f1, 0x34f1, 0x79f1, 0xbef2,
  0xddfd, 0xddfd, 0xddfd, 0xedfe, 0xedfe, 0xedfd, 0xedfd, 0xeefe,
  0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe,
  0xeefe, 0xeefe, 0xedfe, 0xedfe, 0xedfd, 0xddfd, 0xddfd, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfc, 0xddfd, 0xddfd, 0xddfd,
  0xddfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfb,
  0xccfb, 0xccfb, 0xccfb, 0xcdfb, 0xccfe, 0xb9ff, 0xb9ff, 0x33ff,
  0x01fd, 0x02fb, 0x01fb, 0x23f9, 0x55f6, 0x88fa, 0x55f8, 0x21f3,
  0x32f3, 0x42f2, 0x43f2, 0x44f2, 0x33f2, 0x33f2, 0x32f2, 0x43f3,
  0x43f2, 0x54f1, 0x43f1, 0x43f2, 0x54f2, 0x65f2, 0x64f4, 0x62f8,
  0x60f9, 0x71fb, 0x71fe, 0x71ff, 0x81ff, 0x71fe, 0x81fe, 0x81fe,
  0x71fe, 0x71fe, 0x71fd, 0x70fd, 0x71fd, 0x71fe, 0x71fe, 0x71fd,
  0x71fc, 0x71fb, 0x70fa, 0x61f9, 0x72f9, 0x71f9, 0x62f7, 0x65f6,
  0x56f2, 0x47f1, 0x46f1, 0x56f0, 0x46f1, 0x57f1, 0x57f0, 0x58f1,
  0x69f1, 0x69f1, 0x7af1, 0x6af1, 0x58f1, 0x69f1, 0x8cf1, 0x8df0,
  0x9df0, 0x8cf0, 0x8cf0, 0x8cf0, 0x7bf1, 0x56f1, 0x33f1, 0x79f2,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xedfd, 0xedfd, 0xedfd, 0xeefe,
  0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe,
  0xeefe, 0xeefe, 0xeefe, 0xedfe, 0xedfe, 0xedfd, 0xedfd, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xdcfc,
  0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc,
  0xccfb, 0xccfb, 0xccfb, 0xcdfb, 0xccfe, 0xa8ff, 0x74ff, 0x12ff,
  0x02fc, 0x02fb, 0x02fa, 0x12f9, 0x33f9, 0x55fc, 0x33f7, 0x22f4,
  0x42f3, 0x53f3, 0x53f3, 0x54f2, 0x44f2, 0x43f3, 0x32f3, 0x33f2,
  0x55f1, 0x55f1, 0x43f2, 0x42f2, 0x63f3, 0x64f4, 0x63f6, 0x71fa,
  0x61fa, 0x70fc, 0x71fe, 0x71ff, 0x81ff, 0x71fe, 0x71fe, 0x81fe,
  0x71fe, 0x71fe, 0x71fe, 0x81fd, 0x71fd, 0x71fd, 0x81fe, 0x71fc,
  0x70fb, 0x61f9, 0x62f8, 0x73f8, 0x62f8, 0x60f9, 0x61f8, 0x65f4,
  0x79f1, 0x7af0, 0x6af1, 0x69f1, 0x69f1, 0x68f1, 0x58f1, 0x57f1,
  0x69f1, 0x6af1, 0x9cf1, 0xbef1, 0xaef1, 0x9cf1, 0x9cf0, 0x9df1,
  0xbff4, 0xbef4, 0x9df1, 0x7bf0, 0x7bf0, 0x68f1, 0x44f1, 0x45f1,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xedfd, 0xedfe,
  0xedfe, 0xedfe, 0xedfe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe,
  0xeefe, 0xeefe, 0xeefe, 0xedfe, 0xedfe, 0xedfd, 0xedfd, 0xddfd,
  0xedfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xdcfd, 0xdcfc,
  0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc,
  0xccfb, 0xccfb, 0xccfb, 0xcdfb, 0xccfd, 0xbbff, 0x65ff, 0x02ff,
  0x02fa, 0x02f9, 0x02f9, 0x02f9, 0x01fa, 0x11fb, 0x32f7, 0x33f5,
  0x53f4, 0x53f3, 0x53f3, 0x53f3, 0x63f3, 0x53f4, 0x42f4, 0x44f2,
  0x66f0, 0x65f2, 0x42f3, 0x52f3, 0x73f4, 0x73f6, 0x61f8, 0x71fa,
  0x71fc, 0x71fd, 0x71fe, 0x81ff, 0x81ff, 0x71fe, 0x71fd, 0x71fe,
  0x71fd, 0x70fe, 0x71fe, 0x81fd, 0x81fd, 0x71fd, 0x81fd, 0x71fc,
  0x71fa, 0x63f8, 0x65f7, 0x73f8, 0x61f9, 0x51f9, 0x40f8, 0x31f4,
  0x44f1, 0x68f0, 0x7bf0, 0x7af1, 0x7af1, 0x6af1, 0x7af1, 0x7af1,
  0x8bf1, 0x8bf1, 0x9cf1, 0xadf1, 0xadf1, 0x9cf0, 0xbdf2, 0xeffb,
  0xfffe, 0xfffe, 0xfffc, 0xcef7, 0x8cf2, 0x69f0, 0x57f0, 0x56f1,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xedfd, 0xedfe,
  0xedfe, 0xedfe, 0xedfe, 0xedfe, 0xedfe, 0xeefe, 0xeefe, 0xeefe,
  0xeefe, 0xeefe, 0xeefe, 0xedfe, 0xedfe, 0xedfd, 0xedfd, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xdcfd, 0xdcfc,
  0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc,
  0xccfc, 0xccfc, 0xccfb, 0xccfb, 0xccfd, 0xdcff, 0xbaff, 0x23ff,
  0x01fb, 0x02f8, 0x02f8, 0x11f8, 0x43fa, 0x55fa, 0x33f8, 0x65f7,
  0x54f4, 0x53f3, 0x63f3, 0x53f3, 0x63f4, 0x52f4, 0x42f4, 0x54f3,
  0x56f2, 0x65f3, 0x53f4, 0x52f4, 0x73f6, 0x71f9, 0x70fa, 0x61fa,
  0x71fc, 0x71fe, 0x71fe, 0x71fe, 0x81fe, 0x81ff, 0x81ff, 0x71fe,
  0x71fd, 0x71fe, 0x71fd, 0x71fe, 0x71fd, 0x71fd, 0x71fc, 0x80fc,
  0x71f9, 0x64f7, 0x65f7, 0x72f9, 0x70fb, 0x61fa, 0x41f8, 0x30f6,
  0x30f4, 0x21f3, 0x45f2, 0x68f0, 0x69f1, 0x8cf1, 0xadf1, 0x9cf1,
  0x9bf1, 0x9cf1, 0x9cf1, 0x9cf1, 0x9cf0, 0x9cf0, 0xbdf4, 0xfffe,
  0xdefa, 0xeffa, 0xfffc, 0xfffe, 0xffff, 0xbef7, 0x6af0, 0x79f1,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xedfd, 0xedfd, 0xedfd, 0xedfe, 0xedfe, 0xedfe, 0xedfe, 0xedfe,
  0xedfe, 0xeefe, 0xedfe, 0xedfe, 0xedfe, 0xedfd, 0xedfd, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xdcfd, 0xdcfc,
  0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc,
  0xccfc, 0xccfc, 0xccfc, 0xccfb, 0xccfc, 0xddff, 0xcbff, 0x33ff,
  0x01fd, 0x02f9, 0x01f8, 0x22f9, 0x54fa, 0x66fa, 0x55f8, 0x66f7,
  0x33f2, 0x54f3, 0x64f4, 0x54f3, 0x64f4, 0x53f3, 0x31f4, 0x43f4,
  0x54f4, 0x43f3, 0x43f3, 0x53f4, 0x72f7, 0x70fa, 0x70fb, 0x61f9,
  0x71fc, 0x71fe, 0x71fd, 0x71fd, 0x61fc, 0x61fb, 0x61fc, 0x71fe,
  0x81fe, 0x81fe, 0x71fe, 0x71fe, 0x81fe, 0x70fd, 0x70fc, 0x70fc,
  0x70fb, 0x73f9, 0x72fa, 0x70fc, 0x71fc, 0x61fa, 0x41f9, 0x41f7,
  0x40f6, 0x30f5, 0x10f4, 0x58f1, 0x9cf1, 0x9cf1, 0x9df1, 0x9cf1,
  0x8af1, 0x8bf0, 0x9cf1, 0x8bf1, 0x8bf1, 0x8cf0, 0xdef9, 0xfffe,
  0xdef9, 0xdef8, 0xeffa, 0xeefb, 0xfffe, 0xffff, 0xdff9, 0x9cf3,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xddfd, 0xddfd, 0xedfd, 0xedfe, 0xedfe, 0xedfe, 0xedfe, 0xedfe,
  0xedfe, 0xedfe, 0xedfe, 0xedfe, 0xedfe, 0xedfe, 0xedfd, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xdcfd, 0xdcfd,
  0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc,
  0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xdcff, 0xdcff, 0x65ff,
  0x01fe, 0x02fa, 0x12fa, 0x22f9, 0x32f9, 0x54f8, 0x55f7, 0x55f6,
  0x43f4, 0x63f5, 0x43f3, 0x44f2, 0x66f3, 0x54f4, 0x31f5, 0x41f6,
  0x52f6, 0x42f4, 0x43f3, 0x53f4, 0x52f6, 0x61f8, 0x71fa, 0x71fa,
  0x71fc, 0x71fe, 0x71fd, 0x61fc, 0x51fc, 0x51fb, 0x51fb, 0x61fc,
  0x61fc, 0x71fd, 0x71fd, 0x71fe, 0x71fe, 0x71fe, 0x71fd, 0x71fd,
  0x81fd, 0x81fc, 0x71fc, 0x70fc, 0x61fc, 0x61fb, 0x61fa, 0x51f9,
  0x40f8, 0x30f7, 0x67f3, 0x9cf1, 0x89f1, 0x79f1, 0x7bf1, 0x8bf1,
  0x8af0, 0x79f1, 0x8bf1, 0x9cf1, 0x9bf0, 0x7af0, 0xabf5, 0xcef7,
  0xbdf6, 0xdefa, 0xdef9, 0xdefb, 0xeffb, 0xdefb, 0xfffd, 0xeffb,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xedfd, 0xedfe, 0xedfe, 0xedfe, 0xedfe,
  0xedfe, 0xedfe, 0xedfe, 0xedfe, 0xedfe, 0xedfe, 0xedfd, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xdcfd,
  0xccfd, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc,
  0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xcdfc, 0xdcfe, 0xedff, 0x86ff,
  0x00ff, 0x02fb, 0x12fa, 0x11f9, 0x21f7, 0x43f7, 0x55f6, 0x56f5,
  0x75f6, 0x52f5, 0x21f1, 0x55f1, 0x76f4, 0x52f6, 0x40f7, 0x51f7,
  0x52f7, 0x52f6, 0x52f5, 0x52f5, 0x52f6, 0x62f8, 0x71fa, 0x71fd,
  0x71fd, 0x61fd, 0x71fd, 0x61fc, 0x61fd, 0x61fd, 0x61fd, 0x61fd,
  0x61fd, 0x61fd, 0x61fd, 0x61fd, 0x61fd, 0x71fd, 0x71fe, 0x71fe,
  0x71fe, 0x70fe, 0x70fd, 0x60fd, 0x60fd, 0x60fc, 0x61fb, 0x60fb,
  0x50fa, 0x78f4, 0x9df1, 0x79f0, 0x67f1, 0x79f1, 0x69f0, 0x8af1,
  0x9bf1, 0x8af0, 0x7af1, 0x9cf1, 0x8bf1, 0x79f1, 0x68f0, 0x8af0,
  0x9cf2, 0xdefa, 0xacf5, 0xcdf6, 0xcef6, 0xcdf8, 0xcdf8, 0xeefa,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xedfd, 0xedfd, 0xedfe, 0xedfe, 0xedfe,
  0xedfe, 0xedfe, 0xedfe, 0xedfe, 0xedfe, 0xedfe, 0xedfe, 0xedfd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xdcfd,
  0xdcfd, 0xdcfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc,
  0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xcdfc, 0xddfd, 0xddff, 0xa9ff,
  0x12ff, 0x01fb, 0x02fa, 0x22f9, 0x32f7, 0x32f6, 0x55f6, 0x78f7,
  0x76f7, 0x42f5, 0x42f3, 0x76f3, 0x74f5, 0x50f8, 0x50f9, 0x51f7,
  0x53f6, 0x53f7, 0x62f8, 0x62f8, 0x62f8, 0x61f9, 0x71fc, 0x70fd,
  0x71fd, 0x61fd, 0x61fd, 0x71fd, 0x71fe, 0x71fe, 0x71fe, 0x70fe,
  0x71fe, 0x71fe, 0x71fe, 0x71fe, 0x71fe, 0x71fe, 0x70fe, 0x70fe,
  0x60fe, 0x61fe, 0x61fe, 0x61fd, 0x61fd, 0x61fc, 0x60fc, 0x61fb,
  0x89f5, 0x9df0, 0x79f0, 0x68f1, 0x8af1, 0x79f1, 0x68f0, 0x8bf1,
  0x9cf1, 0x9bf1, 0x8af1, 0x8bf1, 0x8af1, 0x79f1, 0x79f1, 0x7af0,
  0x8af0, 0x9bf2, 0x79f0, 0x7af0, 0x9cf0, 0x9cf1, 0xbdf4, 0xeffb,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xedfd, 0xedfd, 0xedfe, 0xedfe,
  0xedfe, 0xedfe, 0xedfe, 0xedfe, 0xedfe, 0xedfe, 0xeefe, 0xedfd,
  0xedfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xdcfd,
  0xdcfd, 0xdcfd, 0xdcfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc,
  0xccfc, 0xccfc, 0xccfc, 0xcdfc, 0xccfc, 0xccfc, 0xddfd, 0xddff,
  0x88ff, 0x11fd, 0x11fb, 0x65fa, 0x44f7, 0x32f5, 0x66f7, 0x77f7,
  0x77f8, 0x74f9, 0x62f4, 0x75f4, 0x62f7, 0x60fb, 0x61fa, 0x51f8,
  0x52f7, 0x62f8, 0x61f9, 0x71fa, 0x71fb, 0x70fb, 0x71fd, 0x71fd,
  0x71fd, 0x71fe, 0x61fe, 0x71fe, 0x71fe, 0x71ff, 0x71fe, 0x70fe,
  0x70fe, 0x70fe, 0x81ff, 0x81ff, 0x80ff, 0x71ff, 0x71ff, 0x70fe,
  0x70fe, 0x70fe, 0x71fe, 0x71fd, 0x71fd, 0x60fd, 0x62fb, 0x8af3,
  0x9cf0, 0x79f0, 0x69f1, 0x8af1, 0x8af1, 0x68f0, 0x79f1, 0x8af1,
  0x8af0, 0x8af1, 0x8af0, 0x8af1, 0x8af1, 0x8af0, 0x8af1, 0x7af0,
  0x8af0, 0x8af0, 0x8af0, 0x79f0, 0x7af0, 0x8bf0, 0xacf3, 0xbdf7,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xedfd, 0xedfe,
  0xedfe, 0xedfe, 0xedfe, 0xedfe, 0xedfe, 0xedfe, 0xeefe, 0xedfd,
  0xedfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xdcfd, 0xdcfd, 0xdcfd, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc,
  0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xcdfc, 0xcdfc, 0xcdfd, 0xddfd,
  0xbcfd, 0x55fd, 0x43fc, 0x76fb, 0x54f8, 0x33f5, 0x66f7, 0x77f7,
  0x87f8, 0x85f8, 0x63f4, 0x64f6, 0x61fb, 0x70fc, 0x71fc, 0x71fb,
  0x61fa, 0x61fa, 0x61fa, 0x71fb, 0x71fc, 0x71fe, 0x71fd, 0x71fd,
  0x71fe, 0x71fe, 0x71fe, 0x71ff, 0x71fe, 0x71ff, 0x71ff, 0x71ff,
  0x71ff, 0x71ff, 0x81ff, 0x80ff, 0x81ff, 0x71ff, 0x70ff, 0x70fe,
  0x71fe, 0x71fe, 0x70fe, 0x71fd, 0x60fd, 0x61fc, 0x8af3, 0x9cf0,
  0x79f0, 0x79f1, 0x79f1, 0x9bf1, 0x8af1, 0x7af1, 0x8af1, 0x79f1,
  0x79f1, 0x7af1, 0x8af1, 0x7af1, 0x8af1, 0x8bf0, 0x8bf0, 0x8af0,
  0x79f0, 0x8bf1, 0x8bf1, 0x8af0, 0x79f1, 0x7af1, 0x8af0, 0x8bf1,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xedfd, 0xedfd, 0xedfd,
  0xedfd, 0xedfd, 0xedfe, 0xedfe, 0xedfe, 0xedfe, 0xeefe, 0xedfd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xdcfd, 0xdcfd, 0xdcfd, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc,
  0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xcdfc, 0xcdfc, 0xddfc,
  0xccfc, 0xaafc, 0x77fb, 0x77fb, 0x55f8, 0x44f5, 0x66f6, 0x78f8,
  0x88f8, 0x75f6, 0x64f5, 0x71fa, 0x80fe, 0x81fd, 0x81fe, 0x80fd,
  0x71fc, 0x71fd, 0x71fc, 0x71fd, 0x71fd, 0x71fe, 0x71fe, 0x71fe,
  0x71fe, 0x71ff, 0x81ff, 0x81ff, 0x71ff, 0x71ff, 0x71ff, 0x81ff,
  0x81ff, 0x81ff, 0x81ff, 0x81ff, 0x81ff, 0x81ff, 0x71ff, 0x71ff,
  0x71fe, 0x71fe, 0x71fd, 0x60fd, 0x61fd, 0x89f3, 0x9cf0, 0x8af0,
  0x79f1, 0x79f0, 0x79f1, 0x89f1, 0x8af0, 0x8af1, 0x7af1, 0x7af1,
  0x8af1, 0x8bf0, 0x79f0, 0x78f0, 0x79f1, 0x7af1, 0x8bf1, 0x8af1,
  0x8af1, 0x79f0, 0x8af0, 0x8af0, 0x8af0, 0x7af1, 0x7af0, 0x9bf1,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xedfd,
  0xedfd, 0xedfd, 0xedfd, 0xedfd, 0xedfd, 0xedfd, 0xedfe, 0xedfd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xddfd, 0xdcfd, 0xdcfd, 0xccfc, 0xccfc, 0xccfd, 0xccfc, 0xccfc,
  0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xcdfc, 0xdcfc,
  0xddfd, 0xccfc, 0x88fb, 0x77fb, 0x66f9, 0x44f5, 0x66f6, 0x89f8,
  0xa8fa, 0x83f8, 0x74f6, 0x81fd, 0x90ff, 0x81fe, 0x80fe, 0x81fe,
  0x81fe, 0x81fe, 0x71fe, 0x71fe, 0x71fe, 0x70fe, 0x71fe, 0x71fe,
  0x81ff, 0x81ff, 0x81ff, 0x81ff, 0x81ff, 0x81ff, 0x81ff, 0x71ff,
  0x81ff, 0x80ff, 0x81ff, 0x81ff, 0x81ff, 0x80ff, 0x81ff, 0x71ff,
  0x70fe, 0x71fe, 0x61fd, 0x60fe, 0x76f7, 0x8cf0, 0x8af0, 0x8af1,
  0x79f1, 0x79f1, 0x89f1, 0x89f1, 0x89f0, 0x79f1, 0x7af1, 0x8bf0,
  0x9bf1, 0x8af1, 0x79f0, 0x79f1, 0x68f1, 0x68f1, 0x79f1, 0x8af1,
  0x8af1, 0x79f1, 0x79f1, 0x7af1, 0x8af1, 0x8af1, 0x79f1, 0x8af1,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xedfd, 0xedfd, 0xedfd, 0xedfd, 0xedfd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xddfd, 0xdcfd, 0xdcfd, 0xdcfd, 0xccfd, 0xccfd, 0xccfd, 0xccfc,
  0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xccfc, 0xddfd,
  0xfffe, 0xddfd, 0x77fa, 0x77fb, 0x77fa, 0x55f6, 0x77f7, 0x9af9,
  0xa7fb, 0x82f9, 0x72f9, 0x90ff, 0x81fe, 0x81fe, 0x80ff, 0x91ff,
  0x81ff, 0x81ff, 0x80ff, 0x80ff, 0x81ff, 0x81ff, 0x81ff, 0x81ff,
  0x80ff, 0x81ff, 0x81ff, 0x81ff, 0x80ff, 0x81ff, 0x81ff, 0x81ff,
  0x80ff, 0x80ff, 0x81ff, 0x81ff, 0x81ff, 0x80ff, 0x71ff, 0x71ff,
  0x71fe, 0x71fe, 0x60fd, 0x62fa, 0x7af0, 0x8bf0, 0x79f1, 0x79f1,
  0x79f0, 0x78f0, 0x79f1, 0x8af1, 0x89f1, 0x78f1, 0x68f1, 0x79f1,
  0x8bf1, 0x8bf1, 0x79f0, 0x89f1, 0x79f1, 0x68f1, 0x79f1, 0x7af1,
  0x8af0, 0x8af1, 0x79f1, 0x69f1, 0x69f1, 0x79f0, 0x79f1, 0x8af1,
  0xddfd, 0xddfd, 0xddfd, 0xedfd, 0xedfd, 0xedfd, 0xedfd, 0xedfe,
  0xedfe, 0xedfe, 0xedfe, 0xedfe, 0xedfe, 0xedfd, 0xedfd, 0xddfd,
  0xddfd, 0xedfd, 0xedfd, 0xedfd, 0xedfd, 0xedfd, 0xedfd, 0xedfd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xddfd, 0xddfd, 0xdcfd, 0xdcfd, 0xccfd, 0xccfd, 0xccfd, 0xccfd,
  0xccfd, 0xccfd, 0xccfd, 0xccfd, 0xccfc, 0xccfc, 0xccfc, 0xddfd,
  0xffff, 0xddfd, 0x77fa, 0x76fb, 0x77fb, 0x66f8, 0x88f8, 0x9af9,
  0xb6fc, 0x81fb, 0x81fd, 0x80ff, 0x81fe, 0x80ff, 0x80ff, 0x91ff,
  0x90ff, 0x80ff, 0x80ff, 0x81ff, 0x80ff, 0x81ff, 0x81ff, 0x80ff,
  0x81ff, 0x80ff, 0x81ff, 0x81ff, 0x81ff, 0x81ff, 0x81ff, 0x80ff,
  0x81ff, 0x80ff, 0x80ff, 0x81ff, 0x81ff, 0x71ff, 0x71ff, 0x70fe,
  0x70fe, 0x60fd, 0x60ff, 0x76f6, 0x8cf0, 0x9bf0, 0x78f1, 0x79f1,
  0x79f1, 0x68f0, 0x8af1, 0x9bf1, 0x89f1, 0x79f1, 0x79f0, 0x68f1,
  0x68f1, 0x79f1, 0x8af1, 0x8af1, 0x78f1, 0x68f1, 0x79f1, 0x79f0,
  0x79f0, 0x8af1, 0x7af1, 0x69f0, 0x69f1, 0x69f1, 0x79f1, 0x8af1,
  0xddfd, 0xddfd, 0xedfd, 0xedfd, 0xedfe, 0xeefe, 0xeefe, 0xeefe,
  0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xedfe, 0xedfe, 0xedfe, 0xedfe,
  0xedfe, 0xedfe, 0xedfd, 0xedfe, 0xedfd, 0xedfd, 0xedfd, 0xedfd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xddfd, 0xddfd, 0xdcfd, 0xdcfd, 0xdcfd, 0xdcfd, 0xccfd, 0xccfd,
  0xccfd, 0xccfd, 0xdcfd, 0xdcfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xedfe, 0xccfd, 0x77fa, 0x65fa, 0x65fa, 0x66f8, 0x99f9, 0xabf9,
  0xb4fe, 0x90ff, 0x90ff, 0x81fe, 0x81fe, 0x81ff, 0x81ff, 0x80ff,
  0x80ff, 0x80ff, 0x81ff, 0x81ff, 0x81ff, 0x81ff, 0x81ff, 0x80ff,
  0x80ff, 0x80ff, 0x81ff, 0x81ff, 0x81ff, 0x81ff, 0x81ff, 0x81ff,
  0x80ff, 0x70ff, 0x80ff, 0x80ff, 0x70ff, 0x71ff, 0x71ff, 0x71fe,
  0x71fe, 0x60fe, 0x61fc, 0x68f2, 0x8af0, 0x8af1, 0x68f1, 0x79f1,
  0x89f1, 0x89f1, 0x8af0, 0x8af0, 0x79f1, 0x79f1, 0x79f1, 0x78f1,
  0x67f1, 0x68f1, 0x79f1, 0x79f0, 0x68f1, 0x79f1, 0x8af0, 0x79f1,
  0x79f1, 0x79f1, 0x79f1, 0x79f1, 0x7af1, 0x79f1, 0x79f1, 0x8af1,
  0xedfd, 0xeefd, 0xedfe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe,
  0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe,
  0xeefe, 0xedfe, 0xedfe, 0xedfe, 0xedfd, 0xedfd, 0xedfd, 0xedfd,
  0xddfe, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xdcfd, 0xdcfd, 0xdcfd, 0xddfd, 0xddfd,
  0xdcfd, 0xdcfd, 0xdcfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xdcfd, 0xbbfc, 0x88fb, 0x65fa, 0x65fa, 0x76f8, 0x99f8, 0xabf9,
  0xb4ff, 0x90ff, 0x91ff, 0x81ff, 0x81ff, 0x81ff, 0x81ff, 0x80ff,
  0x80ff, 0x81ff, 0x81ff, 0x80ff, 0x81ff, 0x81ff, 0x80ff, 0x80ff,
  0x80ff, 0x80ff, 0x81ff, 0x80ff, 0x81ff, 0x81ff, 0x81ff, 0x80ff,
  0x70ff, 0x71ff, 0x71ff, 0x71ff, 0x71ff, 0x71ff, 0x70fe, 0x71fe,
  0x70fd, 0x60fe, 0x55f4, 0x6af0, 0x8af1, 0x7af1, 0x69f0, 0x68f1,
  0x8af1, 0x8af1, 0x79f1, 0x79f0, 0x79f0, 0x79f1, 0x78f1, 0x79f0,
  0x78f1, 0x68f1, 0x68f1, 0x69f1, 0x68f0, 0x7af1, 0x8af0, 0x89f1,
  0x89f1, 0x79f1, 0x68f1, 0x69f1, 0x7af0, 0x79f1, 0x8af0, 0x8af1,
  0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe,
  0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe,
  0xeefe, 0xeefe, 0xeefe, 0xedfd, 0xedfd, 0xedfd, 0xedfe, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xdcfd, 0xdcfd, 0xdcfd, 0xdcfd, 0xdcfd,
  0xdcfd, 0xdcfd, 0xdcfd, 0xddfd, 0xddfd, 0xddfd, 0xedfe, 0xddfd,
  0xcbfc, 0xaafb, 0x88fa, 0x76fb, 0x76fb, 0x77f9, 0x88f8, 0x9af9,
  0xa4fe, 0xa0ff, 0xa1ff, 0x91ff, 0x81ff, 0x81ff, 0x80ff, 0x81ff,
  0x81ff, 0x81ff, 0x71ff, 0x81ff, 0x81ff, 0x80ff, 0x80ff, 0x80ff,
  0x80ff, 0x81ff, 0x81ff, 0x80ff, 0x80ff, 0x81ff, 0x80ff, 0x71ff,
  0x71ff, 0x71ff, 0x71ff, 0x71ff, 0x71ff, 0x71ff, 0x71fe, 0x70fe,
  0x60ff, 0x63f9, 0x69f0, 0x8af0, 0x7af1, 0x68f1, 0x78f1, 0x79f1,
  0x79f1, 0x79f1, 0x79f1, 0x68f1, 0x68f1, 0x69f1, 0x79f0, 0x79f1,
  0x78f1, 0x78f0, 0x68f1, 0x79f1, 0x68f1, 0x8af1, 0x8af0, 0x8af0,
  0x89f1, 0x79f1, 0x68f0, 0x69f0, 0x8af1, 0x7af0, 0x8af0, 0x8af1,
  0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe,
  0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe,
  0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xedfe, 0xedfd, 0xedfe, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xdcfd, 0xdcfd, 0xdcfd, 0xdcfd, 0xdcfd,
  0xdcfd, 0xdcfd, 0xddfd, 0xddfd, 0xddfd, 0xddfe, 0xeefe, 0xddfd,
  0xcbfd, 0xbafb, 0x77f9, 0x77fa, 0x88fb, 0x88f9, 0x77f8, 0x88f8,
  0xa5fd, 0xa2ff, 0xb0ff, 0x91ff, 0x80ff, 0x81ff, 0x80ff, 0x81ff,
  0x80ff, 0x71ff, 0x71ff, 0x71ff, 0x71ff, 0x80ff, 0x81ff, 0x81ff,
  0x81ff, 0x80ff, 0x81ff, 0x80ff, 0x80ff, 0x81ff, 0x81ff, 0x70ff,
  0x71ff, 0x71ff, 0x71ff, 0x70ff, 0x71ff, 0x71fe, 0x71fe, 0x70fe,
  0x60ff, 0x67f4, 0x7af0, 0x7af1, 0x69f0, 0x67f1, 0x67f1, 0x8af0,
  0x79f1, 0x78f0, 0x78f1, 0x68f1, 0x67f1, 0x68f0, 0x79f1, 0x79f1,
  0x89f1, 0x79f1, 0x79f0, 0x79f0, 0x68f1, 0x7af1, 0x8af1, 0x79f1,
  0x8af0, 0x8af1, 0x78f1, 0x69f1, 0x7af1, 0x7af1, 0x8bf1, 0x8af1,
  0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xfefe, 0xfefe,
  0xeefe, 0xfefe, 0xfefe, 0xeefe, 0xeefe, 0xfefe, 0xeefe, 0xeefe,
  0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xedfd, 0xddfd, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xddfd, 0xddfd, 0xdcfd, 0xdcfd, 0xccfd, 0xccfd, 0xccfd, 0xccfd,
  0xccfd, 0xccfd, 0xddfd, 0xddfd, 0xddfd, 0xedfe, 0xeefe, 0xdcfe,
  0xcbfd, 0xbbfc, 0x88fa, 0x88fb, 0x99fc, 0x87f9, 0x77f7, 0x88f9,
  0xabfb, 0xc7ff, 0xc1ff, 0x80ff, 0x80ff, 0x81ff, 0x81ff, 0x81ff,
  0x70ff, 0x71ff, 0x71ff, 0x71ff, 0x71ff, 0x81ff, 0x71ff, 0x71ff,
  0x71ff, 0x80ff, 0x81ff, 0x81ff, 0x81ff, 0x80ff, 0x71ff, 0x71ff,
  0x71ff, 0x71ff, 0x71ff, 0x71ff, 0x71fe, 0x71fe, 0x71fe, 0x60fe,
  0x72fc, 0x79f1, 0x7af0, 0x8bf0, 0x8af1, 0x57f1, 0x67f1, 0x8af0,
  0x79f1, 0x78f0, 0x78f1, 0x79f1, 0x68f1, 0x68f0, 0x79f0, 0x79f1,
  0x79f0, 0x79f1, 0x79f0, 0x79f0, 0x68f1, 0x79f1, 0x8af1, 0x8af1,
  0x8af1, 0x79f0, 0x79f1, 0x79f1, 0x79f1, 0x79f1, 0x8bf1, 0x8bf1,
  0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xfefe, 0xfefe,
  0xeefe, 0xfefe, 0xfefe, 0xfefe, 0xfefe, 0xfefe, 0xeefe, 0xeefe,
  0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xedfe, 0xddfd, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xddfd, 0xdcfd, 0xdcfd, 0xccfd, 0xccfd, 0xccfd, 0xccfd, 0xccfd,
  0xccfd, 0xccfd, 0xdcfd, 0xddfd, 0xddfe, 0xedfe, 0xeefe, 0xeefe,
  0xdcfd, 0x87fa, 0x88fa, 0xbbfc, 0xaafc, 0x88fa, 0x77f7, 0x77f7,
  0x88f8, 0xb6fe, 0xc2ff, 0x80ff, 0x80ff, 0x81ff, 0x71ff, 0x71ff,
  0x71ff, 0x71ff, 0x71ff, 0x71ff, 0x71ff, 0x71ff, 0x71ff, 0x71ff,
  0x71ff, 0x70ff, 0x81ff, 0x81ff, 0x81ff, 0x81ff, 0x71ff, 0x71ff,
  0x71ff, 0x70fe, 0x71fe, 0x71fe, 0x71fe, 0x71fe, 0x60fe, 0x60ff,
  0x75f8, 0x7af0, 0x8af0, 0x9bf1, 0x79f1, 0x47f1, 0x69f1, 0x8af1,
  0x89f1, 0x89f1, 0x79f1, 0x79f0, 0x79f0, 0x79f1, 0x79f1, 0x68f1,
  0x68f1, 0x69f0, 0x79f1, 0x79f0, 0x68f1, 0x68f0, 0x79f1, 0x8af1,
  0x8af0, 0x79f1, 0x69f1, 0x8af1, 0x8af1, 0x68f0, 0x68f0, 0x9bf1,
  0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe,
  0xeefe, 0xfefe, 0xfefe, 0xfefe, 0xfefe, 0xeefe, 0xeefe, 0xeefe,
  0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xedfe, 0xedfd, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd,
  0xccfd, 0xccfd, 0xccfd, 0xccfd, 0xccfd, 0xccfd, 0xccfd, 0xccfd,
  0xccfd, 0xccfd, 0xdcfd, 0xdcfe, 0xddfe, 0xedfe, 0xeefe, 0xedfe,
  0xcbfd, 0x88f9, 0xabfb, 0xbbfd, 0xa9fc, 0x98fa, 0x77f7, 0x56f6,
  0x65f6, 0x96fb, 0xb2ff, 0x90ff, 0x80ff, 0x80ff, 0x71ff, 0x71ff,
  0x71ff, 0x60ff, 0x61ff, 0x71ff, 0x71ff, 0x71ff, 0x70ff, 0x71ff,
  0x70ff, 0x71ff, 0x81ff, 0x80ff, 0x81ff, 0x71ff, 0x71ff, 0x71ff,
  0x81ff, 0x70fe, 0x70fe, 0x71fe, 0x71fe, 0x61fe, 0x60fe, 0x60ff,
  0x66f5, 0x7af0, 0x8af1, 0x7af1, 0x68f1, 0x68f1, 0x69f1, 0x7af1,
  0x89f1, 0x89f1, 0x79f0, 0x79f0, 0x7af0, 0x7af0, 0x68f1, 0x57f1,
  0x46f1, 0x68f1, 0x7af0, 0x79f1, 0x78f1, 0x78f1, 0x79f0, 0x7af0,
  0x7af0, 0x79f1, 0x79f1, 0x7af0, 0x8af0, 0x79f1, 0x68f1, 0x8af1,
  0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe,
  0xeefe, 0xfefe, 0xfefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe,
  0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xedfe, 0xedfd, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xdcfd,
  0xccfd, 0xccfd, 0xccfd, 0xccfd, 0xccfd, 0xccfd, 0xccfd, 0xccfd,
  0xccfd, 0xccfd, 0xdcfd, 0xddfe, 0xddfe, 0xeefe, 0xeefe, 0xcafd,
  0x84fa, 0x76f8, 0xbbfc, 0xbbfd, 0x99fc, 0x88fa, 0x77f7, 0x77f7,
  0x78f7, 0xa9fb, 0xb3ff, 0x90ff, 0x80ff, 0x80ff, 0x71ff, 0x71ff,
  0x71ff, 0x61ff, 0x60ff, 0x71ff, 0x71ff, 0x71ff, 0x71ff, 0x71ff,
  0x71ff, 0x71ff, 0x71ff, 0x70ff, 0x81ff, 0x71ff, 0x71ff, 0x71ff,
  0x71fe, 0x71fe, 0x71fe, 0x71fe, 0x71fe, 0x60fe, 0x60fe, 0x60fe,
  0x66f4, 0x69f0, 0x79f1, 0x69f0, 0x69f1, 0x69f1, 0x79f1, 0x79f1,
  0x79f1, 0x7af1, 0x8af0, 0x8bf1, 0x8af1, 0x68f0, 0x57f1, 0x57f1,
  0x57f1, 0x68f1, 0x8af1, 0x79f0, 0x79f0, 0x79f1, 0x79f1, 0x79f1,
  0x79f1, 0x79f1, 0x79f0, 0x79f1, 0x8af1, 0x79f0, 0x79f1, 0x79f1,
  0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe,
  0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe,
  0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xedfe, 0xedfd, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xdcfd,
  0xccfd, 0xccfd, 0xccfd, 0xcbfd, 0xcbfd, 0xcbfd, 0xcbfd, 0xcbfd,
  0xccfd, 0xccfd, 0xdcfe, 0xddfe, 0xddfe, 0xeefe, 0xeefe, 0xb8fd,
  0x51f8, 0x43f5, 0x99fa, 0xbbfd, 0xa9fc, 0x99fa, 0x77f7, 0x65f6,
  0x77f7, 0x98fa, 0xb3ff, 0x90ff, 0x81ff, 0x81ff, 0x70ff, 0x71ff,
  0x61ff, 0x71ff, 0x60fe, 0x71ff, 0x71ff, 0x71ff, 0x71ff, 0x70ff,
  0x71ff, 0x71ff, 0x71ff, 0x71ff, 0x71ff, 0x71ff, 0x70ff, 0x71ff,
  0x70ff, 0x71fe, 0x70fe, 0x71fe, 0x70fe, 0x60fe, 0x60fe, 0x60fe,
  0x78f3, 0x69f0, 0x79f0, 0x7af1, 0x7af0, 0x7af0, 0x79f0, 0x68f0,
  0x78f1, 0x7af1, 0x8af1, 0x8af1, 0x79f1, 0x58f1, 0x58f1, 0x58f0,
  0x68f0, 0x79f0, 0x8af1, 0x8af0, 0x79f0, 0x79f0, 0x79f1, 0x79f1,
  0x78f1, 0x68f1, 0x68f1, 0x79f1, 0x8af1, 0x7af1, 0x79f1, 0x79f1,
  0xfefe, 0xfefe, 0xfefe, 0xfefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe,
  0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe,
  0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xeefe, 0xedfe, 0xddfd,
  0xddfd, 0xddfd, 0xddfd, 0xddfd, 0xddfe, 0xddfd, 0xddfd, 0xdcfd,
  0xccfd, 0xccfd, 0xccfd, 0xcbfd, 0xcbfd, 0xcbfd, 0xcbfd, 0xcbfd,
  0xccfd, 0xdcfd, 0xdcfe, 0xddfe, 0xedfe, 0xeefe, 0xddfe, 0xa6fd,
  0x51f7, 0x22f4, 0x77f9, 0xbbfd, 0xaafd, 0xaafb, 0x88f8, 0x66f6,
  0x66f7, 0x89f8, 0xb5ff, 0x91ff, 0x81ff, 0x81ff, 0x71ff, 0x71ff,
  0x71ff, 0x71ff, 0x71ff, 0x71ff, 0x81ff, 0x71ff, 0x81ff, 0x81ff,
  0x81ff, 0x81ff, 0x81ff, 0x71ff, 0x81ff, 0x81ff, 0x81ff, 0x81ff,
  0x81ff, 0x81fe, 0x71fe, 0x71fe, 0x71fe, 0x71fe, 0x61fe, 0x72fd,
  0x78f3, 0x7af1, 0x8af1, 0x8bf1, 0x8bf1, 0x8af1, 0x7af1, 0x79f1,
  0x78f1, 0x79f1, 0x79f1, 0x79f1, 0x79f1, 0x79f1, 0x79f1, 0x79f1,
  0x79f1, 0x79f1, 0x8af1, 0x8af1, 0x8af1, 0x8af1, 0x8af1, 0x79f1,
  0x79f1, 0x79f1, 0x79f1, 0x7af1, 0x8bf1, 0x8af1, 0x8af1, 0x8af2,
};